/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 26 "src/p.y" /* yacc.c:339  */


/*
 * DESCRIPTION
 *   Simple context-free grammar for parsing the control file.
 *
 */

#include "config.h"

#ifdef HAVE_STDIO_H
#include <stdio.h>
#endif

#ifdef HAVE_STDLIB_H
#include <stdlib.h>
#endif

#ifdef HAVE_ERRNO_H
#include <errno.h>
#endif

#ifdef HAVE_CTYPE_H
#include <ctype.h>
#endif

#ifdef HAVE_PWD_H
#include <pwd.h>
#endif

#ifdef HAVE_GRP_H
#include <grp.h>
#endif

#ifdef HAVE_SYS_TYPES_H
#include <sys/types.h>
#endif

#ifdef HAVE_SYS_TIME_H
#include <sys/time.h>
#endif

#ifdef HAVE_TIME_H
#include <time.h>
#endif

#ifdef HAVE_SYS_SOCKET_H
#include <sys/socket.h>
#endif

#ifdef HAVE_ASM_PARAM_H
#include <asm/param.h>
#endif

#ifdef HAVE_STRING_H
#include <string.h>
#endif

#ifdef HAVE_STRINGS_H
#include <strings.h>
#endif

#ifdef HAVE_NETDB_H
#include <netdb.h>
#endif

#ifdef HAVE_SYSLOG_H
#include <syslog.h>
#endif

#ifdef HAVE_NETINET_IN_SYSTM_H
#include <netinet/in_systm.h>
#endif

#ifdef HAVE_NETINET_IN_H
#include <netinet/in.h>
#endif

#ifdef HAVE_NETINET_IP_H
#include <netinet/ip.h>
#endif

#ifdef HAVE_NETINET_IP_ICMP_H
#include <netinet/ip_icmp.h>
#endif

#ifdef HAVE_REGEX_H
#include <regex.h>
#endif

#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif

#include "net.h"
#include "monit.h"
#include "protocol.h"
#include "engine.h"
#include "alert.h"
#include "ProcessTree.h"
#include "device.h"
#include "processor.h"

// libmonit
#include "io/File.h"
#include "util/Str.h"
#include "thread/Thread.h"


/* ------------------------------------------------------------- Definitions */


struct precedence_t {
        boolean_t daemon;
        boolean_t logfile;
        boolean_t pidfile;
};

struct rate_t {
        unsigned count;
        unsigned cycles;
};

/* yacc interface */
void  yyerror(const char *,...);
void  yyerror2(const char *,...);
void  yywarning(const char *,...);
void  yywarning2(const char *,...);

/* lexer interface */
int yylex(void);
extern FILE *yyin;
extern int lineno;
extern int arglineno;
extern char *yytext;
extern char *argyytext;
extern char *currentfile;
extern char *argcurrentfile;
extern int buffer_stack_ptr;

/* Local variables */
static int cfg_errflag = 0;
static Service_T tail = NULL;
static Service_T current = NULL;
static Request_T urlrequest = NULL;
static command_t command = NULL;
static command_t command1 = NULL;
static command_t command2 = NULL;
static Service_T depend_list = NULL;
static struct Uid_T uidset = {};
static struct Gid_T gidset = {};
static struct Pid_T pidset = {};
static struct Pid_T ppidset = {};
static struct FsFlag_T fsflagset = {};
static struct NonExist_T nonexistset = {};
static struct Exist_T existset = {};
static struct Status_T statusset = {};
static struct Perm_T permset = {};
static struct Size_T sizeset = {};
static struct Uptime_T uptimeset = {};
static struct LinkStatus_T linkstatusset = {};
static struct LinkSpeed_T linkspeedset = {};
static struct LinkSaturation_T linksaturationset = {};
static struct Bandwidth_T bandwidthset = {};
static struct Match_T matchset = {};
static struct Icmp_T icmpset = {};
static struct Mail_T mailset = {};
static struct SslOptions_T sslset = {};
static struct Port_T portset = {};
static struct MailServer_T mailserverset = {};
static struct Mmonit_T mmonitset = {};
static struct FileSystem_T filesystemset = {};
static struct Resource_T resourceset = {};
static struct Checksum_T checksumset = {};
static struct Timestamp_T timestampset = {};
static struct ActionRate_T actionrateset = {};
static struct precedence_t ihp = {false, false, false};
static struct rate_t rate = {1, 1};
static struct rate_t rate1 = {1, 1};
static struct rate_t rate2 = {1, 1};
static char * htpasswd_file = NULL;
static unsigned repeat = 0;
static unsigned repeat1 = 0;
static unsigned repeat2 = 0;
static Digest_Type digesttype = Digest_Cleartext;

#define BITMAP_MAX (sizeof(long long) * 8)


/* -------------------------------------------------------------- Prototypes */

static void  preparse();
static void  postparse();
static boolean_t _parseOutgoingAddress(const char *ip, Outgoing_T *outgoing);
static void  addmail(char *, Mail_T, Mail_T *);
static Service_T createservice(Service_Type, char *, char *, State_Type (*)(Service_T));
static void  addservice(Service_T);
static void  adddependant(char *);
static void  addservicegroup(char *);
static void  addport(Port_T *, Port_T);
static void  addhttpheader(Port_T, const char *);
static void  addresource(Resource_T);
static void  addtimestamp(Timestamp_T);
static void  addactionrate(ActionRate_T);
static void  addsize(Size_T);
static void  adduptime(Uptime_T);
static void  addpid(Pid_T);
static void  addppid(Pid_T);
static void  addfsflag(FsFlag_T);
static void  addnonexist(NonExist_T);
static void  addexist(Exist_T);
static void  addlinkstatus(Service_T, LinkStatus_T);
static void  addlinkspeed(Service_T, LinkSpeed_T);
static void  addlinksaturation(Service_T, LinkSaturation_T);
static void  addbandwidth(Bandwidth_T *, Bandwidth_T);
static void  addfilesystem(FileSystem_T);
static void  addicmp(Icmp_T);
static void  addgeneric(Port_T, char*, char*);
static void  addcommand(int, unsigned);
static void  addargument(char *);
static void  addmmonit(Mmonit_T);
static void  addmailserver(MailServer_T);
static boolean_t addcredentials(char *, char *, Digest_Type, boolean_t);
#ifdef HAVE_LIBPAM
static void  addpamauth(char *, int);
#endif
static void  addhtpasswdentry(char *, char *, Digest_Type);
static uid_t get_uid(char *, uid_t);
static gid_t get_gid(char *, gid_t);
static void  addchecksum(Checksum_T);
static void  addperm(Perm_T);
static void  addmatch(Match_T, int, int);
static void  addmatchpath(Match_T, Action_Type);
static void  addstatus(Status_T);
static Uid_T adduid(Uid_T);
static Gid_T addgid(Gid_T);
static void  addeuid(uid_t);
static void  addegid(gid_t);
static void  addeventaction(EventAction_T *, Action_Type, Action_Type);
static void  prepare_urlrequest(URL_T U);
static void  seturlrequest(int, char *);
static void  setlogfile(char *);
static void  setpidfile(char *);
static void  reset_sslset();
static void  reset_mailset();
static void  reset_mailserverset();
static void  reset_mmonitset();
static void  reset_portset();
static void  reset_resourceset();
static void  reset_timestampset();
static void  reset_actionrateset();
static void  reset_sizeset();
static void  reset_uptimeset();
static void  reset_pidset();
static void  reset_ppidset();
static void  reset_fsflagset();
static void  reset_nonexistset();
static void  reset_existset();
static void  reset_linkstatusset();
static void  reset_linkspeedset();
static void  reset_linksaturationset();
static void  reset_bandwidthset();
static void  reset_checksumset();
static void  reset_permset();
static void  reset_uidset();
static void  reset_gidset();
static void  reset_statusset();
static void  reset_filesystemset();
static void  reset_icmpset();
static void  reset_rateset(struct rate_t *);
static void  check_name(char *);
static int   check_perm(int);
static void  check_exec(char *);
static int   cleanup_hash_string(char *);
static void  check_depend();
static void  setsyslog(char *);
static command_t copycommand(command_t);
static int verifyMaxForward(int);
static void _setPEM(char **store, char *path, const char *description, boolean_t isFile);
static void _setSSLOptions(SslOptions_T options);


#line 349 "src/y.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_YY_SRC_Y_TAB_H_INCLUDED
# define YY_YY_SRC_Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    IF = 258,
    ELSE = 259,
    THEN = 260,
    FAILED = 261,
    SET = 262,
    LOGFILE = 263,
    FACILITY = 264,
    DAEMON = 265,
    SYSLOG = 266,
    MAILSERVER = 267,
    HTTPD = 268,
    ALLOW = 269,
    REJECTOPT = 270,
    ADDRESS = 271,
    INIT = 272,
    TERMINAL = 273,
    BATCH = 274,
    READONLY = 275,
    CLEARTEXT = 276,
    MD5HASH = 277,
    SHA1HASH = 278,
    CRYPT = 279,
    DELAY = 280,
    PEMFILE = 281,
    ENABLE = 282,
    DISABLE = 283,
    SSL = 284,
    CIPHER = 285,
    CLIENTPEMFILE = 286,
    ALLOWSELFCERTIFICATION = 287,
    SELFSIGNED = 288,
    VERIFY = 289,
    CERTIFICATE = 290,
    CACERTIFICATEFILE = 291,
    CACERTIFICATEPATH = 292,
    VALID = 293,
    INTERFACE = 294,
    LINK = 295,
    PACKET = 296,
    BYTEIN = 297,
    BYTEOUT = 298,
    PACKETIN = 299,
    PACKETOUT = 300,
    SPEED = 301,
    SATURATION = 302,
    UPLOAD = 303,
    DOWNLOAD = 304,
    TOTAL = 305,
    IDFILE = 306,
    STATEFILE = 307,
    SEND = 308,
    EXPECT = 309,
    CYCLE = 310,
    COUNT = 311,
    REMINDER = 312,
    REPEAT = 313,
    LIMITS = 314,
    SENDEXPECTBUFFER = 315,
    EXPECTBUFFER = 316,
    FILECONTENTBUFFER = 317,
    HTTPCONTENTBUFFER = 318,
    PROGRAMOUTPUT = 319,
    NETWORKTIMEOUT = 320,
    PROGRAMTIMEOUT = 321,
    STARTTIMEOUT = 322,
    STOPTIMEOUT = 323,
    RESTARTTIMEOUT = 324,
    PIDFILE = 325,
    START = 326,
    STOP = 327,
    PATHTOK = 328,
    HOST = 329,
    HOSTNAME = 330,
    PORT = 331,
    IPV4 = 332,
    IPV6 = 333,
    TYPE = 334,
    UDP = 335,
    TCP = 336,
    TCPSSL = 337,
    PROTOCOL = 338,
    CONNECTION = 339,
    ALERT = 340,
    NOALERT = 341,
    MAILFORMAT = 342,
    UNIXSOCKET = 343,
    SIGNATURE = 344,
    TIMEOUT = 345,
    RETRY = 346,
    RESTART = 347,
    CHECKSUM = 348,
    EVERY = 349,
    NOTEVERY = 350,
    DEFAULT = 351,
    HTTP = 352,
    HTTPS = 353,
    APACHESTATUS = 354,
    FTP = 355,
    SMTP = 356,
    SMTPS = 357,
    POP = 358,
    POPS = 359,
    IMAP = 360,
    IMAPS = 361,
    CLAMAV = 362,
    NNTP = 363,
    NTP3 = 364,
    MYSQL = 365,
    DNS = 366,
    WEBSOCKET = 367,
    SSH = 368,
    DWP = 369,
    LDAP2 = 370,
    LDAP3 = 371,
    RDATE = 372,
    RSYNC = 373,
    TNS = 374,
    PGSQL = 375,
    POSTFIXPOLICY = 376,
    SIP = 377,
    LMTP = 378,
    GPS = 379,
    RADIUS = 380,
    MEMCACHE = 381,
    REDIS = 382,
    MONGODB = 383,
    SIEVE = 384,
    SPAMASSASSIN = 385,
    FAIL2BAN = 386,
    STRING = 387,
    PATH = 388,
    MAILADDR = 389,
    MAILFROM = 390,
    MAILREPLYTO = 391,
    MAILSUBJECT = 392,
    MAILBODY = 393,
    SERVICENAME = 394,
    STRINGNAME = 395,
    NUMBER = 396,
    PERCENT = 397,
    LOGLIMIT = 398,
    CLOSELIMIT = 399,
    DNSLIMIT = 400,
    KEEPALIVELIMIT = 401,
    REPLYLIMIT = 402,
    REQUESTLIMIT = 403,
    STARTLIMIT = 404,
    WAITLIMIT = 405,
    GRACEFULLIMIT = 406,
    CLEANUPLIMIT = 407,
    REAL = 408,
    CHECKPROC = 409,
    CHECKFILESYS = 410,
    CHECKFILE = 411,
    CHECKDIR = 412,
    CHECKHOST = 413,
    CHECKSYSTEM = 414,
    CHECKFIFO = 415,
    CHECKPROGRAM = 416,
    CHECKNET = 417,
    THREADS = 418,
    CHILDREN = 419,
    METHOD = 420,
    GET = 421,
    HEAD = 422,
    STATUS = 423,
    ORIGIN = 424,
    VERSIONOPT = 425,
    READ = 426,
    WRITE = 427,
    OPERATION = 428,
    SERVICETIME = 429,
    DISK = 430,
    RESOURCE = 431,
    MEMORY = 432,
    TOTALMEMORY = 433,
    LOADAVG1 = 434,
    LOADAVG5 = 435,
    LOADAVG15 = 436,
    SWAP = 437,
    MODE = 438,
    ACTIVE = 439,
    PASSIVE = 440,
    MANUAL = 441,
    ONREBOOT = 442,
    NOSTART = 443,
    LASTSTATE = 444,
    CPU = 445,
    TOTALCPU = 446,
    CPUUSER = 447,
    CPUSYSTEM = 448,
    CPUWAIT = 449,
    GROUP = 450,
    REQUEST = 451,
    DEPENDS = 452,
    BASEDIR = 453,
    SLOT = 454,
    EVENTQUEUE = 455,
    SECRET = 456,
    HOSTHEADER = 457,
    UID = 458,
    EUID = 459,
    GID = 460,
    MMONIT = 461,
    INSTANCE = 462,
    USERNAME = 463,
    PASSWORD = 464,
    TIME = 465,
    ATIME = 466,
    CTIME = 467,
    MTIME = 468,
    CHANGED = 469,
    MILLISECOND = 470,
    SECOND = 471,
    MINUTE = 472,
    HOUR = 473,
    DAY = 474,
    MONTH = 475,
    SSLAUTO = 476,
    SSLV2 = 477,
    SSLV3 = 478,
    TLSV1 = 479,
    TLSV11 = 480,
    TLSV12 = 481,
    TLSV13 = 482,
    CERTMD5 = 483,
    AUTO = 484,
    BYTE = 485,
    KILOBYTE = 486,
    MEGABYTE = 487,
    GIGABYTE = 488,
    INODE = 489,
    SPACE = 490,
    TFREE = 491,
    PERMISSION = 492,
    SIZE = 493,
    MATCH = 494,
    NOT = 495,
    IGNORE = 496,
    ACTION = 497,
    UPTIME = 498,
    EXEC = 499,
    UNMONITOR = 500,
    PING = 501,
    PING4 = 502,
    PING6 = 503,
    ICMP = 504,
    ICMPECHO = 505,
    NONEXIST = 506,
    EXIST = 507,
    INVALID = 508,
    DATA = 509,
    RECOVERED = 510,
    PASSED = 511,
    SUCCEEDED = 512,
    URL = 513,
    CONTENT = 514,
    PID = 515,
    PPID = 516,
    FSFLAG = 517,
    REGISTER = 518,
    CREDENTIALS = 519,
    URLOBJECT = 520,
    ADDRESSOBJECT = 521,
    TARGET = 522,
    TIMESPEC = 523,
    HTTPHEADER = 524,
    MAXFORWARD = 525,
    FIPS = 526,
    GREATER = 527,
    GREATEROREQUAL = 528,
    LESS = 529,
    LESSOREQUAL = 530,
    EQUAL = 531,
    NOTEQUAL = 532
  };
#endif
/* Tokens.  */
#define IF 258
#define ELSE 259
#define THEN 260
#define FAILED 261
#define SET 262
#define LOGFILE 263
#define FACILITY 264
#define DAEMON 265
#define SYSLOG 266
#define MAILSERVER 267
#define HTTPD 268
#define ALLOW 269
#define REJECTOPT 270
#define ADDRESS 271
#define INIT 272
#define TERMINAL 273
#define BATCH 274
#define READONLY 275
#define CLEARTEXT 276
#define MD5HASH 277
#define SHA1HASH 278
#define CRYPT 279
#define DELAY 280
#define PEMFILE 281
#define ENABLE 282
#define DISABLE 283
#define SSL 284
#define CIPHER 285
#define CLIENTPEMFILE 286
#define ALLOWSELFCERTIFICATION 287
#define SELFSIGNED 288
#define VERIFY 289
#define CERTIFICATE 290
#define CACERTIFICATEFILE 291
#define CACERTIFICATEPATH 292
#define VALID 293
#define INTERFACE 294
#define LINK 295
#define PACKET 296
#define BYTEIN 297
#define BYTEOUT 298
#define PACKETIN 299
#define PACKETOUT 300
#define SPEED 301
#define SATURATION 302
#define UPLOAD 303
#define DOWNLOAD 304
#define TOTAL 305
#define IDFILE 306
#define STATEFILE 307
#define SEND 308
#define EXPECT 309
#define CYCLE 310
#define COUNT 311
#define REMINDER 312
#define REPEAT 313
#define LIMITS 314
#define SENDEXPECTBUFFER 315
#define EXPECTBUFFER 316
#define FILECONTENTBUFFER 317
#define HTTPCONTENTBUFFER 318
#define PROGRAMOUTPUT 319
#define NETWORKTIMEOUT 320
#define PROGRAMTIMEOUT 321
#define STARTTIMEOUT 322
#define STOPTIMEOUT 323
#define RESTARTTIMEOUT 324
#define PIDFILE 325
#define START 326
#define STOP 327
#define PATHTOK 328
#define HOST 329
#define HOSTNAME 330
#define PORT 331
#define IPV4 332
#define IPV6 333
#define TYPE 334
#define UDP 335
#define TCP 336
#define TCPSSL 337
#define PROTOCOL 338
#define CONNECTION 339
#define ALERT 340
#define NOALERT 341
#define MAILFORMAT 342
#define UNIXSOCKET 343
#define SIGNATURE 344
#define TIMEOUT 345
#define RETRY 346
#define RESTART 347
#define CHECKSUM 348
#define EVERY 349
#define NOTEVERY 350
#define DEFAULT 351
#define HTTP 352
#define HTTPS 353
#define APACHESTATUS 354
#define FTP 355
#define SMTP 356
#define SMTPS 357
#define POP 358
#define POPS 359
#define IMAP 360
#define IMAPS 361
#define CLAMAV 362
#define NNTP 363
#define NTP3 364
#define MYSQL 365
#define DNS 366
#define WEBSOCKET 367
#define SSH 368
#define DWP 369
#define LDAP2 370
#define LDAP3 371
#define RDATE 372
#define RSYNC 373
#define TNS 374
#define PGSQL 375
#define POSTFIXPOLICY 376
#define SIP 377
#define LMTP 378
#define GPS 379
#define RADIUS 380
#define MEMCACHE 381
#define REDIS 382
#define MONGODB 383
#define SIEVE 384
#define SPAMASSASSIN 385
#define FAIL2BAN 386
#define STRING 387
#define PATH 388
#define MAILADDR 389
#define MAILFROM 390
#define MAILREPLYTO 391
#define MAILSUBJECT 392
#define MAILBODY 393
#define SERVICENAME 394
#define STRINGNAME 395
#define NUMBER 396
#define PERCENT 397
#define LOGLIMIT 398
#define CLOSELIMIT 399
#define DNSLIMIT 400
#define KEEPALIVELIMIT 401
#define REPLYLIMIT 402
#define REQUESTLIMIT 403
#define STARTLIMIT 404
#define WAITLIMIT 405
#define GRACEFULLIMIT 406
#define CLEANUPLIMIT 407
#define REAL 408
#define CHECKPROC 409
#define CHECKFILESYS 410
#define CHECKFILE 411
#define CHECKDIR 412
#define CHECKHOST 413
#define CHECKSYSTEM 414
#define CHECKFIFO 415
#define CHECKPROGRAM 416
#define CHECKNET 417
#define THREADS 418
#define CHILDREN 419
#define METHOD 420
#define GET 421
#define HEAD 422
#define STATUS 423
#define ORIGIN 424
#define VERSIONOPT 425
#define READ 426
#define WRITE 427
#define OPERATION 428
#define SERVICETIME 429
#define DISK 430
#define RESOURCE 431
#define MEMORY 432
#define TOTALMEMORY 433
#define LOADAVG1 434
#define LOADAVG5 435
#define LOADAVG15 436
#define SWAP 437
#define MODE 438
#define ACTIVE 439
#define PASSIVE 440
#define MANUAL 441
#define ONREBOOT 442
#define NOSTART 443
#define LASTSTATE 444
#define CPU 445
#define TOTALCPU 446
#define CPUUSER 447
#define CPUSYSTEM 448
#define CPUWAIT 449
#define GROUP 450
#define REQUEST 451
#define DEPENDS 452
#define BASEDIR 453
#define SLOT 454
#define EVENTQUEUE 455
#define SECRET 456
#define HOSTHEADER 457
#define UID 458
#define EUID 459
#define GID 460
#define MMONIT 461
#define INSTANCE 462
#define USERNAME 463
#define PASSWORD 464
#define TIME 465
#define ATIME 466
#define CTIME 467
#define MTIME 468
#define CHANGED 469
#define MILLISECOND 470
#define SECOND 471
#define MINUTE 472
#define HOUR 473
#define DAY 474
#define MONTH 475
#define SSLAUTO 476
#define SSLV2 477
#define SSLV3 478
#define TLSV1 479
#define TLSV11 480
#define TLSV12 481
#define TLSV13 482
#define CERTMD5 483
#define AUTO 484
#define BYTE 485
#define KILOBYTE 486
#define MEGABYTE 487
#define GIGABYTE 488
#define INODE 489
#define SPACE 490
#define TFREE 491
#define PERMISSION 492
#define SIZE 493
#define MATCH 494
#define NOT 495
#define IGNORE 496
#define ACTION 497
#define UPTIME 498
#define EXEC 499
#define UNMONITOR 500
#define PING 501
#define PING4 502
#define PING6 503
#define ICMP 504
#define ICMPECHO 505
#define NONEXIST 506
#define EXIST 507
#define INVALID 508
#define DATA 509
#define RECOVERED 510
#define PASSED 511
#define SUCCEEDED 512
#define URL 513
#define CONTENT 514
#define PID 515
#define PPID 516
#define FSFLAG 517
#define REGISTER 518
#define CREDENTIALS 519
#define URLOBJECT 520
#define ADDRESSOBJECT 521
#define TARGET 522
#define TIMESPEC 523
#define HTTPHEADER 524
#define MAXFORWARD 525
#define FIPS 526
#define GREATER 527
#define GREATEROREQUAL 528
#define LESS 529
#define LESSOREQUAL 530
#define EQUAL 531
#define NOTEQUAL 532

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 309 "src/p.y" /* yacc.c:355  */

        URL_T url;
        Address_T address;
        float real;
        int   number;
        char *string;

#line 951 "src/y.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_SRC_Y_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 968 "src/y.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  69
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1682

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  284
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  237
/* YYNRULES -- Number of rules.  */
#define YYNRULES  773
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1440

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   532

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   280,     2,
       2,     2,     2,     2,   281,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   282,     2,   283,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   278,     2,   279,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   359,   359,   360,   363,   364,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   396,   397,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   423,   424,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   447,   448,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   473,   474,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   494,   495,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     513,   514,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   534,   535,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   552,   553,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   573,   574,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   590,   594,   597,   603,   613,   618,   621,   626,   631,
     634,   637,   642,   648,   651,   652,   655,   658,   661,   664,
     667,   670,   673,   676,   679,   682,   685,   688,   691,   694,
     699,   704,   712,   715,   720,   723,   727,   733,   738,   743,
     751,   754,   755,   758,   764,   765,   768,   771,   772,   773,
     774,   777,   778,   783,   788,   791,   794,   795,   798,   802,
     806,   810,   814,   817,   821,   824,   827,   830,   835,   841,
     842,   845,   859,   866,   875,   876,   879,   883,   887,   891,
     899,   907,   916,   920,   926,   935,   942,   957,   958,   961,
     970,   981,   982,   985,   988,   991,   992,   993,   994,   997,
    1014,  1015,  1018,  1019,  1020,  1021,  1022,  1023,  1024,  1025,
    1026,  1030,  1036,  1042,  1048,  1054,  1060,  1061,  1064,  1069,
    1074,  1078,  1082,  1088,  1089,  1092,  1093,  1096,  1099,  1104,
    1109,  1112,  1120,  1124,  1128,  1132,  1136,  1136,  1143,  1143,
    1150,  1150,  1157,  1157,  1164,  1171,  1172,  1175,  1181,  1184,
    1189,  1192,  1195,  1202,  1211,  1216,  1219,  1224,  1229,  1234,
    1242,  1248,  1263,  1268,  1276,  1286,  1289,  1294,  1297,  1303,
    1306,  1311,  1312,  1315,  1316,  1319,  1322,  1327,  1331,  1335,
    1338,  1343,  1346,  1351,  1356,  1359,  1364,  1373,  1374,  1377,
    1378,  1379,  1380,  1381,  1382,  1383,  1384,  1385,  1386,  1387,
    1390,  1397,  1398,  1401,  1402,  1403,  1404,  1405,  1406,  1409,
    1415,  1416,  1419,  1420,  1421,  1422,  1423,  1426,  1432,  1437,
    1442,  1449,  1450,  1453,  1454,  1455,  1456,  1459,  1462,  1467,
    1472,  1478,  1481,  1486,  1489,  1493,  1498,  1499,  1502,  1503,
    1506,  1511,  1514,  1517,  1520,  1523,  1526,  1529,  1532,  1537,
    1540,  1545,  1548,  1551,  1554,  1557,  1560,  1563,  1566,  1570,
    1573,  1576,  1581,  1584,  1587,  1592,  1595,  1598,  1601,  1604,
    1607,  1610,  1613,  1616,  1619,  1622,  1625,  1630,  1638,  1648,
    1649,  1652,  1655,  1658,  1661,  1666,  1667,  1670,  1673,  1678,
    1679,  1682,  1690,  1695,  1698,  1703,  1708,  1709,  1712,  1715,
    1720,  1721,  1724,  1727,  1730,  1731,  1732,  1733,  1734,  1735,
    1738,  1748,  1751,  1756,  1760,  1766,  1771,  1777,  1778,  1783,
    1788,  1789,  1792,  1797,  1798,  1801,  1804,  1807,  1810,  1814,
    1818,  1822,  1826,  1830,  1834,  1838,  1842,  1846,  1852,  1856,
    1863,  1869,  1875,  1882,  1887,  1892,  1897,  1902,  1905,  1910,
    1913,  1918,  1921,  1926,  1929,  1934,  1937,  1942,  1947,  1952,
    1958,  1966,  1972,  1973,  1976,  1980,  1983,  1987,  1992,  1995,
    1998,  1999,  2002,  2003,  2004,  2005,  2006,  2007,  2008,  2009,
    2010,  2011,  2012,  2013,  2014,  2015,  2016,  2017,  2018,  2019,
    2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,  2028,  2029,
    2030,  2031,  2034,  2035,  2038,  2039,  2042,  2043,  2044,  2045,
    2048,  2052,  2056,  2062,  2065,  2068,  2074,  2077,  2081,  2086,
    2093,  2096,  2097,  2100,  2103,  2110,  2119,  2125,  2126,  2129,
    2130,  2131,  2132,  2133,  2134,  2135,  2138,  2144,  2145,  2148,
    2149,  2150,  2151,  2154,  2159,  2166,  2173,  2174,  2175,  2176,
    2179,  2184,  2191,  2196,  2201,  2206,  2213,  2218,  2225,  2232,
    2239,  2246,  2247,  2248,  2251,  2256,  2263,  2268,  2275,  2276,
    2279,  2280,  2281,  2282,  2285,  2292,  2300,  2301,  2302,  2303,
    2304,  2305,  2306,  2307,  2310,  2311,  2312,  2313,  2314,  2315,
    2318,  2319,  2320,  2322,  2323,  2325,  2328,  2331,  2339,  2342,
    2345,  2349,  2352,  2355,  2358,  2363,  2374,  2385,  2395,  2407,
    2408,  2413,  2420,  2421,  2426,  2433,  2436,  2439,  2442,  2447,
    2451,  2458,  2464,  2465,  2466,  2469,  2476,  2483,  2490,  2499,
    2508,  2515,  2524,  2533,  2540,  2549,  2556,  2565,  2572,  2581,
    2587,  2588,  2589,  2590,  2591,  2594,  2599,  2606,  2614,  2621,
    2629,  2637,  2644,  2650,  2657,  2665,  2668,  2674,  2680,  2687,
    2693,  2700,  2706,  2713,  2719,  2726,  2732,  2737,  2745,  2753,
    2761,  2769,  2777,  2785,  2795,  2803,  2811,  2819,  2827,  2835,
    2845,  2848,  2849,  2850
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IF", "ELSE", "THEN", "FAILED", "SET",
  "LOGFILE", "FACILITY", "DAEMON", "SYSLOG", "MAILSERVER", "HTTPD",
  "ALLOW", "REJECTOPT", "ADDRESS", "INIT", "TERMINAL", "BATCH", "READONLY",
  "CLEARTEXT", "MD5HASH", "SHA1HASH", "CRYPT", "DELAY", "PEMFILE",
  "ENABLE", "DISABLE", "SSL", "CIPHER", "CLIENTPEMFILE",
  "ALLOWSELFCERTIFICATION", "SELFSIGNED", "VERIFY", "CERTIFICATE",
  "CACERTIFICATEFILE", "CACERTIFICATEPATH", "VALID", "INTERFACE", "LINK",
  "PACKET", "BYTEIN", "BYTEOUT", "PACKETIN", "PACKETOUT", "SPEED",
  "SATURATION", "UPLOAD", "DOWNLOAD", "TOTAL", "IDFILE", "STATEFILE",
  "SEND", "EXPECT", "CYCLE", "COUNT", "REMINDER", "REPEAT", "LIMITS",
  "SENDEXPECTBUFFER", "EXPECTBUFFER", "FILECONTENTBUFFER",
  "HTTPCONTENTBUFFER", "PROGRAMOUTPUT", "NETWORKTIMEOUT", "PROGRAMTIMEOUT",
  "STARTTIMEOUT", "STOPTIMEOUT", "RESTARTTIMEOUT", "PIDFILE", "START",
  "STOP", "PATHTOK", "HOST", "HOSTNAME", "PORT", "IPV4", "IPV6", "TYPE",
  "UDP", "TCP", "TCPSSL", "PROTOCOL", "CONNECTION", "ALERT", "NOALERT",
  "MAILFORMAT", "UNIXSOCKET", "SIGNATURE", "TIMEOUT", "RETRY", "RESTART",
  "CHECKSUM", "EVERY", "NOTEVERY", "DEFAULT", "HTTP", "HTTPS",
  "APACHESTATUS", "FTP", "SMTP", "SMTPS", "POP", "POPS", "IMAP", "IMAPS",
  "CLAMAV", "NNTP", "NTP3", "MYSQL", "DNS", "WEBSOCKET", "SSH", "DWP",
  "LDAP2", "LDAP3", "RDATE", "RSYNC", "TNS", "PGSQL", "POSTFIXPOLICY",
  "SIP", "LMTP", "GPS", "RADIUS", "MEMCACHE", "REDIS", "MONGODB", "SIEVE",
  "SPAMASSASSIN", "FAIL2BAN", "STRING", "PATH", "MAILADDR", "MAILFROM",
  "MAILREPLYTO", "MAILSUBJECT", "MAILBODY", "SERVICENAME", "STRINGNAME",
  "NUMBER", "PERCENT", "LOGLIMIT", "CLOSELIMIT", "DNSLIMIT",
  "KEEPALIVELIMIT", "REPLYLIMIT", "REQUESTLIMIT", "STARTLIMIT",
  "WAITLIMIT", "GRACEFULLIMIT", "CLEANUPLIMIT", "REAL", "CHECKPROC",
  "CHECKFILESYS", "CHECKFILE", "CHECKDIR", "CHECKHOST", "CHECKSYSTEM",
  "CHECKFIFO", "CHECKPROGRAM", "CHECKNET", "THREADS", "CHILDREN", "METHOD",
  "GET", "HEAD", "STATUS", "ORIGIN", "VERSIONOPT", "READ", "WRITE",
  "OPERATION", "SERVICETIME", "DISK", "RESOURCE", "MEMORY", "TOTALMEMORY",
  "LOADAVG1", "LOADAVG5", "LOADAVG15", "SWAP", "MODE", "ACTIVE", "PASSIVE",
  "MANUAL", "ONREBOOT", "NOSTART", "LASTSTATE", "CPU", "TOTALCPU",
  "CPUUSER", "CPUSYSTEM", "CPUWAIT", "GROUP", "REQUEST", "DEPENDS",
  "BASEDIR", "SLOT", "EVENTQUEUE", "SECRET", "HOSTHEADER", "UID", "EUID",
  "GID", "MMONIT", "INSTANCE", "USERNAME", "PASSWORD", "TIME", "ATIME",
  "CTIME", "MTIME", "CHANGED", "MILLISECOND", "SECOND", "MINUTE", "HOUR",
  "DAY", "MONTH", "SSLAUTO", "SSLV2", "SSLV3", "TLSV1", "TLSV11", "TLSV12",
  "TLSV13", "CERTMD5", "AUTO", "BYTE", "KILOBYTE", "MEGABYTE", "GIGABYTE",
  "INODE", "SPACE", "TFREE", "PERMISSION", "SIZE", "MATCH", "NOT",
  "IGNORE", "ACTION", "UPTIME", "EXEC", "UNMONITOR", "PING", "PING4",
  "PING6", "ICMP", "ICMPECHO", "NONEXIST", "EXIST", "INVALID", "DATA",
  "RECOVERED", "PASSED", "SUCCEEDED", "URL", "CONTENT", "PID", "PPID",
  "FSFLAG", "REGISTER", "CREDENTIALS", "URLOBJECT", "ADDRESSOBJECT",
  "TARGET", "TIMESPEC", "HTTPHEADER", "MAXFORWARD", "FIPS", "GREATER",
  "GREATEROREQUAL", "LESS", "LESSOREQUAL", "EQUAL", "NOTEQUAL", "'{'",
  "'}'", "':'", "'@'", "'['", "']'", "$accept", "cfgfile",
  "statement_list", "statement", "optproclist", "optproc", "optfilelist",
  "optfile", "optfilesyslist", "optfilesys", "optdirlist", "optdir",
  "opthostlist", "opthost", "optnetlist", "optnet", "optsystemlist",
  "optsystem", "optfifolist", "optfifo", "optprogramlist", "optprogram",
  "setalert", "setdaemon", "setterminal", "startdelay", "setinit",
  "setonreboot", "setexpectbuffer", "setlimits", "limitlist", "limit",
  "setfips", "setlog", "seteventqueue", "setidfile", "setstatefile",
  "setpid", "setmmonits", "mmonitlist", "mmonit", "mmonitoptlist",
  "mmonitopt", "credentials", "setssl", "ssl", "ssloptionlist",
  "ssloption", "sslexpire", "expireoperator", "sslchecksum",
  "checksumoperator", "sslversion", "certmd5", "setmailservers",
  "setmailformat", "mailserverlist", "mailserver", "mailserveroptlist",
  "mailserveropt", "sethttpd", "httpdlist", "httpdoption", "pemfile",
  "clientpemfile", "allowselfcert", "httpdport", "httpdsocket",
  "httpdsocketoptionlist", "httpdsocketoption", "sigenable", "sigdisable",
  "signature", "bindaddress", "allow", "$@1", "$@2", "$@3", "$@4",
  "allowuserlist", "allowuser", "readonly", "checkproc", "checkfile",
  "checkfilesys", "checkdir", "checkhost", "checknet", "checksystem",
  "checkfifo", "checkprogram", "start", "stop", "restart", "argumentlist",
  "useroptionlist", "argument", "useroption", "username", "password",
  "hostname", "connection", "connectionoptlist", "connectionopt",
  "connectionurl", "connectionurloptlist", "connectionurlopt",
  "connectionunix", "connectionuxoptlist", "connectionuxopt", "icmp",
  "icmpoptlist", "icmpopt", "host", "port", "unixsocket", "ip", "type",
  "typeoptlist", "typeopt", "outgoing", "protocol", "sendexpect",
  "websocketlist", "websocket", "smtplist", "smtp", "mysqllist", "mysql",
  "target", "maxforward", "siplist", "sip", "httplist", "http", "status",
  "method", "request", "responsesum", "hostheader", "httpheaderlist",
  "secret", "radiuslist", "radius", "apache_stat_list", "apache_stat",
  "exist", "pid", "ppid", "uptime", "icmpcount", "icmpsize", "icmptimeout",
  "icmpoutgoing", "stoptimeout", "starttimeout", "restarttimeout",
  "programtimeout", "nettimeout", "connectiontimeout", "retry",
  "actionrate", "urloption", "urloperator", "alert", "alertmail",
  "noalertmail", "eventoptionlist", "eventoption", "formatlist",
  "formatoptionlist", "formatoption", "every", "mode", "onreboot", "group",
  "depend", "dependlist", "dependant", "statusvalue", "resourceprocess",
  "resourceprocesslist", "resourceprocessopt", "resourcesystem",
  "resourcesystemlist", "resourcesystemopt", "resourcecpuproc",
  "resourcecpu", "resourcecpuid", "resourcemem", "resourcememproc",
  "resourceswap", "resourcethreads", "resourcechild", "resourceload",
  "resourceloadavg", "resourceread", "resourcewrite", "value",
  "timestamptype", "timestamp", "operator", "time", "totaltime",
  "currenttime", "repeat", "action", "action1", "action2", "rateXcycles",
  "rateXYcycles", "rate1", "rate2", "recovery", "checksum", "hashtype",
  "inode", "space", "read", "write", "servicetime", "fsflag", "unit",
  "permission", "match", "matchflagnot", "size", "uid", "euid", "gid",
  "linkstatus", "linkspeed", "linksaturation", "upload", "download",
  "icmptype", "reminder", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   123,   125,
      58,    64,    91,    93
};
# endif

#define YYPACT_NINF -721

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-721)))

#define YYTABLE_NINF -700

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     578,    70,   -37,   -16,    24,    35,   125,   132,   178,   203,
     206,   143,   578,  -721,  -721,  -721,  -721,  -721,  -721,  -721,
    -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,
    -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,
    -721,    39,    62,    85,  -721,  -721,   288,    86,   215,   244,
     106,   246,   303,   222,   174,    48,   242,   153,  -721,   -50,
     -12,   381,   389,   391,   453,  -721,   408,   413,   247,  -721,
    -721,   335,   227,   501,   530,   636,   758,   797,   530,   893,
     480,  -721,   421,   426,     3,  -721,  1218,  -721,  -721,  -721,
    -721,  -721,   913,  -721,  -721,  1013,  -721,  -721,  -721,   364,
     366,  -721,   153,   252,   239,   253,  1275,   448,   387,   401,
     342,   362,   410,   415,   409,   417,   432,   459,   462,   195,
     432,   432,   466,   432,   -66,   343,   519,    57,   478,   481,
    -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,
    -721,  -721,  -721,   -30,  -721,  -721,  -721,  -721,  -721,  -721,
    -721,  -721,  -721,  -721,    78,  -114,  -721,  -721,  -721,  -721,
    -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,
    -721,  -721,  -721,  -721,  -721,    21,  -721,  -721,  -721,  -721,
    -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,
    -721,  -721,  -721,  -721,  -721,  -721,  -721,    68,  -721,  -721,
    -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,
    -721,  -721,  -721,  -721,    53,  -721,  -721,  -721,  -721,  -721,
    -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,   111,
    -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,
    -721,  -721,  -721,  -721,  -721,  -721,   904,  -721,  -721,  -721,
    -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,
    -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,
    -721,  -721,  -721,  -721,  -721,  -721,    12,  -721,  -721,  -721,
    -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,   491,
     601,  -721,   495,   331,   499,  -721,   570,     4,   520,   527,
     569,   575,   405,   540,  -721,   548,   564,   556,  -721,  -721,
    -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,
       8,    44,  -721,  -721,  -721,  -721,  -721,   463,   475,  -721,
    -721,    32,  -721,   573,  -721,   353,   252,   455,  -721,  1013,
    1275,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,
    -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,
    -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,
    -721,   956,  -721,   615,  -721,  -721,  -721,  -721,  -721,  -721,
    -721,  -721,  -721,  -721,  -721,  -721,  -721,   333,  -721,  -721,
    -721,   385,   678,   674,   674,   434,   674,   674,  -721,  -721,
    -721,   674,   674,   395,   523,   674,   650,  1241,  -721,  -721,
    -721,  -721,  -721,  -721,   674,  -721,  -721,   429,   633,  -721,
     669,   722,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,
    -721,  -721,   481,  -721,   515,  1275,   448,   124,  -721,  -721,
    -721,  -721,   142,   674,   523,   394,   674,   559,  -721,   394,
     566,   -64,   674,   674,   674,  -113,   795,  1037,   915,   150,
     755,   674,   674,   674,   630,   769,   674,   674,  -721,  -721,
    -721,  -721,  1199,  -721,  -721,   674,  -721,  -721,  -721,   674,
     643,  -721,   672,  -721,   735,    79,   705,  -721,  -721,  -721,
    -721,  -721,  -721,  -721,   707,  -721,  -721,  -721,  -721,  -721,
    -721,  -721,  -721,   616,   738,  -721,   734,   740,   745,   600,
     753,   763,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,
    -721,  -721,   607,   617,   655,   690,   694,   696,   703,   706,
    -721,  -721,   713,   715,   717,   727,   731,   733,   761,   764,
     770,  -721,  -721,  -721,  -721,  -721,  -721,   813,   831,  -721,
    -721,  -721,  -721,  -721,  -721,  -721,   313,  1016,   827,  -721,
     897,   877,   126,   168,   -21,  -721,  -721,  -721,   901,   922,
     230,   262,   272,   801,   981,  -721,   934,  -721,  -721,  -721,
    -721,  -721,  -721,  -721,   938,   946,   674,   674,    -9,    -9,
      -9,    -9,   650,   650,   650,   948,    13,  -721,  -721,  1077,
    -721,  1086,    -9,   963,   234,  -721,   971,   275,  -721,   976,
     311,  -721,  -721,  -721,  1275,  1095,  -721,  -721,  -721,   978,
    1027,   650,   650,   650,  1028,   982,  -721,  -721,   649,   990,
     652,   692,   702,    -3,    65,   240,   650,   674,   259,   674,
      -9,  -721,  -721,  -721,  1054,   650,   993,   995,  1012,   674,
     674,   650,    -9,    -9,  -721,  1150,    -9,  1021,   650,  -721,
     331,     7,  -721,  -721,  -721,  -721,  -721,  -721,  1025,  1032,
    1036,  1038,  1040,  1158,    64,   223,  1048,  1050,  1053,   925,
     900,  1056,  1057,  1186,  1042,  1046,  1055,  1060,  1061,  1062,
    1063,  1065,  1070,  -721,   975,  -721,   827,   448,  -721,   979,
    -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,   650,   650,
     650,   650,   650,   650,  -721,  1071,  -721,  1039,  1142,  -721,
    -721,   264,   278,  -721,  -721,   584,   700,  1072,  1078,  1208,
    1217,  1219,   957,  -721,  1170,   243,   243,  -721,  1011,  -721,
    1014,  -721,  1015,  -721,  1196,   827,   650,    71,  1223,  1224,
    1228,   650,   913,   650,   650,   957,   650,   650,  -721,  -721,
    -721,  -721,  1064,   913,  1075,   913,  1041,  1045,  1247,   292,
      38,  1113,    -9,   729,    30,    30,    30,  1007,  -721,  1257,
    1122,   -10,    10,  1125,  1131,  1269,   784,   792,   243,  1137,
     650,  1276,  1006,  1006,  -721,  1151,  1040,  1040,  1040,  1158,
    -721,  1040,  -721,  -721,  -721,  -721,   338,   350,  1143,  -721,
    -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,
     913,   913,   913,   913,   741,   751,   789,   805,   811,  -721,
     448,  -721,  -721,  1280,  1282,  1283,  1285,  1286,  1287,    25,
    -721,    98,  1161,  1164,   634,  1461,  1156,  1160,  -721,  -721,
    -721,  -721,  -721,  -721,  1294,  1298,  1135,   913,  1162,   913,
    -721,  -721,  -721,  -721,  -721,  -721,   243,   243,   243,  -721,
    -721,  -721,  -721,  -721,   650,  -721,  -721,  -721,  -721,  -721,
     432,  -721,  -721,  1300,  1300,  -721,  -721,  -721,   827,   448,
    1311,  1202,  1331,   243,   243,   243,  1336,   650,  1337,  1338,
     650,  1340,  1345,   650,  1136,   650,  1136,   650,   650,   243,
      38,  1209,  1348,   650,   821,   650,   650,  1226,  1220,  1221,
    1222,  -721,  -721,  -721,  -721,  -721,  1355,  1361,  1362,  -721,
      30,   243,   650,  1136,  1136,  1136,  1136,   101,   159,   243,
    -721,  -721,  -721,  -721,  1300,  -721,  1364,   243,  1238,  1239,
    -721,  1040,  1040,  1040,  -721,  -721,  -721,  -721,  -721,  -721,
    -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,
    -721,  -721,  -721,  -721,  -721,  -721,   243,   243,   243,   243,
     243,   243,    41,   394,  -721,  -721,  -721,  -721,  -721,  -721,
    -721,  1368,  1243,  -721,  -721,  -721,  -721,  -721,  -721,  -721,
    -721,  -721,  -721,  -721,  -721,  -721,  -721,  1372,  -721,  -721,
    -721,  -721,  -721,  -721,  -721,  -721,   773,  -721,  -721,  -721,
    -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,    29,
    -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,
    -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  1167,
    -721,   243,   582,  -721,  1136,  -721,  1136,  -721,  -721,  1300,
    1379,    72,  1382,  -721,  -721,   448,  -721,   243,   650,   243,
    1300,  -721,  -721,   243,  1381,   243,   243,  1383,   243,   243,
    1385,  -721,   650,  1389,   650,  1390,  1391,  -721,  1392,   650,
     243,  1393,   650,   650,  1395,  1397,  -721,  -721,  1171,  -721,
     243,   243,   243,  1409,  1300,  1412,   650,   650,   650,   650,
     476,   492,   571,   725,  1300,  -721,   243,  -721,  -721,  -721,
    1300,  1300,  1300,  1300,  1300,  1300,  1154,  1295,   243,  -721,
     243,  1102,   442,   442,  1296,   674,   674,   674,   674,   674,
     674,   674,   674,   674,   674,  -721,  -721,   773,  -721,   829,
     829,   829,  1303,  1305,  1289,  1308,    29,  -721,   -17,  1227,
    -721,  1300,  -721,  -721,  -721,  -721,  -721,   243,  1350,    90,
    -721,   507,  -721,  1300,  1437,  1300,  -721,  -721,   243,  -721,
    -721,   243,  -721,  -721,   243,  1441,   243,  1447,   243,   243,
     243,  1448,  1300,   243,  1449,  1465,   243,   243,  -721,  1300,
    1300,  1300,   243,  -721,   243,  1468,  1471,  1472,  1476,   637,
    -721,  -721,  -721,   650,   637,   650,   637,   650,   637,   650,
    -721,  1300,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  1330,
    -721,  1300,  1300,  -721,  -721,  -721,  1347,   898,   674,   941,
    1351,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,
    -721,  1343,  1366,  1367,  1369,  1370,  1373,  1374,  1375,  1380,
    1384,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,
    -721,  -721,  -721,   140,  1413,  -721,  -721,  -721,  1356,  -721,
    -721,  -721,  1300,    15,  -721,   650,   650,   650,  -721,   243,
    -721,  1300,  1300,  1300,   243,  1300,   243,  1300,  1300,  1300,
     243,  -721,  1300,   243,   243,  1300,  1300,  -721,  -721,  -721,
    1300,  1300,   243,   243,   243,   243,   650,  1484,   650,  1504,
     650,  1515,   650,  1517,  -721,  1304,  -721,  -721,  -721,  -721,
    -721,  1460,  -721,  -721,  -721,  -178,  1388,  1462,  1463,  1497,
    1498,  1499,  1500,  1501,  1502,  1503,  -721,  -721,  -721,  -721,
    -721,  -721,  1477,  -721,  -721,  1526,  1528,  1597,  1300,  -721,
    -721,  -721,  1300,  -721,  1300,  -721,  -721,  -721,  1300,  -721,
    1300,  1300,  -721,  -721,  -721,  -721,  1300,  1300,  1300,  1300,
    1641,   243,  1642,   243,  1643,   243,  1644,   243,  -721,  -721,
    -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,
    -721,  -721,  -721,   243,   243,   243,  -721,  -721,  -721,  -721,
    -721,  -721,  -721,  -721,  -721,  -721,   243,  1300,   243,  1300,
     243,  1300,   243,  1300,  -721,  -721,  -721,  -721,  1300,  -721,
    1300,  -721,  1300,  -721,  1300,  -721,  -721,  -721,  -721,  -721
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       2,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     3,     4,     6,     8,     9,    20,    22,    19,
      21,    23,    10,    11,    17,    18,    16,    12,     7,    13,
      14,    15,    33,    56,    76,    98,   115,   130,   147,   161,
     178,     0,     0,     0,   290,   198,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   220,   592,
       0,     0,     0,     0,     0,   351,     0,     0,     0,     1,
       5,    24,    25,    26,    27,    28,    32,    29,    30,    31,
     222,   221,   196,   281,   545,   277,   289,   195,   246,   227,
     228,   204,   730,   229,   558,     0,   199,   200,   201,     0,
       0,   234,   230,   241,     0,     0,     0,   771,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      34,    35,    36,    37,    45,    46,    47,    38,    39,    40,
      44,    48,    49,   592,   557,    50,    51,    52,    53,    54,
      55,    41,    42,    43,   745,   745,    57,    58,    59,    60,
      61,    63,    65,    64,    72,    73,    74,    75,    62,    69,
      66,    71,    70,    67,    68,     0,    77,    78,    79,    80,
      81,    82,    84,    83,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    85,    86,    87,     0,    99,   100,
     101,   102,   103,   105,   107,   106,   111,   112,   113,   114,
     104,   108,   109,   110,     0,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,     0,
     131,   132,   133,   134,   140,   144,   141,   142,   143,   145,
     146,   135,   136,   137,   138,   139,     0,   148,   149,   150,
     151,   160,   152,   153,   154,   155,   156,   157,   158,   159,
     162,   163,   164,   165,   166,   168,   170,   169,   174,   175,
     176,   177,   167,   171,   172,   173,     0,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,     0,
       0,   194,     0,   279,     0,   278,   374,     0,     0,     0,
       0,     0,   244,     0,   303,     0,     0,     0,   292,   291,
     293,   294,   295,   299,   300,   317,   318,   296,   297,   298,
       0,     0,   731,   732,   733,   734,   202,     0,     0,   598,
     599,     0,   594,   224,   226,   233,   241,     0,   231,     0,
       0,   576,   563,   564,   578,   579,   586,   584,   566,   588,
     565,   587,   583,   590,   572,   574,   589,   580,   585,   562,
     591,   569,   573,   577,   570,   575,   568,   567,   581,   582,
     571,     0,   560,     0,   191,   340,   341,   342,   343,   346,
     345,   344,   347,   348,   352,   365,   366,   543,   361,   349,
     350,   417,     0,   666,   666,     0,   666,   666,   651,   652,
     653,   666,   666,     0,     0,   666,   699,   699,   617,   619,
     620,   621,   622,   623,   666,   624,   625,   539,   537,   559,
     541,     0,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   613,   610,   611,     0,     0,   771,   712,   660,   661,
     662,   663,   712,   666,   746,     0,   666,     0,   746,     0,
       0,     0,   666,   666,   666,     0,   666,   666,     0,   417,
       0,   666,   666,   666,     0,     0,   666,   666,   639,   636,
     637,   638,   699,   627,   632,   666,   630,   631,   629,   666,
       0,   223,     0,   281,     0,     0,     0,   272,   266,   267,
     268,   269,   270,   271,     0,   273,   285,   286,   287,   288,
     282,   283,   284,     0,     0,   275,     0,     0,     0,   334,
     322,     0,   319,   301,   314,   316,   246,   302,   304,   306,
     313,   315,     0,     0,     0,     0,     0,     0,     0,     0,
     243,   247,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   203,   205,   596,   597,   276,   595,     0,     0,   235,
     237,   238,   239,   240,   232,   242,     0,     0,   592,   561,
     772,     0,     0,     0,   543,   362,   363,   353,     0,     0,
       0,     0,     0,     0,     0,   400,     0,   673,   667,   668,
     669,   670,   671,   672,     0,     0,   666,   666,     0,     0,
       0,     0,   699,   699,   699,     0,     0,   700,   701,     0,
     618,     0,     0,     0,   539,   355,     0,   537,   357,     0,
     541,   359,   600,   612,     0,     0,   554,   713,   714,     0,
       0,   699,   699,   699,     0,     0,   552,   553,     0,     0,
       0,     0,     0,     0,     0,     0,   699,   666,     0,   666,
       0,   411,   411,   411,     0,   699,     0,     0,     0,   666,
     666,   699,     0,     0,   628,     0,     0,     0,   699,   197,
     280,   264,   372,   371,   373,   274,   546,   375,   323,   324,
     325,     0,     0,   338,     0,   305,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   225,     0,   593,   592,   771,   773,     0,
     367,   369,   368,   370,   364,   354,   418,   420,   699,   699,
     699,   699,   699,   699,   391,     0,   377,   699,     0,   648,
     649,     0,     0,   659,   658,   730,   730,     0,     0,     0,
       0,     0,   674,   697,     0,     0,     0,   650,     0,   356,
       0,   358,     0,   360,     0,   592,   699,   699,     0,     0,
       0,   699,   730,   699,   699,   674,   699,   699,   740,   739,
     744,   743,   659,   730,   659,   730,   659,     0,     0,     0,
     659,     0,     0,   730,   699,   699,   699,     0,   411,     0,
       0,   730,   730,     0,     0,     0,   730,   730,     0,     0,
     699,     0,   264,   264,   265,     0,     0,     0,     0,   338,
     337,   327,   335,   339,   321,   245,     0,     0,     0,   307,
     254,   253,   255,   250,   251,   248,   249,   256,   257,   252,
     730,   730,   730,   730,     0,     0,     0,     0,     0,   236,
     771,   192,   544,     0,     0,     0,     0,     0,     0,   699,
     419,   699,     0,     0,     0,     0,     0,     0,   401,   402,
     403,   404,   405,   406,     0,     0,   659,   730,   659,   730,
     643,   642,   645,   644,   633,   634,     0,     0,     0,   675,
     676,   677,   678,   679,   699,   698,   692,   693,   688,   691,
       0,   694,   695,   705,   705,   540,   538,   542,   592,   771,
       0,     0,     0,     0,     0,     0,     0,   699,     0,     0,
     699,     0,     0,   699,   683,   699,   683,   699,   699,     0,
     659,     0,     0,   699,   730,   699,   699,     0,     0,     0,
       0,   412,   413,   414,   415,   416,     0,     0,     0,   770,
     699,     0,   699,   683,   683,   683,   683,   730,   730,     0,
     641,   640,   647,   646,   705,   635,     0,     0,     0,     0,
     261,   329,   331,   333,   320,   336,   308,   310,   309,   311,
     312,   206,   207,   208,   209,   210,   211,   212,   213,   216,
     217,   214,   215,   218,   219,   193,     0,     0,     0,     0,
       0,     0,     0,     0,   396,   398,   397,   392,   394,   395,
     393,     0,     0,   421,   422,   387,   389,   388,   378,   379,
     380,   385,   381,   382,   384,   386,   383,     0,   467,   468,
     425,   423,   426,   432,   490,   490,     0,   436,   475,   475,
     450,   451,   439,   440,   441,   447,   448,   479,   433,     0,
     456,   434,   442,   443,   457,   459,   460,   461,   449,   486,
     462,   463,   510,   465,   458,   444,   452,   455,   435,     0,
     548,     0,     0,   655,   683,   657,   683,   530,   531,   705,
       0,   685,     0,   529,   616,   771,   555,     0,   699,     0,
     705,   748,   665,     0,     0,     0,     0,     0,     0,     0,
       0,   684,   699,     0,   699,     0,     0,   729,     0,   699,
       0,     0,   699,   699,     0,     0,   536,   533,     0,   534,
       0,     0,     0,     0,   705,     0,   699,   699,   699,   699,
       0,     0,     0,     0,   705,   626,     0,   615,   262,   263,
     705,   705,   705,   705,   705,   705,   259,     0,     0,   430,
       0,   424,   437,   438,     0,   666,   666,   666,   666,   666,
     666,   666,   666,   666,   666,   515,   516,   431,   513,   453,
     454,   445,     0,     0,     0,     0,   466,   469,   446,   464,
     547,   705,   550,   549,   654,   656,   528,     0,     0,   685,
     689,     0,   556,   705,     0,   705,   736,   711,     0,   738,
     737,     0,   742,   741,     0,     0,     0,     0,     0,     0,
       0,     0,   705,     0,     0,     0,     0,     0,   535,   705,
     705,   705,     0,   755,     0,     0,     0,     0,     0,     0,
     680,   681,   682,   699,     0,   699,     0,   699,     0,   699,
     756,   705,   749,   750,   751,   752,   753,   754,   260,     0,
     551,   705,   705,   428,   429,   427,     0,     0,   666,     0,
       0,   507,   492,   493,   491,   496,   497,   494,   495,   498,
     517,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   514,   477,   478,   476,   481,   482,   480,   473,   471,
     474,   472,   470,     0,     0,   488,   489,   487,     0,   512,
     511,   399,   705,     0,   690,   702,   702,   702,   735,     0,
     709,   705,   705,   705,     0,   705,     0,   705,   705,   705,
       0,   715,   705,     0,     0,   705,   705,   408,   409,   410,
     705,   705,     0,     0,     0,     0,   699,     0,   699,     0,
     699,     0,   699,     0,   614,     0,   390,   376,   505,   501,
     502,     0,   504,   503,   506,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   484,   483,   485,   509,
     532,   686,     0,   703,   704,     0,     0,     0,   705,   747,
     664,   724,   705,   726,   705,   727,   728,   717,   705,   716,
     705,   705,   720,   719,   407,   757,   705,   705,   705,   705,
       0,     0,     0,     0,     0,     0,     0,     0,   258,   500,
     508,   499,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   687,     0,     0,     0,   710,   723,   725,   718,
     722,   721,   761,   758,   767,   764,     0,   705,     0,   705,
       0,   705,     0,   705,   696,   706,   707,   708,   705,   762,
     705,   759,   705,   768,   705,   765,   763,   760,   769,   766
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -721,  -721,  -721,  1638,  -721,  -721,  -721,  -721,  -721,  -721,
    -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,
    -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,
    -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,
    1549,  -721,  -721,  1316,  -721,   -81,  1138,  -721,   812,  -721,
    -315,   285,  -332,  -334,  -721,  -721,  -721,  1571,  1173,  -721,
    -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,
    -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,    67,
    -720,   858,  -721,  -721,  -721,  -721,  -721,  -721,  -721,  -721,
    -721,  1387,  1419,  1427,  -107,  -399,  -385,  -555,  -605,  -329,
    -721,  1583,  -721,  -721,  1584,  -721,  -721,  -721,  -721,  -721,
    -721,  -595,  -721,  -721,  -721,  -721,  -721,   819,  -721,  -721,
    -721,   820,   822,  -721,   506,   645,  -721,  -721,  -721,  -721,
    -721,  -721,  -721,   651,  -721,  -721,  -721,  -721,  -721,  -721,
    -721,  -721,  -721,  -721,  -721,   518,   525,  -721,  -721,  1590,
    -721,  -721,  -721,  -721,  1066,  1067,  1058,  1105,  -721,  -545,
    -395,  1466,   833,  -432,  1474,  1669,  -721,  -317,  -349,  -133,
    1333,  -291,  1521,  1535,  1543,  1551,  1559,  -721,  1244,  -721,
    -721,  -721,  1268,  -721,  -721,  1205,  -721,  -721,  -721,  -721,
    -721,  -721,  -721,  -721,  -210,  -721,  -721,  -721,   834,  -251,
      18,  -390,   923,  -369,  -287,   510,  -504,  -410,  -302,  -379,
    -296,  -407,  -176,  -263,  -721,  1240,  -721,  -721,  -721,  -721,
    -721,  -721,  -310,   535,  -721,  1525,  -721,   557,  -721,   803,
    -721,  -721,  -721,  -721,  -721,  -721,  -428
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    11,    12,    13,    71,   130,    72,   156,    73,   176,
      74,   198,    75,   215,    76,   230,    77,   247,    78,   260,
      79,   277,    14,    15,    16,   291,    17,    18,    19,    20,
     321,   542,    21,    22,    23,    24,    25,    26,    27,   102,
     103,   335,   549,   338,    28,   496,   320,   531,   985,  1229,
     497,   795,   498,   499,    29,    30,    84,    85,   293,   500,
      31,    86,   309,   310,   311,   312,   313,   314,   675,   809,
     315,   316,   317,   318,   319,   672,   796,   797,   798,   801,
     802,   804,    32,    33,    34,    35,    36,    37,    38,    39,
      40,   131,   132,   133,   387,   564,   388,   566,   501,   502,
     505,   134,   841,   998,   135,   839,   987,   136,   717,   848,
     221,   774,   921,   574,   716,   575,   999,   849,  1131,  1235,
    1001,   850,   851,  1156,  1157,  1149,  1264,  1151,  1267,  1275,
    1276,  1158,  1277,  1132,  1244,  1245,  1246,  1247,  1248,  1249,
    1335,  1279,  1159,  1280,  1147,  1148,   137,   138,   139,   140,
     922,   923,   924,   925,   608,   605,   611,   567,   296,   852,
     853,   141,   990,   628,   142,   143,   144,   371,   372,   107,
     331,   332,   145,   146,   147,   148,   149,   432,   433,   288,
     150,   407,   408,   259,   472,   473,   409,   474,   475,   476,
     410,   477,   411,   412,   413,   414,   415,   416,   725,   446,
     168,   584,   874,  1213,  1082,  1170,   882,   883,  1425,   597,
     598,   599,  1355,  1063,   169,   620,   188,   189,   190,   191,
     192,   193,   326,   170,   171,   447,   172,   151,   152,   153,
     241,   242,   243,   244,   245,   778,   374
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     601,   553,   565,   552,   585,   308,   588,   589,   616,   704,
     436,   590,   591,   417,   418,   595,   420,   631,   604,   607,
     551,   610,   559,   557,   602,   506,   507,   451,   508,   792,
     793,   933,   565,   565,   522,   565,   478,   104,   523,   524,
     546,   525,   526,  -699,   527,   528,   917,   775,   776,   704,
      80,   935,   704,   625,   302,   704,   629,   104,   108,   459,
     982,   109,   633,   634,   635,   655,   638,   640,   733,   561,
    1351,   646,   647,   648,   451,   421,   652,   653,    41,  1126,
      42,   955,    43,    44,   437,   656,   918,    45,    46,   657,
     522,  1390,   210,   294,   523,   524,   272,   525,   526,    47,
     527,   528,    60,  1152,   532,  1391,   533,   534,   535,   536,
     537,   538,   539,   540,   992,   846,   847,   460,   615,    96,
     919,    48,    49,    61,   621,   891,   448,   302,   427,    50,
    1168,    51,   723,   982,   661,    83,   509,   510,   762,   570,
      52,   572,  1110,    69,   724,   449,   617,   618,  1168,   636,
     724,   842,   843,   392,   734,    53,  1352,    54,   461,   462,
     463,   464,   392,    62,   617,   618,   596,   327,   328,   329,
     330,   596,    81,   619,    63,   993,   994,   844,   529,   596,
     479,   845,   562,   930,   563,   729,   730,   731,   846,   847,
     105,   623,   452,   453,   392,   454,   721,   722,  1153,  1154,
    1112,   391,   422,    82,   385,   386,   764,   623,   559,   392,
     434,   662,   596,   663,   748,   749,   750,    83,   724,   392,
     322,   323,   324,   325,   568,  1155,   480,   110,   106,   768,
     154,   955,   955,   955,   529,   455,    97,    98,   779,   596,
     322,   323,   324,   325,   785,   428,   429,   769,   435,   772,
    1273,   791,   392,  1274,   550,   456,   457,    55,   700,   783,
     784,   404,   478,   117,    64,   546,   559,   701,   920,   831,
      56,    65,  1346,   406,  1347,   562,    57,   563,   438,   439,
     440,   441,   458,   794,   983,   511,   118,   530,   438,   439,
     440,   441,   442,   562,   988,   563,  1004,   744,   120,   121,
     702,   833,   834,   835,   836,   837,   838,    87,   404,   703,
     854,   545,    53,   122,   876,   877,   443,    66,   444,   123,
     406,   124,   125,   541,   603,   465,   884,   570,   878,   572,
     406,   322,   323,   324,   325,   879,   392,   445,   119,   890,
     892,    58,    67,   805,   896,    68,   898,   899,    89,   901,
     902,   819,   438,   439,   440,   441,    94,   983,   393,   394,
     302,   619,   708,   912,    88,   606,   484,   926,   927,   928,
     395,   709,   396,   397,   398,   399,   400,    90,   944,   621,
     622,   766,   302,   946,    91,   401,   402,    92,   484,   322,
     323,   324,   325,   724,   710,   559,   641,   642,   643,   644,
     770,   609,   975,   711,   712,   856,   120,   121,   573,   403,
     126,  1145,   724,   713,   127,   861,   863,   724,   101,   858,
      53,   122,   128,   561,   129,   697,   806,   123,   807,   124,
     125,   724,   991,   910,  1007,   404,    93,   562,   405,   563,
      99,   100,   897,   548,   989,   724,  1005,   406,   327,   328,
     329,   330,    95,   904,   111,   906,  1057,  1058,  1059,   568,
     808,  1066,   112,   916,   113,   385,   386,  1060,   155,   114,
     956,   934,   936,   569,   377,   378,   941,   943,   562,   957,
     563,   115,   958,  1070,  1071,  1072,   116,   880,   881,   289,
    1074,   959,   290,  1077,   379,   380,  1080,   333,  1083,  1087,
    1085,  1086,   292,  1088,   175,   373,  1091,   334,  1094,  1095,
     961,   962,   963,   964,   562,   337,   563,   339,   126,   603,
     375,  1104,   127,  1103,   986,  1105,   997,  1242,  1242,  1114,
     128,   340,   129,   197,   376,  1236,   562,  1117,   563,   485,
     486,   383,  1145,   381,  1262,  1262,  1265,  1054,   382,  1056,
     384,  1127,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   385,   386,   830,   385,   386,  1120,  1121,  1122,  1123,
    1124,  1125,   120,   121,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   520,   521,     1,    53,   122,   570,   571,
     572,   389,   695,   123,   390,   124,   125,   160,   180,   202,
     419,   120,   121,   264,  1093,   586,   587,  1237,   194,   211,
    1238,   423,   889,   273,   704,    53,   122,  1209,   430,  1084,
     431,  1064,   123,   481,   124,   125,   482,  1111,  1113,   173,
     195,   212,   562,  1214,   563,   274,   483,  1172,  1239,   214,
     503,  1161,  1163,   573,  1240,   504,  1106,  1107,  1108,  1109,
     485,   486,   512,   876,   877,   592,   593,  1173,   514,  1175,
     513,  1174,  1169,  1177,   515,  1179,  1180,   878,  1182,  1183,
     626,   627,  1162,   517,   879,  1185,   565,  1187,   649,   650,
    1192,  1115,  1191,   516,   126,  1194,  1195,  1146,   127,   518,
    1199,  1200,  1201,  1210,  1211,  1212,   128,   519,   129,  1205,
    1206,  1207,  1208,   424,   425,   426,  1221,   120,   121,  1210,
    1211,  1212,  1216,   126,  1010,  1011,  1012,   127,  1231,   555,
    1232,    53,   122,   606,  1241,   128,   860,   129,   123,   543,
     124,   125,     2,     3,     4,     5,     6,     7,     8,     9,
      10,   544,  1215,  1217,  1219,  1251,  1252,  1253,  1254,  1255,
    1256,  1257,  1258,  1259,  1260,  1065,   560,  1282,   984,   609,
     995,   229,  1285,  1286,  1287,   385,   386,  1164,  1291,  1165,
     576,  1292,   547,  1061,  1293,   594,  1295,   612,  1297,  1298,
    1299,   753,   754,  1302,   756,   757,  1305,  1306,  1210,  1211,
    1212,   596,  1310,   614,  1311,   645,  1166,  1234,   630,  1233,
     246,   385,   386,  1243,  1243,   632,  1317,  1176,  1319,   651,
    1321,   658,  1323,   659,   322,   323,   324,   325,  1146,   126,
    1263,  1263,  1266,   127,   758,   759,   880,   881,   661,   120,
     121,   128,   666,   129,   760,   761,   562,   664,   563,   665,
    1316,  1203,   862,    53,   122,  1318,  1134,  1320,  1331,  1322,
     123,  1220,   124,   125,  1210,  1211,  1212,  1222,  1223,  1224,
    1225,  1226,  1227,   951,   952,   953,  1218,   668,   120,   121,
     667,   915,   562,   669,   563,   174,   196,   213,   670,  1358,
     671,   275,    53,   122,  1362,  -326,  1364,   676,   577,   123,
    1368,   124,   125,  1370,  1371,   673,   276,   677,  1281,  1424,
    1424,  1424,  1376,  1377,  1378,  1379,  1353,  1353,  1353,  1380,
    1288,  1382,  1290,  1384,   104,  1386,  1135,  1136,  1137,  1138,
    1139,  1140,  1141,  1142,  1143,  1144,   940,   815,   816,  1301,
     322,   323,   324,   325,   942,   678,  1307,  1308,  1309,   813,
     814,   126,  1210,  1211,  1212,   127,   578,   579,   580,   581,
     582,   583,   698,   128,   693,   129,   965,   966,  1324,   322,
     323,   324,   325,  1092,   120,   121,   967,   968,  1326,  1327,
     679,  1417,   694,  1419,   680,  1421,   681,  1423,    53,   122,
     126,   485,   486,   682,   127,   123,   683,   124,   125,  1354,
    1354,  1354,   128,   684,   129,   685,   341,   686,   342,   343,
     344,   345,   346,   347,   969,   970,  1428,   687,  1430,   577,
    1432,   688,  1434,   689,   322,   323,   324,   325,   699,  1350,
     971,   972,   322,   323,   324,   325,   973,   974,  1359,  1360,
    1361,   637,  1363,   706,  1365,  1366,  1367,   485,   486,  1369,
     348,   690,  1372,  1373,   691,   392,   349,  1374,  1375,   350,
     692,   322,   323,   324,   325,   707,   341,   715,   342,   343,
     344,   345,   346,   347,  1329,  1330,   714,   578,   579,   580,
     581,   582,   583,  1332,  1333,   718,   126,   948,   949,   719,
     127,   466,   735,   398,   399,   400,   467,   720,   128,   732,
     129,   736,   842,   843,   468,  1406,   469,   470,   471,  1407,
     348,  1408,  1426,  1427,   738,  1409,   349,  1410,  1411,   350,
    1356,  1357,   740,  1412,  1413,  1414,  1415,   742,   844,   746,
     747,   751,   845,   752,   351,   438,   439,   440,   441,   846,
     847,   755,   352,   777,   780,   341,   781,   342,   343,   344,
     345,   346,   347,   322,   323,   324,   325,   405,   327,   328,
     329,   330,   621,   782,  1429,   788,  1431,  -328,  1433,   353,
    1435,   354,   790,   355,  -330,  1436,   356,  1437,  -332,  1438,
     799,  1439,   800,   869,   870,   871,   872,   873,   803,   348,
     596,   810,   811,   820,   351,   349,   812,   821,   350,   817,
     818,   829,   352,   357,   358,   832,   822,   855,   359,   360,
     361,   823,   824,   825,   826,   362,   827,   363,   364,   365,
     366,   828,   840,   866,   864,   367,   368,   369,   370,   353,
     865,   354,   867,   355,   868,   875,   356,   885,   893,   894,
     886,   887,   297,   895,   298,   558,   341,   903,   342,   343,
     344,   345,   346,   347,   299,   300,   301,   302,   905,   303,
     304,   577,   909,   357,   358,   913,   907,   929,   359,   360,
     361,   908,   931,   351,   932,   362,   937,   363,   364,   365,
     366,   352,   938,   639,   939,   367,   368,   369,   370,   945,
     348,   947,   794,   950,   960,   976,   349,   977,   978,   350,
     979,   980,   981,  1008,   305,   696,  1009,  1049,   353,  1051,
     354,  1050,   355,  1052,  1062,   356,   306,   307,  1053,   578,
     579,   580,   581,   582,   583,   341,  1067,   342,   343,   344,
     345,   346,   347,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   357,   358,  1068,  1055,  1069,   359,   360,   361,
     596,  1073,  1075,  1076,   362,  1078,   363,   364,   365,   366,
    1079,  1089,  1081,  1090,   367,   368,   369,   370,  1096,   348,
    1100,  1097,  1098,  1099,   351,   349,  1101,  1102,   350,  1116,
    1118,  1119,   352,  1128,   745,  1129,   466,  1130,   398,   399,
     400,   467,   596,  1160,  1167,  1171,  1178,  1198,  1181,   468,
    1184,   469,   470,   471,  1186,  1188,  1189,  1190,  1193,   353,
    1196,   354,  1197,   355,   393,   394,   356,   487,   488,   489,
     490,   491,   492,   493,  1202,   495,   395,  1204,   396,   397,
     398,   399,   400,   726,   727,   728,  1228,  1230,  1278,  1250,
    1270,   401,   402,   357,   358,  1268,   737,  1269,   359,   360,
     361,  1271,  1289,   351,  1283,   362,  1294,   363,   364,   365,
     366,   352,  1296,  1300,  1303,   367,   368,   369,   370,   157,
     177,   199,   216,   231,   248,   261,   278,   763,   765,   767,
    1304,  1325,   771,  1312,   773,   888,  1313,  1314,   353,  1328,
     354,  1315,   355,  1334,  1336,   356,   786,   787,  1349,  1381,
     789,   158,   178,   200,   217,   232,   249,   262,   279,   159,
     179,   201,   218,   233,   250,   263,   280,  1337,  1338,  1383,
    1339,  1340,   357,   358,  1341,  1342,  1343,   359,   360,   361,
    1385,  1344,  1387,  1388,   362,  1345,   363,   364,   365,   366,
    1392,  1403,  1402,  1404,   367,   368,   369,   370,   161,   181,
     203,   222,   234,   252,   265,   281,   162,   182,   204,   223,
     235,   253,   266,   282,  1348,   857,   859,  1013,  1014,  1015,
    1016,  1017,  1018,  1019,  1020,  1021,  1022,  1023,  1024,  1025,
    1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,
    1036,  1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,
    1046,  1047,  1048,   163,   183,   205,   224,   236,   254,   267,
     283,  1389,  1405,   911,  1393,  1394,   914,   164,   184,   206,
     225,   237,   255,   268,   284,   165,   185,   207,   226,   238,
     256,   269,   285,   166,   186,   208,   227,   239,   257,   270,
     286,   167,   187,   209,   228,   240,   258,   271,   287,  1395,
    1396,  1397,  1398,  1399,  1400,  1401,  1416,  1418,  1420,  1422,
      70,   336,   554,   996,   674,   295,   660,   954,   219,   220,
    1000,  1002,  1272,  1003,  1150,  1261,  1133,   251,   743,   705,
      59,   739,   556,   741,  1006,   600,   613,   654,   900,  1284,
     450,     0,   624
};

static const yytype_int16 yycheck[] =
{
     407,   335,   387,   335,   394,    86,   396,   397,   436,   564,
     143,   401,   402,   120,   121,   405,   123,   449,   417,   418,
     335,   420,   371,   340,   414,    21,    22,     6,    24,    22,
      23,    41,   417,   418,    26,   420,   246,    87,    30,    31,
     331,    33,    34,     5,    36,    37,    16,   642,   643,   604,
      11,    41,   607,   443,    29,   610,   446,    87,    70,     6,
      35,    73,   452,   453,   454,   472,   456,   457,    55,    90,
      55,   461,   462,   463,     6,   141,   466,   467,     8,    38,
      10,   801,    12,    13,     6,   475,    56,    17,    18,   479,
      26,   269,    74,    90,    30,    31,    78,    33,    34,    29,
      36,    37,   139,    74,    60,   283,    62,    63,    64,    65,
      66,    67,    68,    69,    16,    90,    91,     6,   435,    71,
      90,    51,    52,   139,   237,    54,   240,    29,    71,    59,
      58,    61,   141,    35,    93,   132,   132,   133,   141,   203,
      70,   205,    41,     0,   153,   259,    22,    23,    58,   262,
     153,    53,    54,   141,   141,    85,   141,    87,    47,    48,
      49,    50,   141,   139,    22,    23,   141,   135,   136,   137,
     138,   141,   133,   237,   139,    77,    78,    79,   170,   141,
     168,    83,   203,   778,   205,   592,   593,   594,    90,    91,
     240,   442,   171,   172,   141,   174,   586,   587,   169,   170,
      41,     6,   268,   141,   132,   133,   141,   458,   557,   141,
     240,   132,   141,   134,   621,   622,   623,   132,   153,   141,
     230,   231,   232,   233,    74,   196,   214,   239,   278,   636,
       3,   951,   952,   953,   170,   214,   188,   189,   645,   141,
     230,   231,   232,   233,   651,   188,   189,   637,   278,   639,
     267,   658,   141,   270,   335,   234,   235,   187,   132,   649,
     650,   240,   472,    16,   139,   556,   615,   141,   238,   697,
     200,   139,   132,   252,   134,   203,   206,   205,   210,   211,
     212,   213,   214,   276,   259,   281,    39,   279,   210,   211,
     212,   213,   214,   203,   839,   205,   841,   614,    71,    72,
     132,   708,   709,   710,   711,   712,   713,    19,   240,   141,
     717,   279,    85,    86,    71,    72,   238,   139,   240,    92,
     252,    94,    95,   279,    90,   214,   736,   203,    85,   205,
     252,   230,   231,   232,   233,    92,   141,   259,     3,   746,
     747,   271,   139,   279,   751,   139,   753,   754,   133,   756,
     757,   683,   210,   211,   212,   213,   134,   259,   163,   164,
      29,   237,   132,   770,   278,    90,    35,   774,   775,   776,
     175,   141,   177,   178,   179,   180,   181,   133,   788,   237,
     238,   141,    29,   790,   278,   190,   191,   141,    35,   230,
     231,   232,   233,   153,   132,   744,   246,   247,   248,   249,
     141,    90,   830,   141,   132,   141,    71,    72,   258,   214,
     183,  1016,   153,   141,   187,   725,   726,   153,   265,   141,
      85,    86,   195,    90,   197,   558,   203,    92,   205,    94,
      95,   153,   839,   141,   841,   240,   133,   203,   243,   205,
     198,   199,   752,    90,   839,   153,   841,   252,   135,   136,
     137,   138,   278,   763,    73,   765,   866,   867,   868,    74,
     237,   889,    73,   773,    73,   132,   133,   874,   241,    16,
     132,   781,   782,    88,   132,   133,   786,   787,   203,   141,
     205,    73,   132,   893,   894,   895,    73,   244,   245,     9,
     897,   141,    71,   900,   132,   133,   903,   133,   905,   909,
     907,   908,    76,   910,     3,    57,   913,   141,   915,   916,
     820,   821,   822,   823,   203,   263,   205,   278,   183,    90,
     133,   931,   187,   930,   839,   932,   841,  1132,  1133,   939,
     195,   278,   197,     3,   133,    93,   203,   947,   205,   208,
     209,   132,  1147,   133,  1149,  1150,  1151,   857,   133,   859,
     133,   983,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   132,   133,   696,   132,   133,   976,   977,   978,   979,
     980,   981,    71,    72,   221,   222,   223,   224,   225,   226,
     227,   228,   229,    27,    28,     7,    85,    86,   203,   204,
     205,   132,   279,    92,   132,    94,    95,    72,    73,    74,
     134,    71,    72,    78,   914,   171,   172,   165,    73,    74,
     168,   268,   745,    78,  1169,    85,    86,   141,   140,   906,
     139,   884,    92,   132,    94,    95,    25,   937,   938,    72,
      73,    74,   203,   141,   205,    78,   141,  1065,   196,     3,
     141,  1051,  1052,   258,   202,    75,   933,   934,   935,   936,
     208,   209,   132,    71,    72,   260,   261,  1067,    89,  1069,
     133,  1068,  1061,  1073,    89,  1075,  1076,    85,  1078,  1079,
     276,   277,    90,   133,    92,  1082,  1061,  1084,    48,    49,
    1090,   944,  1089,   278,   183,  1092,  1093,  1016,   187,   141,
    1100,  1101,  1102,   217,   218,   219,   195,   133,   197,  1106,
    1107,  1108,  1109,   184,   185,   186,  1116,    71,    72,   217,
     218,   219,   141,   183,    80,    81,    82,   187,  1128,   264,
    1130,    85,    86,    90,   282,   195,   142,   197,    92,   266,
      94,    95,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   266,  1111,  1112,  1113,  1135,  1136,  1137,  1138,  1139,
    1140,  1141,  1142,  1143,  1144,   888,   141,  1167,   839,    90,
     841,     3,   255,   256,   257,   132,   133,  1054,  1178,  1056,
      92,  1181,   199,   880,  1184,   252,  1186,    55,  1188,  1189,
    1190,   132,   133,  1193,   132,   133,  1196,  1197,   217,   218,
     219,   141,  1202,   278,  1204,    40,  1059,  1131,   239,  1131,
       3,   132,   133,  1132,  1133,   239,  1213,  1070,  1215,    40,
    1217,   168,  1219,   141,   230,   231,   232,   233,  1147,   183,
    1149,  1150,  1151,   187,   132,   133,   244,   245,    93,    71,
      72,   195,   216,   197,   132,   133,   203,   132,   205,   132,
    1209,  1104,   142,    85,    86,  1214,    73,  1216,  1238,  1218,
      92,  1114,    94,    95,   217,   218,   219,  1120,  1121,  1122,
    1123,  1124,  1125,   796,   797,   798,   141,   133,    71,    72,
     132,   142,   203,   133,   205,    72,    73,    74,   133,  1289,
     280,    78,    85,    86,  1294,   132,  1296,   280,   214,    92,
    1300,    94,    95,  1303,  1304,   132,     3,   280,  1161,  1403,
    1404,  1405,  1312,  1313,  1314,  1315,  1285,  1286,  1287,  1316,
    1173,  1318,  1175,  1320,    87,  1322,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   142,    27,    28,  1192,
     230,   231,   232,   233,   142,   280,  1199,  1200,  1201,    14,
      15,   183,   217,   218,   219,   187,   272,   273,   274,   275,
     276,   277,    55,   195,   141,   197,   215,   216,  1221,   230,
     231,   232,   233,   142,    71,    72,   215,   216,  1231,  1232,
     280,  1381,   141,  1383,   280,  1385,   280,  1387,    85,    86,
     183,   208,   209,   280,   187,    92,   280,    94,    95,  1285,
    1286,  1287,   195,   280,   197,   280,    40,   280,    42,    43,
      44,    45,    46,    47,   215,   216,  1416,   280,  1418,   214,
    1420,   280,  1422,   280,   230,   231,   232,   233,   141,  1282,
     215,   216,   230,   231,   232,   233,   215,   216,  1291,  1292,
    1293,   236,  1295,   132,  1297,  1298,  1299,   208,   209,  1302,
      84,   280,  1305,  1306,   280,   141,    90,  1310,  1311,    93,
     280,   230,   231,   232,   233,   133,    40,    76,    42,    43,
      44,    45,    46,    47,   166,   167,   265,   272,   273,   274,
     275,   276,   277,   132,   133,   141,   183,   792,   793,   141,
     187,   177,     5,   179,   180,   181,   182,   141,   195,   141,
     197,     5,    53,    54,   190,  1358,   192,   193,   194,  1362,
      84,  1364,  1404,  1405,   141,  1368,    90,  1370,  1371,    93,
    1286,  1287,   141,  1376,  1377,  1378,  1379,   141,    79,   141,
      93,    93,    83,   141,   168,   210,   211,   212,   213,    90,
      91,   141,   176,    79,   141,    40,   141,    42,    43,    44,
      45,    46,    47,   230,   231,   232,   233,   243,   135,   136,
     137,   138,   237,   141,  1417,     5,  1419,   132,  1421,   203,
    1423,   205,   141,   207,   132,  1428,   210,  1430,   132,  1432,
     132,  1434,   132,   216,   217,   218,   219,   220,    20,    84,
     141,   133,   132,   141,   168,    90,   133,   141,    93,   133,
     133,   216,   176,   237,   238,   216,   141,    55,   242,   243,
     244,   141,   141,   141,   141,   249,   141,   251,   252,   253,
     254,   141,   141,     5,   142,   259,   260,   261,   262,   203,
     142,   205,     5,   207,     5,    55,   210,   216,     5,     5,
     216,   216,    14,     5,    16,   279,    40,   173,    42,    43,
      44,    45,    46,    47,    26,    27,    28,    29,   173,    31,
      32,   214,     5,   237,   238,   142,   215,   250,   242,   243,
     244,   216,     5,   168,   142,   249,   141,   251,   252,   253,
     254,   176,   141,   236,     5,   259,   260,   261,   262,   142,
      84,     5,   276,   132,   141,     5,    90,     5,     5,    93,
       5,     5,     5,   132,    76,   279,   132,   141,   203,     5,
     205,   141,   207,     5,     4,   210,    88,    89,   173,   272,
     273,   274,   275,   276,   277,    40,     5,    42,    43,    44,
      45,    46,    47,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   237,   238,   132,   173,     5,   242,   243,   244,
     141,     5,     5,     5,   249,     5,   251,   252,   253,   254,
       5,   142,   216,     5,   259,   260,   261,   262,   132,    84,
       5,   141,   141,   141,   168,    90,     5,     5,    93,     5,
     132,   132,   176,     5,   279,   132,   177,     5,   179,   180,
     181,   182,   141,   216,     5,     3,     5,   216,     5,   190,
       5,   192,   193,   194,     5,     5,     5,     5,     5,   203,
       5,   205,     5,   207,   163,   164,   210,   221,   222,   223,
     224,   225,   226,   227,     5,   229,   175,     5,   177,   178,
     179,   180,   181,   589,   590,   591,   272,   132,   201,   133,
     141,   190,   191,   237,   238,   132,   602,   132,   242,   243,
     244,   133,     5,   168,    94,   249,     5,   251,   252,   253,
     254,   176,     5,     5,     5,   259,   260,   261,   262,    72,
      73,    74,    75,    76,    77,    78,    79,   633,   634,   635,
       5,   141,   638,     5,   640,   279,     5,     5,   203,   132,
     205,     5,   207,   132,   141,   210,   652,   653,   132,     5,
     656,    72,    73,    74,    75,    76,    77,    78,    79,    72,
      73,    74,    75,    76,    77,    78,    79,   141,   141,     5,
     141,   141,   237,   238,   141,   141,   141,   242,   243,   244,
       5,   141,     5,   219,   249,   141,   251,   252,   253,   254,
     142,     5,    55,     5,   259,   260,   261,   262,    72,    73,
      74,    75,    76,    77,    78,    79,    72,    73,    74,    75,
      76,    77,    78,    79,   141,   721,   722,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,    72,    73,    74,    75,    76,    77,    78,
      79,   141,     5,   769,   142,   142,   772,    72,    73,    74,
      75,    76,    77,    78,    79,    72,    73,    74,    75,    76,
      77,    78,    79,    72,    73,    74,    75,    76,    77,    78,
      79,    72,    73,    74,    75,    76,    77,    78,    79,   142,
     142,   142,   142,   142,   142,   142,     5,     5,     5,     5,
      12,   102,   336,   841,   516,    84,   483,   799,    75,    75,
     841,   841,  1156,   841,  1019,  1147,  1015,    77,   610,   564,
       1,   604,   339,   607,   841,   407,   432,   472,   755,  1169,
     155,    -1,   442
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     7,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   285,   286,   287,   306,   307,   308,   310,   311,   312,
     313,   316,   317,   318,   319,   320,   321,   322,   328,   338,
     339,   344,   366,   367,   368,   369,   370,   371,   372,   373,
     374,     8,    10,    12,    13,    17,    18,    29,    51,    52,
      59,    61,    70,    85,    87,   187,   200,   206,   271,   449,
     139,   139,   139,   139,   139,   139,   139,   139,   139,     0,
     287,   288,   290,   292,   294,   296,   298,   300,   302,   304,
      11,   133,   141,   132,   340,   341,   345,    19,   278,   133,
     133,   278,   141,   133,   134,   278,    71,   188,   189,   198,
     199,   265,   323,   324,    87,   240,   278,   453,    70,    73,
     239,    73,    73,    73,    16,    73,    73,    16,    39,     3,
      71,    72,    86,    92,    94,    95,   183,   187,   195,   197,
     289,   375,   376,   377,   385,   388,   391,   430,   431,   432,
     433,   445,   448,   449,   450,   456,   457,   458,   459,   460,
     464,   511,   512,   513,     3,   241,   291,   375,   376,   377,
     430,   445,   448,   456,   457,   458,   459,   460,   484,   498,
     507,   508,   510,   511,   513,     3,   293,   375,   376,   377,
     430,   445,   448,   456,   457,   458,   459,   460,   500,   501,
     502,   503,   504,   505,   507,   511,   513,     3,   295,   375,
     376,   377,   430,   445,   448,   456,   457,   458,   459,   460,
     484,   507,   511,   513,     3,   297,   375,   376,   377,   385,
     388,   394,   445,   448,   456,   457,   458,   459,   460,     3,
     299,   375,   376,   377,   445,   448,   456,   457,   458,   459,
     460,   514,   515,   516,   517,   518,     3,   301,   375,   376,
     377,   433,   445,   448,   456,   457,   458,   459,   460,   467,
     303,   375,   376,   377,   430,   445,   448,   456,   457,   458,
     459,   460,   484,   507,   511,   513,     3,   305,   375,   376,
     377,   445,   448,   456,   457,   458,   459,   460,   463,     9,
      71,   309,    76,   342,    90,   341,   442,    14,    16,    26,
      27,    28,    29,    31,    32,    76,    88,    89,   329,   346,
     347,   348,   349,   350,   351,   354,   355,   356,   357,   358,
     330,   314,   230,   231,   232,   233,   506,   135,   136,   137,
     138,   454,   455,   133,   141,   325,   324,   263,   327,   278,
     278,    40,    42,    43,    44,    45,    46,    47,    84,    90,
      93,   168,   176,   203,   205,   207,   210,   237,   238,   242,
     243,   244,   249,   251,   252,   253,   254,   259,   260,   261,
     262,   451,   452,    57,   520,   133,   133,   132,   133,   132,
     133,   133,   133,   132,   133,   132,   133,   378,   380,   132,
     132,     6,   141,   163,   164,   175,   177,   178,   179,   180,
     181,   190,   191,   214,   240,   243,   252,   465,   466,   470,
     474,   476,   477,   478,   479,   480,   481,   378,   378,   134,
     378,   141,   268,   268,   184,   185,   186,    71,   188,   189,
     140,   139,   461,   462,   240,   278,   453,     6,   210,   211,
     212,   213,   214,   238,   240,   259,   483,   509,   240,   259,
     509,     6,   171,   172,   174,   214,   234,   235,   214,     6,
       6,    47,    48,    49,    50,   214,   177,   182,   190,   192,
     193,   194,   468,   469,   471,   472,   473,   475,   478,   168,
     214,   132,    25,   141,    35,   208,   209,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   329,   334,   336,   337,
     343,   382,   383,   141,    75,   384,    21,    22,    24,   132,
     133,   281,   132,   133,    89,    89,   278,   133,   141,   133,
      27,    28,    26,    30,    31,    33,    34,    36,    37,   170,
     279,   331,    60,    62,    63,    64,    65,    66,    67,    68,
      69,   279,   315,   266,   266,   279,   455,   199,    90,   326,
     329,   334,   336,   337,   327,   264,   454,   451,   279,   452,
     141,    90,   203,   205,   379,   380,   381,   441,    74,    88,
     203,   204,   205,   258,   397,   399,    92,   214,   272,   273,
     274,   275,   276,   277,   485,   485,   171,   172,   485,   485,
     485,   485,   260,   261,   252,   485,   141,   493,   494,   495,
     466,   495,   485,    90,   379,   439,    90,   379,   438,    90,
     379,   440,    55,   462,   278,   451,   520,    22,    23,   237,
     499,   237,   238,   483,   499,   485,   276,   277,   447,   485,
     239,   447,   239,   485,   485,   485,   262,   236,   485,   236,
     485,   246,   247,   248,   249,    40,   485,   485,   485,    48,
      49,    40,   485,   485,   469,   495,   485,   485,   168,   141,
     342,    93,   132,   134,   132,   132,   216,   132,   133,   133,
     133,   280,   359,   132,   330,   352,   280,   280,   280,   280,
     280,   280,   280,   280,   280,   280,   280,   280,   280,   280,
     280,   280,   280,   141,   141,   279,   279,   453,    55,   141,
     132,   141,   132,   141,   381,   441,   132,   133,   132,   141,
     132,   141,   132,   141,   265,    76,   398,   392,   141,   141,
     141,   485,   485,   141,   153,   482,   482,   482,   482,   495,
     495,   495,   141,    55,   141,     5,     5,   482,   141,   439,
     141,   438,   141,   440,   451,   279,   141,    93,   495,   495,
     495,    93,   141,   132,   133,   141,   132,   133,   132,   133,
     132,   133,   141,   482,   141,   482,   141,   482,   495,   485,
     141,   482,   485,   482,   395,   395,   395,    79,   519,   495,
     141,   141,   141,   485,   485,   495,   482,   482,     5,   482,
     141,   495,    22,    23,   276,   335,   360,   361,   362,   132,
     132,   363,   364,    20,   365,   279,   203,   205,   237,   353,
     133,   132,   133,    14,    15,    27,    28,   133,   133,   336,
     141,   141,   141,   141,   141,   141,   141,   141,   141,   216,
     453,   520,   216,   495,   495,   495,   495,   495,   495,   389,
     141,   386,    53,    54,    79,    83,    90,    91,   393,   401,
     405,   406,   443,   444,   495,    55,   141,   482,   141,   482,
     142,   506,   142,   506,   142,   142,     5,     5,     5,   216,
     217,   218,   219,   220,   486,    55,    71,    72,    85,    92,
     244,   245,   490,   491,   491,   216,   216,   216,   279,   453,
     495,    54,   495,     5,     5,     5,   495,   506,   495,   495,
     486,   495,   495,   173,   506,   173,   506,   215,   216,     5,
     141,   482,   495,   142,   482,   142,   506,    16,    56,    90,
     238,   396,   434,   435,   436,   437,   495,   495,   495,   250,
     395,     5,   142,    41,   506,    41,   506,   141,   141,     5,
     142,   506,   142,   506,   491,   142,   495,     5,   335,   335,
     132,   363,   363,   363,   365,   364,   132,   141,   132,   141,
     141,   506,   506,   506,   506,   215,   216,   215,   216,   215,
     216,   215,   216,   215,   216,   520,     5,     5,     5,     5,
       5,     5,    35,   259,   329,   332,   334,   390,   443,   444,
     446,   495,    16,    77,    78,   329,   332,   334,   387,   400,
     401,   404,   405,   406,   443,   444,   446,   495,   132,   132,
      80,    81,    82,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   141,
     141,     5,     5,   173,   506,   173,   506,   491,   491,   491,
     495,   378,     4,   497,   497,   453,   520,     5,   132,     5,
     491,   491,   491,     5,   495,     5,     5,   495,     5,     5,
     495,   216,   488,   495,   488,   495,   495,   491,   495,   142,
       5,   495,   142,   506,   495,   495,   132,   141,   141,   141,
       5,     5,     5,   495,   491,   495,   488,   488,   488,   488,
      41,   506,    41,   506,   491,   497,     5,   491,   132,   132,
     491,   491,   491,   491,   491,   491,    38,   447,     5,   132,
       5,   402,   417,   417,    73,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   382,   383,   428,   429,   409,
     409,   411,    74,   169,   170,   196,   407,   408,   415,   426,
     216,   491,    90,   491,   488,   488,   497,     5,    58,   379,
     489,     3,   520,   491,   495,   491,   497,   491,     5,   491,
     491,     5,   491,   491,     5,   495,     5,   495,     5,     5,
       5,   495,   491,     5,   495,   495,     5,     5,   216,   491,
     491,   491,     5,   497,     5,   495,   495,   495,   495,   141,
     217,   218,   219,   487,   141,   487,   141,   487,   141,   487,
     497,   491,   497,   497,   497,   497,   497,   497,   272,   333,
     132,   491,   491,   336,   337,   403,    93,   165,   168,   196,
     202,   282,   382,   383,   418,   419,   420,   421,   422,   423,
     133,   485,   485,   485,   485,   485,   485,   485,   485,   485,
     485,   429,   382,   383,   410,   382,   383,   412,   132,   132,
     141,   133,   408,   267,   270,   413,   414,   416,   201,   425,
     427,   497,   491,    94,   489,   255,   256,   257,   497,     5,
     497,   491,   491,   491,     5,   491,     5,   491,   491,   491,
       5,   497,   491,     5,     5,   491,   491,   497,   497,   497,
     491,   491,     5,     5,     5,     5,   487,   495,   487,   495,
     487,   495,   487,   495,   497,   141,   497,   497,   132,   166,
     167,   485,   132,   133,   132,   424,   141,   141,   141,   141,
     141,   141,   141,   141,   141,   141,   132,   134,   141,   132,
     497,    55,   141,   493,   494,   496,   496,   496,   491,   497,
     497,   497,   491,   497,   491,   497,   497,   497,   491,   497,
     491,   491,   497,   497,   497,   497,   491,   491,   491,   491,
     495,     5,   495,     5,   495,     5,   495,     5,   219,   141,
     269,   283,   142,   142,   142,   142,   142,   142,   142,   142,
     142,   142,    55,     5,     5,     5,   497,   497,   497,   497,
     497,   497,   497,   497,   497,   497,     5,   491,     5,   491,
       5,   491,     5,   491,   490,   492,   492,   492,   491,   497,
     491,   497,   491,   497,   491,   497,   497,   497,   497,   497
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   284,   285,   285,   286,   286,   287,   287,   287,   287,
     287,   287,   287,   287,   287,   287,   287,   287,   287,   287,
     287,   287,   287,   287,   287,   287,   287,   287,   287,   287,
     287,   287,   287,   288,   288,   289,   289,   289,   289,   289,
     289,   289,   289,   289,   289,   289,   289,   289,   289,   289,
     289,   289,   289,   289,   289,   289,   290,   290,   291,   291,
     291,   291,   291,   291,   291,   291,   291,   291,   291,   291,
     291,   291,   291,   291,   291,   291,   292,   292,   293,   293,
     293,   293,   293,   293,   293,   293,   293,   293,   293,   293,
     293,   293,   293,   293,   293,   293,   293,   293,   294,   294,
     295,   295,   295,   295,   295,   295,   295,   295,   295,   295,
     295,   295,   295,   295,   295,   296,   296,   297,   297,   297,
     297,   297,   297,   297,   297,   297,   297,   297,   297,   297,
     298,   298,   299,   299,   299,   299,   299,   299,   299,   299,
     299,   299,   299,   299,   299,   299,   299,   300,   300,   301,
     301,   301,   301,   301,   301,   301,   301,   301,   301,   301,
     301,   302,   302,   303,   303,   303,   303,   303,   303,   303,
     303,   303,   303,   303,   303,   303,   303,   303,   304,   304,
     305,   305,   305,   305,   305,   305,   305,   305,   305,   305,
     305,   306,   306,   306,   307,   308,   309,   309,   310,   311,
     311,   311,   312,   313,   314,   314,   315,   315,   315,   315,
     315,   315,   315,   315,   315,   315,   315,   315,   315,   315,
     316,   317,   317,   317,   318,   318,   318,   319,   320,   321,
     322,   323,   323,   324,   325,   325,   326,   326,   326,   326,
     326,   327,   327,   328,   329,   329,   330,   330,   331,   331,
     331,   331,   331,   331,   331,   331,   331,   331,   332,   333,
     333,   334,   334,   334,   335,   335,   336,   336,   336,   336,
     336,   336,   336,   336,   337,   338,   339,   340,   340,   341,
     341,   342,   342,   343,   343,   343,   343,   343,   343,   344,
     345,   345,   346,   346,   346,   346,   346,   346,   346,   346,
     346,   347,   348,   349,   350,   351,   352,   352,   353,   353,
     353,   353,   353,   354,   354,   355,   355,   356,   356,   357,
     358,   358,   358,   358,   358,   358,   359,   358,   360,   358,
     361,   358,   362,   358,   358,   363,   363,   364,   365,   365,
     366,   366,   366,   366,   367,   368,   368,   369,   370,   371,
     371,   372,   373,   374,   374,   375,   375,   376,   376,   377,
     377,   378,   378,   379,   379,   380,   380,   381,   381,   381,
     381,   382,   382,   383,   384,   384,   385,   386,   386,   387,
     387,   387,   387,   387,   387,   387,   387,   387,   387,   387,
     388,   389,   389,   390,   390,   390,   390,   390,   390,   391,
     392,   392,   393,   393,   393,   393,   393,   394,   394,   394,
     394,   395,   395,   396,   396,   396,   396,   397,   397,   398,
     399,   400,   400,   401,   401,   401,   402,   402,   403,   403,
     404,   405,   405,   405,   405,   405,   405,   405,   405,   405,
     405,   405,   405,   405,   405,   405,   405,   405,   405,   405,
     405,   405,   405,   405,   405,   405,   405,   405,   405,   405,
     405,   405,   405,   405,   405,   405,   405,   406,   406,   407,
     407,   408,   408,   408,   408,   409,   409,   410,   410,   411,
     411,   412,   412,   413,   413,   414,   415,   415,   416,   416,
     417,   417,   418,   418,   418,   418,   418,   418,   418,   418,
     419,   420,   420,   421,   421,   422,   423,   424,   424,   425,
     426,   426,   427,   428,   428,   429,   429,   429,   429,   429,
     429,   429,   429,   429,   429,   429,   429,   429,   430,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   438,   439,
     439,   440,   440,   441,   441,   442,   442,   443,   444,   445,
     445,   446,   447,   447,   448,   448,   448,   448,   449,   450,
     451,   451,   452,   452,   452,   452,   452,   452,   452,   452,
     452,   452,   452,   452,   452,   452,   452,   452,   452,   452,
     452,   452,   452,   452,   452,   452,   452,   452,   452,   452,
     452,   452,   453,   453,   454,   454,   455,   455,   455,   455,
     456,   456,   456,   457,   457,   457,   458,   458,   458,   459,
     460,   461,   461,   462,   463,   463,   464,   465,   465,   466,
     466,   466,   466,   466,   466,   466,   467,   468,   468,   469,
     469,   469,   469,   470,   470,   471,   472,   472,   472,   472,
     473,   473,   474,   474,   474,   474,   475,   475,   476,   477,
     478,   479,   479,   479,   480,   480,   481,   481,   482,   482,
     483,   483,   483,   483,   484,   484,   485,   485,   485,   485,
     485,   485,   485,   485,   486,   486,   486,   486,   486,   486,
     487,   487,   487,   488,   488,   489,   489,   489,   490,   490,
     490,   490,   490,   490,   490,   491,   492,   493,   494,   495,
     495,   495,   496,   496,   496,   497,   497,   497,   497,   498,
     498,   498,   499,   499,   499,   500,   500,   500,   500,   501,
     501,   501,   501,   502,   502,   503,   503,   504,   504,   505,
     506,   506,   506,   506,   506,   507,   507,   508,   508,   508,
     508,   508,   508,   508,   508,   509,   509,   510,   510,   511,
     511,   512,   512,   513,   513,   514,   515,   516,   517,   517,
     517,   517,   517,   517,   518,   518,   518,   518,   518,   518,
     519,   520,   520,   520
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     1,     1,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     0,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     0,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     0,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     4,     7,     8,     4,     3,     0,     3,     2,     3,
       3,     3,     4,     5,     0,     2,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       2,     3,     3,     5,     4,     6,     4,     3,     3,     3,
       3,     2,     3,     2,     0,     2,     3,     1,     1,     1,
       1,     0,     2,     5,     1,     4,     0,     2,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     5,     0,
       1,     4,     5,     5,     0,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     5,     5,     1,     2,     2,
       4,     0,     2,     1,     1,     1,     1,     1,     1,     3,
       0,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     1,     2,     3,     0,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     1,     1,     2,
       5,     4,     2,     3,     3,     3,     0,     4,     0,     5,
       0,     5,     0,     5,     2,     1,     2,     1,     0,     1,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     2,     4,     5,     6,     3,     4,     3,     4,     3,
       4,     1,     2,     1,     2,     1,     1,     2,     2,     2,
       2,     2,     2,     2,     0,     2,     9,     0,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       9,     0,     2,     1,     1,     1,     1,     1,     1,     8,
       0,     2,     1,     1,     1,     1,     1,     9,     8,     8,
       8,     0,     2,     1,     1,     1,     1,     0,     2,     2,
       2,     1,     1,     2,     3,     2,     0,     2,     1,     1,
       2,     3,     2,     2,     2,     2,     2,     3,     3,     2,
       2,     2,     2,     2,     2,     3,     3,     2,     2,     2,
       2,     2,     2,     3,     3,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     3,     2,     3,     2,     2,     1,
       2,     2,     2,     2,     2,     0,     2,     1,     1,     0,
       2,     1,     1,     2,     2,     2,     0,     2,     1,     1,
       0,     2,     1,     1,     1,     1,     1,     1,     1,     3,
       3,     2,     2,     2,     2,     2,     2,     0,     2,     2,
       0,     2,     1,     1,     2,     1,     1,     2,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     7,     6,
       6,     6,     9,     2,     2,     3,     2,     0,     3,     0,
       3,     0,     3,     0,     3,     0,     3,     3,     2,     7,
       7,     3,     1,     1,     3,     6,     7,     1,     2,     2,
       1,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     4,     1,     2,     2,     2,     1,     1,
       3,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     1,     2,     1,     8,     6,     6,     1,     2,     1,
       1,     1,     1,     1,     1,     1,     6,     1,     2,     1,
       1,     1,     1,     4,     4,     4,     1,     1,     1,     1,
       4,     4,     4,     4,     4,     4,     4,     4,     3,     3,
       3,     1,     1,     1,     6,     5,     6,     5,     1,     1,
       1,     1,     1,     1,     9,     6,     0,     1,     1,     1,
       1,     1,     1,     1,     0,     1,     1,     1,     1,     1,
       1,     1,     1,     0,     1,     0,     3,     4,     1,     3,
       4,     1,     1,     1,     1,     1,     1,     2,     3,     0,
       1,     1,     0,     1,     1,     0,     6,     6,     6,     8,
      10,     7,     0,     1,     1,     8,     9,     9,    10,     9,
       9,    10,    10,    10,     9,    10,     9,     9,     9,     6,
       0,     1,     1,     1,     1,     8,     7,     7,     7,     4,
       4,     7,     7,     4,     4,     0,     1,     9,     6,     8,
       8,     8,     8,     8,     8,     7,     7,     9,    10,    11,
      12,    10,    11,    12,    10,    11,    12,    10,    11,    12,
       2,     0,     2,     3
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 191:
#line 590 "src/p.y" /* yacc.c:1646  */
    {
                        mailset.events = Event_All;
                        addmail((yyvsp[-2].string), &mailset, &Run.maillist);
                  }
#line 3226 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 192:
#line 594 "src/p.y" /* yacc.c:1646  */
    {
                        addmail((yyvsp[-5].string), &mailset, &Run.maillist);
                  }
#line 3234 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 193:
#line 597 "src/p.y" /* yacc.c:1646  */
    {
                        mailset.events = ~mailset.events;
                        addmail((yyvsp[-6].string), &mailset, &Run.maillist);
                  }
#line 3243 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 194:
#line 603 "src/p.y" /* yacc.c:1646  */
    {
                        if (! (Run.flags & Run_Daemon) || ihp.daemon) {
                                ihp.daemon     = true;
                                Run.flags      |= Run_Daemon;
                                Run.polltime   = (yyvsp[-1].number);
                                Run.startdelay = (yyvsp[0].number);
                        }
                  }
#line 3256 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 195:
#line 613 "src/p.y" /* yacc.c:1646  */
    {
                        Run.flags |= Run_Batch;
                  }
#line 3264 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 196:
#line 618 "src/p.y" /* yacc.c:1646  */
    {
                        (yyval.number) = START_DELAY;
                  }
#line 3272 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 197:
#line 621 "src/p.y" /* yacc.c:1646  */
    {
                        (yyval.number) = (yyvsp[0].number);
                  }
#line 3280 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 198:
#line 626 "src/p.y" /* yacc.c:1646  */
    {
                        Run.flags |= Run_Foreground;
                  }
#line 3288 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 199:
#line 631 "src/p.y" /* yacc.c:1646  */
    {
                        Run.onreboot = Onreboot_Start;
                  }
#line 3296 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 200:
#line 634 "src/p.y" /* yacc.c:1646  */
    {
                        Run.onreboot = Onreboot_Nostart;
                  }
#line 3304 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 201:
#line 637 "src/p.y" /* yacc.c:1646  */
    {
                        Run.onreboot = Onreboot_Laststate;
                  }
#line 3312 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 202:
#line 642 "src/p.y" /* yacc.c:1646  */
    {
                        // Note: deprecated (replaced by "set limits" statement's "sendExpectBuffer" option)
                        Run.limits.sendExpectBuffer = (yyvsp[-1].number) * (yyvsp[0].number);
                  }
#line 3321 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 206:
#line 655 "src/p.y" /* yacc.c:1646  */
    {
                        Run.limits.sendExpectBuffer = (yyvsp[-1].number) * (yyvsp[0].number);
                  }
#line 3329 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 207:
#line 658 "src/p.y" /* yacc.c:1646  */
    {
                        Run.limits.fileContentBuffer = (yyvsp[-1].number) * (yyvsp[0].number);
                  }
#line 3337 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 208:
#line 661 "src/p.y" /* yacc.c:1646  */
    {
                        Run.limits.httpContentBuffer = (yyvsp[-1].number) * (yyvsp[0].number);
                  }
#line 3345 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 209:
#line 664 "src/p.y" /* yacc.c:1646  */
    {
                        Run.limits.programOutput = (yyvsp[-1].number) * (yyvsp[0].number);
                  }
#line 3353 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 210:
#line 667 "src/p.y" /* yacc.c:1646  */
    {
                        Run.limits.networkTimeout = (yyvsp[-1].number);
                  }
#line 3361 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 211:
#line 670 "src/p.y" /* yacc.c:1646  */
    {
                        Run.limits.networkTimeout = (yyvsp[-1].number) * 1000;
                  }
#line 3369 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 212:
#line 673 "src/p.y" /* yacc.c:1646  */
    {
                        Run.limits.programTimeout = (yyvsp[-1].number);
                  }
#line 3377 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 213:
#line 676 "src/p.y" /* yacc.c:1646  */
    {
                        Run.limits.programTimeout = (yyvsp[-1].number) * 1000;
                  }
#line 3385 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 214:
#line 679 "src/p.y" /* yacc.c:1646  */
    {
                        Run.limits.stopTimeout = (yyvsp[-1].number);
                  }
#line 3393 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 215:
#line 682 "src/p.y" /* yacc.c:1646  */
    {
                        Run.limits.stopTimeout = (yyvsp[-1].number) * 1000;
                  }
#line 3401 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 216:
#line 685 "src/p.y" /* yacc.c:1646  */
    {
                        Run.limits.startTimeout = (yyvsp[-1].number);
                  }
#line 3409 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 217:
#line 688 "src/p.y" /* yacc.c:1646  */
    {
                        Run.limits.startTimeout = (yyvsp[-1].number) * 1000;
                  }
#line 3417 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 218:
#line 691 "src/p.y" /* yacc.c:1646  */
    {
                        Run.limits.restartTimeout = (yyvsp[-1].number);
                  }
#line 3425 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 219:
#line 694 "src/p.y" /* yacc.c:1646  */
    {
                        Run.limits.restartTimeout = (yyvsp[-1].number) * 1000;
                  }
#line 3433 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 220:
#line 699 "src/p.y" /* yacc.c:1646  */
    {
                        Run.flags |= Run_FipsEnabled;
                  }
#line 3441 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 221:
#line 704 "src/p.y" /* yacc.c:1646  */
    {
                        if (! Run.files.log || ihp.logfile) {
                                ihp.logfile = true;
                                setlogfile((yyvsp[0].string));
                                Run.flags &= ~Run_UseSyslog;
                                Run.flags |= Run_Log;
                        }
                  }
#line 3454 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 222:
#line 712 "src/p.y" /* yacc.c:1646  */
    {
                        setsyslog(NULL);
                  }
#line 3462 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 223:
#line 715 "src/p.y" /* yacc.c:1646  */
    {
                        setsyslog((yyvsp[0].string)); FREE((yyvsp[0].string));
                  }
#line 3470 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 224:
#line 720 "src/p.y" /* yacc.c:1646  */
    {
                        Run.eventlist_dir = (yyvsp[0].string);
                  }
#line 3478 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 225:
#line 723 "src/p.y" /* yacc.c:1646  */
    {
                        Run.eventlist_dir = (yyvsp[-2].string);
                        Run.eventlist_slots = (yyvsp[0].number);
                  }
#line 3487 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 226:
#line 727 "src/p.y" /* yacc.c:1646  */
    {
                        Run.eventlist_dir = Str_dup(MYEVENTLISTBASE);
                        Run.eventlist_slots = (yyvsp[0].number);
                  }
#line 3496 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 227:
#line 733 "src/p.y" /* yacc.c:1646  */
    {
                        Run.files.id = (yyvsp[0].string);
                  }
#line 3504 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 228:
#line 738 "src/p.y" /* yacc.c:1646  */
    {
                        Run.files.state = (yyvsp[0].string);
                  }
#line 3512 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 229:
#line 743 "src/p.y" /* yacc.c:1646  */
    {
                        if (! Run.files.pid || ihp.pidfile) {
                                ihp.pidfile = true;
                                setpidfile((yyvsp[0].string));
                        }
                  }
#line 3523 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 233:
#line 758 "src/p.y" /* yacc.c:1646  */
    {
                        mmonitset.url = (yyvsp[-1].url);
                        addmmonit(&mmonitset);
                  }
#line 3532 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 236:
#line 768 "src/p.y" /* yacc.c:1646  */
    {
                        mmonitset.timeout = (yyvsp[-1].number) * 1000; // net timeout is in milliseconds internally
                  }
#line 3540 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 242:
#line 778 "src/p.y" /* yacc.c:1646  */
    {
                        Run.flags &= ~Run_MmonitCredentials;
                  }
#line 3548 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 243:
#line 783 "src/p.y" /* yacc.c:1646  */
    {
                        _setSSLOptions(&(Run.ssl));
                  }
#line 3556 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 244:
#line 788 "src/p.y" /* yacc.c:1646  */
    {
                        sslset.flags = SSL_Enabled;
                  }
#line 3564 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 248:
#line 798 "src/p.y" /* yacc.c:1646  */
    {
                        sslset.flags = SSL_Enabled;
                        sslset.verify = true;
                  }
#line 3573 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 249:
#line 802 "src/p.y" /* yacc.c:1646  */
    {
                        sslset.flags = SSL_Enabled;
                        sslset.verify = false;
                  }
#line 3582 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 250:
#line 806 "src/p.y" /* yacc.c:1646  */
    {
                        sslset.flags = SSL_Enabled;
                        sslset.allowSelfSigned = true;
                  }
#line 3591 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 251:
#line 810 "src/p.y" /* yacc.c:1646  */
    {
                        sslset.flags = SSL_Enabled;
                        sslset.allowSelfSigned = false;
                  }
#line 3600 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 252:
#line 814 "src/p.y" /* yacc.c:1646  */
    {
                        sslset.flags = SSL_Enabled;
                  }
#line 3608 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 253:
#line 817 "src/p.y" /* yacc.c:1646  */
    {
                        FREE(sslset.ciphers);
                        sslset.ciphers = (yyvsp[0].string);
                  }
#line 3617 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 254:
#line 821 "src/p.y" /* yacc.c:1646  */
    {
                        _setPEM(&(sslset.pemfile), (yyvsp[0].string), "SSL server PEM file", true);
                  }
#line 3625 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 255:
#line 824 "src/p.y" /* yacc.c:1646  */
    {
                        _setPEM(&(sslset.clientpemfile), (yyvsp[0].string), "SSL client PEM file", true);
                  }
#line 3633 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 256:
#line 827 "src/p.y" /* yacc.c:1646  */
    {
                        _setPEM(&(sslset.CACertificateFile), (yyvsp[0].string), "SSL CA certificates file", true);
                  }
#line 3641 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 257:
#line 830 "src/p.y" /* yacc.c:1646  */
    {
                        _setPEM(&(sslset.CACertificatePath), (yyvsp[0].string), "SSL CA certificates directory", false);
                  }
#line 3649 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 258:
#line 835 "src/p.y" /* yacc.c:1646  */
    {
                        sslset.flags = SSL_Enabled;
                        portset.target.net.ssl.certificate.minimumDays = (yyvsp[-1].number);
                  }
#line 3658 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 261:
#line 845 "src/p.y" /* yacc.c:1646  */
    {
                        sslset.flags = SSL_Enabled;
                        sslset.checksum = (yyvsp[0].string);
                        switch (cleanup_hash_string(sslset.checksum)) {
                                case 32:
                                        sslset.checksumType = Hash_Md5;
                                        break;
                                case 40:
                                        sslset.checksumType = Hash_Sha1;
                                        break;
                                default:
                                        yyerror2("Unknown checksum type: [%s] is not MD5 nor SHA1", sslset.checksum);
                        }
                  }
#line 3677 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 262:
#line 859 "src/p.y" /* yacc.c:1646  */
    {
                        sslset.flags = SSL_Enabled;
                        sslset.checksum = (yyvsp[0].string);
                        if (cleanup_hash_string(sslset.checksum) != 32)
                                yyerror2("Unknown checksum type: [%s] is not MD5", sslset.checksum);
                        sslset.checksumType = Hash_Md5;
                  }
#line 3689 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 263:
#line 866 "src/p.y" /* yacc.c:1646  */
    {
                        sslset.flags = SSL_Enabled;
                        sslset.checksum = (yyvsp[0].string);
                        if (cleanup_hash_string(sslset.checksum) != 40)
                                yyerror2("Unknown checksum type: [%s] is not SHA1", sslset.checksum);
                        sslset.checksumType = Hash_Sha1;
                  }
#line 3701 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 266:
#line 879 "src/p.y" /* yacc.c:1646  */
    {
                        sslset.flags = SSL_Enabled;
                        sslset.version = SSL_V2;
                  }
#line 3710 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 267:
#line 883 "src/p.y" /* yacc.c:1646  */
    {
                        sslset.flags = SSL_Enabled;
                        sslset.version = SSL_V3;
                  }
#line 3719 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 268:
#line 887 "src/p.y" /* yacc.c:1646  */
    {
                        sslset.flags = SSL_Enabled;
                        sslset.version = SSL_TLSV1;
                  }
#line 3728 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 269:
#line 892 "src/p.y" /* yacc.c:1646  */
    {
#ifndef HAVE_TLSV1_1
                        yyerror("Your SSL Library does not support TLS version 1.1");
#endif
                        sslset.flags = SSL_Enabled;
                        sslset.version = SSL_TLSV11;
                }
#line 3740 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 270:
#line 900 "src/p.y" /* yacc.c:1646  */
    {
#ifndef HAVE_TLSV1_2
                        yyerror("Your SSL Library does not support TLS version 1.2");
#endif
                        sslset.flags = SSL_Enabled;
                        sslset.version = SSL_TLSV12;
                }
#line 3752 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 271:
#line 908 "src/p.y" /* yacc.c:1646  */
    {
#ifndef HAVE_TLSV1_3
                        yyerror("Your SSL Library does not support TLS version 1.3");
#endif
                        sslset.flags = SSL_Enabled;
                        sslset.version = SSL_TLSV13;
                }
#line 3764 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 272:
#line 916 "src/p.y" /* yacc.c:1646  */
    {
                        sslset.flags = SSL_Enabled;
                        sslset.version = SSL_Auto;
                  }
#line 3773 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 273:
#line 920 "src/p.y" /* yacc.c:1646  */
    {
                        sslset.flags = SSL_Enabled;
                        sslset.version = SSL_Auto;
                  }
#line 3782 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 274:
#line 926 "src/p.y" /* yacc.c:1646  */
    { // Backward compatibility
                        sslset.flags = SSL_Enabled;
                        sslset.checksum = (yyvsp[0].string);
                        if (cleanup_hash_string(sslset.checksum) != 32)
                                yyerror2("Unknown checksum type: [%s] is not MD5", sslset.checksum);
                        sslset.checksumType = Hash_Md5;
                  }
#line 3794 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 275:
#line 935 "src/p.y" /* yacc.c:1646  */
    {
                        if (((yyvsp[-1].number)) > SMTP_TIMEOUT)
                                Run.mailserver_timeout = (yyvsp[-1].number);
                        Run.mail_hostname = (yyvsp[0].string);
                  }
#line 3804 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 276:
#line 942 "src/p.y" /* yacc.c:1646  */
    {
                        if (mailset.from) {
                                Run.MailFormat.from = mailset.from;
                        } else {
                                Run.MailFormat.from = Address_new();
                                Run.MailFormat.from->address = Str_dup(ALERT_FROM);
                        }
                        if (mailset.replyto)
                                Run.MailFormat.replyto = mailset.replyto;
                        Run.MailFormat.subject = mailset.subject ?  mailset.subject : Str_dup(ALERT_SUBJECT);
                        Run.MailFormat.message = mailset.message ?  mailset.message : Str_dup(ALERT_MESSAGE);
                        reset_mailset();
                  }
#line 3822 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 279:
#line 961 "src/p.y" /* yacc.c:1646  */
    {
                        /* Restore the current text overriden by lookahead */
                        FREE(argyytext);
                        argyytext = Str_dup((yyvsp[-1].string));

                        mailserverset.host = (yyvsp[-1].string);
                        mailserverset.port = PORT_SMTP;
                        addmailserver(&mailserverset);
                  }
#line 3836 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 280:
#line 970 "src/p.y" /* yacc.c:1646  */
    {
                        /* Restore the current text overriden by lookahead */
                        FREE(argyytext);
                        argyytext = Str_dup((yyvsp[-3].string));

                        mailserverset.host = (yyvsp[-3].string);
                        mailserverset.port = (yyvsp[-1].number);
                        addmailserver(&mailserverset);
                  }
#line 3850 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 283:
#line 985 "src/p.y" /* yacc.c:1646  */
    {
                        mailserverset.username = (yyvsp[0].string);
                  }
#line 3858 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 284:
#line 988 "src/p.y" /* yacc.c:1646  */
    {
                        mailserverset.password = (yyvsp[0].string);
                  }
#line 3866 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 289:
#line 997 "src/p.y" /* yacc.c:1646  */
    {
                        if (sslset.flags & SSL_Enabled) {
#ifdef HAVE_OPENSSL
                                if (! sslset.pemfile) {
                                        yyerror("SSL server PEM file is required (please use ssl pemfile option)");
                                } else if (! file_checkStat(sslset.pemfile, "SSL server PEM file", S_IRWXU)) {
                                        yyerror("SSL server PEM file permissions check failed");
                                } else  {
                                        _setSSLOptions(&(Run.httpd.socket.net.ssl));
                                }
#else
                                yyerror("SSL is not supported");
#endif
                        }
                  }
#line 3886 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 301:
#line 1030 "src/p.y" /* yacc.c:1646  */
    {
                        _setPEM(&(sslset.pemfile), (yyvsp[0].string), "SSL server PEM file", true);
                  }
#line 3894 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 302:
#line 1036 "src/p.y" /* yacc.c:1646  */
    {
                        _setPEM(&(sslset.clientpemfile), (yyvsp[0].string), "SSL client PEM file", true);
                  }
#line 3902 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 303:
#line 1042 "src/p.y" /* yacc.c:1646  */
    {
                        sslset.flags = SSL_Enabled;
                        sslset.allowSelfSigned = true;
                  }
#line 3911 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 304:
#line 1048 "src/p.y" /* yacc.c:1646  */
    {
                        Run.httpd.flags |= Httpd_Net;
                        Run.httpd.socket.net.port = (yyvsp[0].number);
                  }
#line 3920 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 305:
#line 1054 "src/p.y" /* yacc.c:1646  */
    {
                        Run.httpd.flags |= Httpd_Unix;
                        Run.httpd.socket.unix.path = (yyvsp[-1].string);
                  }
#line 3929 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 308:
#line 1064 "src/p.y" /* yacc.c:1646  */
    {
                        Run.httpd.flags |= Httpd_UnixUid;
                        Run.httpd.socket.unix.uid = get_uid((yyvsp[0].string), 0);
                        FREE((yyvsp[0].string));
                    }
#line 3939 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 309:
#line 1069 "src/p.y" /* yacc.c:1646  */
    {
                        Run.httpd.flags |= Httpd_UnixGid;
                        Run.httpd.socket.unix.gid = get_gid((yyvsp[0].string), 0);
                        FREE((yyvsp[0].string));
                    }
#line 3949 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 310:
#line 1074 "src/p.y" /* yacc.c:1646  */
    {
                        Run.httpd.flags |= Httpd_UnixUid;
                        Run.httpd.socket.unix.uid = get_uid(NULL, (yyvsp[0].number));
                    }
#line 3958 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 311:
#line 1078 "src/p.y" /* yacc.c:1646  */
    {
                        Run.httpd.flags |= Httpd_UnixGid;
                        Run.httpd.socket.unix.gid = get_gid(NULL, (yyvsp[0].number));
                    }
#line 3967 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 312:
#line 1082 "src/p.y" /* yacc.c:1646  */
    {
                        Run.httpd.flags |= Httpd_UnixPermission;
                        Run.httpd.socket.unix.permission = check_perm((yyvsp[0].number));
                    }
#line 3976 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 317:
#line 1096 "src/p.y" /* yacc.c:1646  */
    {
                        Run.httpd.flags |= Httpd_Signature;
                  }
#line 3984 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 318:
#line 1099 "src/p.y" /* yacc.c:1646  */
    {
                        Run.httpd.flags &= ~Httpd_Signature;
                  }
#line 3992 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 319:
#line 1104 "src/p.y" /* yacc.c:1646  */
    {
                        Run.httpd.socket.net.address = (yyvsp[0].string);
                  }
#line 4000 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 320:
#line 1109 "src/p.y" /* yacc.c:1646  */
    {
                        addcredentials((yyvsp[-3].string), (yyvsp[-1].string), Digest_Cleartext, (yyvsp[0].number));
                  }
#line 4008 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 321:
#line 1112 "src/p.y" /* yacc.c:1646  */
    {
#ifdef HAVE_LIBPAM
                        addpamauth((yyvsp[-1].string), (yyvsp[0].number));
#else
                        yyerror("PAM is not supported");
                        FREE((yyvsp[-1].string));
#endif
                  }
#line 4021 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 322:
#line 1120 "src/p.y" /* yacc.c:1646  */
    {
                        addhtpasswdentry((yyvsp[0].string), NULL, Digest_Cleartext);
                        FREE((yyvsp[0].string));
                  }
#line 4030 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 323:
#line 1124 "src/p.y" /* yacc.c:1646  */
    {
                        addhtpasswdentry((yyvsp[0].string), NULL, Digest_Cleartext);
                        FREE((yyvsp[0].string));
                  }
#line 4039 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 324:
#line 1128 "src/p.y" /* yacc.c:1646  */
    {
                        addhtpasswdentry((yyvsp[0].string), NULL, Digest_Md5);
                        FREE((yyvsp[0].string));
                  }
#line 4048 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 325:
#line 1132 "src/p.y" /* yacc.c:1646  */
    {
                        addhtpasswdentry((yyvsp[0].string), NULL, Digest_Crypt);
                        FREE((yyvsp[0].string));
                  }
#line 4057 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 326:
#line 1136 "src/p.y" /* yacc.c:1646  */
    {
                        htpasswd_file = (yyvsp[0].string);
                        digesttype = Digest_Cleartext;
                  }
#line 4066 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 327:
#line 1140 "src/p.y" /* yacc.c:1646  */
    {
                        FREE(htpasswd_file);
                  }
#line 4074 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 328:
#line 1143 "src/p.y" /* yacc.c:1646  */
    {
                        htpasswd_file = (yyvsp[0].string);
                        digesttype = Digest_Cleartext;
                  }
#line 4083 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 329:
#line 1147 "src/p.y" /* yacc.c:1646  */
    {
                        FREE(htpasswd_file);
                  }
#line 4091 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 330:
#line 1150 "src/p.y" /* yacc.c:1646  */
    {
                        htpasswd_file = (yyvsp[0].string);
                        digesttype = Digest_Md5;
                  }
#line 4100 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 331:
#line 1154 "src/p.y" /* yacc.c:1646  */
    {
                        FREE(htpasswd_file);
                  }
#line 4108 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 332:
#line 1157 "src/p.y" /* yacc.c:1646  */
    {
                        htpasswd_file = (yyvsp[0].string);
                        digesttype = Digest_Crypt;
                  }
#line 4117 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 333:
#line 1161 "src/p.y" /* yacc.c:1646  */
    {
                        FREE(htpasswd_file);
                  }
#line 4125 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 334:
#line 1164 "src/p.y" /* yacc.c:1646  */
    {
                        if (! Engine_addAllow((yyvsp[0].string)))
                                yywarning2("invalid allow option", (yyvsp[0].string));
                        FREE((yyvsp[0].string));
                  }
#line 4135 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 337:
#line 1175 "src/p.y" /* yacc.c:1646  */
    {
                        addhtpasswdentry(htpasswd_file, (yyvsp[0].string), digesttype);
                        FREE((yyvsp[0].string));
                  }
#line 4144 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 338:
#line 1181 "src/p.y" /* yacc.c:1646  */
    {
                        (yyval.number) = false;
                  }
#line 4152 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 339:
#line 1184 "src/p.y" /* yacc.c:1646  */
    {
                        (yyval.number) = true;
                  }
#line 4160 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 340:
#line 1189 "src/p.y" /* yacc.c:1646  */
    {
                        createservice(Service_Process, (yyvsp[-2].string), (yyvsp[0].string), check_process);
                  }
#line 4168 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 341:
#line 1192 "src/p.y" /* yacc.c:1646  */
    {
                        createservice(Service_Process, (yyvsp[-2].string), (yyvsp[0].string), check_process);
                  }
#line 4176 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 342:
#line 1195 "src/p.y" /* yacc.c:1646  */
    {
                        createservice(Service_Process, (yyvsp[-2].string), (yyvsp[0].string), check_process);
                        matchset.ignore = false;
                        matchset.match_path = NULL;
                        matchset.match_string = Str_dup((yyvsp[0].string));
                        addmatch(&matchset, Action_Ignored, 0);
                  }
#line 4188 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 343:
#line 1202 "src/p.y" /* yacc.c:1646  */
    {
                        createservice(Service_Process, (yyvsp[-2].string), (yyvsp[0].string), check_process);
                        matchset.ignore = false;
                        matchset.match_path = NULL;
                        matchset.match_string = Str_dup((yyvsp[0].string));
                        addmatch(&matchset, Action_Ignored, 0);
                  }
#line 4200 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 344:
#line 1211 "src/p.y" /* yacc.c:1646  */
    {
                        createservice(Service_File, (yyvsp[-2].string), (yyvsp[0].string), check_file);
                  }
#line 4208 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 345:
#line 1216 "src/p.y" /* yacc.c:1646  */
    {
                        createservice(Service_Filesystem, (yyvsp[-2].string), (yyvsp[0].string), check_filesystem);
                  }
#line 4216 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 346:
#line 1219 "src/p.y" /* yacc.c:1646  */
    {
                        createservice(Service_Filesystem, (yyvsp[-2].string), (yyvsp[0].string), check_filesystem);
                  }
#line 4224 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 347:
#line 1224 "src/p.y" /* yacc.c:1646  */
    {
                        createservice(Service_Directory, (yyvsp[-2].string), (yyvsp[0].string), check_directory);
                  }
#line 4232 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 348:
#line 1229 "src/p.y" /* yacc.c:1646  */
    {
                        createservice(Service_Host, (yyvsp[-2].string), (yyvsp[0].string), check_remote_host);
                  }
#line 4240 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 349:
#line 1234 "src/p.y" /* yacc.c:1646  */
    {
                        if (Link_isGetByAddressSupported()) {
                                createservice(Service_Net, (yyvsp[-2].string), (yyvsp[0].string), check_net);
                                current->inf.net->stats = Link_createForAddress((yyvsp[0].string));
                        } else {
                                yyerror("Network monitoring by IP address is not supported on this platform, please use 'check network <foo> with interface <bar>' instead");
                        }
                  }
#line 4253 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 350:
#line 1242 "src/p.y" /* yacc.c:1646  */
    {
                        createservice(Service_Net, (yyvsp[-2].string), (yyvsp[0].string), check_net);
                        current->inf.net->stats = Link_createForInterface((yyvsp[0].string));
                  }
#line 4262 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 351:
#line 1248 "src/p.y" /* yacc.c:1646  */
    {
                        char *servicename = (yyvsp[0].string);
                        if (Str_sub(servicename, "$HOST")) {
                                char hostname[STRLEN];
                                if (gethostname(hostname, sizeof(hostname))) {
                                        LogError("System hostname error -- %s\n", STRERROR);
                                        cfg_errflag++;
                                } else {
                                        Util_replaceString(&servicename, "$HOST", hostname);
                                }
                        }
                        Run.system = createservice(Service_System, servicename, NULL, check_system); // The name given in the 'check system' statement overrides system hostname
                  }
#line 4280 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 352:
#line 1263 "src/p.y" /* yacc.c:1646  */
    {
                        createservice(Service_Fifo, (yyvsp[-2].string), (yyvsp[0].string), check_fifo);
                  }
#line 4288 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 353:
#line 1268 "src/p.y" /* yacc.c:1646  */
    {
                        command_t c = command; // Current command
                        check_exec(c->arg[0]);
                        createservice(Service_Program, (yyvsp[-3].string), NULL, check_program);
                        current->program->timeout = (yyvsp[0].number);
                        current->program->lastOutput = StringBuffer_create(64);
                        current->program->inprogressOutput = StringBuffer_create(64);
                 }
#line 4301 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 354:
#line 1276 "src/p.y" /* yacc.c:1646  */
    {
                        command_t c = command; // Current command
                        check_exec(c->arg[0]);
                        createservice(Service_Program, (yyvsp[-4].string), NULL, check_program);
                        current->program->timeout = (yyvsp[0].number);
                        current->program->lastOutput = StringBuffer_create(64);
                        current->program->inprogressOutput = StringBuffer_create(64);
                 }
#line 4314 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 355:
#line 1286 "src/p.y" /* yacc.c:1646  */
    {
                        addcommand(START, (yyvsp[0].number));
                  }
#line 4322 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 356:
#line 1289 "src/p.y" /* yacc.c:1646  */
    {
                        addcommand(START, (yyvsp[0].number));
                  }
#line 4330 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 357:
#line 1294 "src/p.y" /* yacc.c:1646  */
    {
                        addcommand(STOP, (yyvsp[0].number));
                  }
#line 4338 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 358:
#line 1297 "src/p.y" /* yacc.c:1646  */
    {
                        addcommand(STOP, (yyvsp[0].number));
                  }
#line 4346 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 359:
#line 1303 "src/p.y" /* yacc.c:1646  */
    {
                        addcommand(RESTART, (yyvsp[0].number));
                  }
#line 4354 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 360:
#line 1306 "src/p.y" /* yacc.c:1646  */
    {
                        addcommand(RESTART, (yyvsp[0].number));
                  }
#line 4362 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 365:
#line 1319 "src/p.y" /* yacc.c:1646  */
    {
                        addargument((yyvsp[0].string));
                  }
#line 4370 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 366:
#line 1322 "src/p.y" /* yacc.c:1646  */
    {
                        addargument((yyvsp[0].string));
                  }
#line 4378 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 367:
#line 1327 "src/p.y" /* yacc.c:1646  */
    {
                        addeuid(get_uid((yyvsp[0].string), 0));
                        FREE((yyvsp[0].string));
                  }
#line 4387 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 368:
#line 1331 "src/p.y" /* yacc.c:1646  */
    {
                        addegid(get_gid((yyvsp[0].string), 0));
                        FREE((yyvsp[0].string));
                  }
#line 4396 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 369:
#line 1335 "src/p.y" /* yacc.c:1646  */
    {
                        addeuid(get_uid(NULL, (yyvsp[0].number)));
                  }
#line 4404 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 370:
#line 1338 "src/p.y" /* yacc.c:1646  */
    {
                        addegid(get_gid(NULL, (yyvsp[0].number)));
                  }
#line 4412 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 371:
#line 1343 "src/p.y" /* yacc.c:1646  */
    {
                        (yyval.string) = (yyvsp[0].string);
                  }
#line 4420 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 372:
#line 1346 "src/p.y" /* yacc.c:1646  */
    {
                        (yyval.string) = (yyvsp[0].string);
                  }
#line 4428 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 373:
#line 1351 "src/p.y" /* yacc.c:1646  */
    {
                        (yyval.string) = (yyvsp[0].string);
                  }
#line 4436 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 374:
#line 1356 "src/p.y" /* yacc.c:1646  */
    {
                        (yyval.string) = NULL;
                  }
#line 4444 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 375:
#line 1359 "src/p.y" /* yacc.c:1646  */
    {
                        (yyval.string) = (yyvsp[0].string);
                  }
#line 4452 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 376:
#line 1364 "src/p.y" /* yacc.c:1646  */
    {
                        /* This is a workaround to support content match without having to create an URL object. 'urloption' creates the Request_T object we need minus the URL object, but with enough information to perform content test.
                           TODO: Parser is in need of refactoring */
                        portset.url_request = urlrequest;
                        addeventaction(&(portset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addport(&(current->portlist), &portset);
                  }
#line 4464 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 390:
#line 1390 "src/p.y" /* yacc.c:1646  */
    {
                        prepare_urlrequest((yyvsp[-5].url));
                        addeventaction(&(portset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addport(&(current->portlist), &portset);
                  }
#line 4474 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 399:
#line 1409 "src/p.y" /* yacc.c:1646  */
    {
                        addeventaction(&(portset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addport(&(current->socketlist), &portset);
                  }
#line 4483 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 407:
#line 1426 "src/p.y" /* yacc.c:1646  */
    {
                        icmpset.family = Socket_Ip;
                        icmpset.type = (yyvsp[-5].number);
                        addeventaction(&(icmpset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addicmp(&icmpset);
                  }
#line 4494 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 408:
#line 1432 "src/p.y" /* yacc.c:1646  */
    {
                        icmpset.family = Socket_Ip;
                        addeventaction(&(icmpset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addicmp(&icmpset);
                 }
#line 4504 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 409:
#line 1437 "src/p.y" /* yacc.c:1646  */
    {
                        icmpset.family = Socket_Ip4;
                        addeventaction(&(icmpset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addicmp(&icmpset);
                 }
#line 4514 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 410:
#line 1442 "src/p.y" /* yacc.c:1646  */
    {
                        icmpset.family = Socket_Ip6;
                        addeventaction(&(icmpset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addicmp(&icmpset);
                 }
#line 4524 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 417:
#line 1459 "src/p.y" /* yacc.c:1646  */
    {
                        portset.hostname = Str_dup(current->type == Service_Host ? current->path : LOCALHOST);
                  }
#line 4532 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 418:
#line 1462 "src/p.y" /* yacc.c:1646  */
    {
                        portset.hostname = (yyvsp[0].string);
                  }
#line 4540 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 419:
#line 1467 "src/p.y" /* yacc.c:1646  */
    {
                        portset.target.net.port = (yyvsp[0].number);
                  }
#line 4548 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 420:
#line 1472 "src/p.y" /* yacc.c:1646  */
    {
                        portset.family = Socket_Unix;
                        portset.target.unix.pathname = (yyvsp[0].string);
                  }
#line 4557 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 421:
#line 1478 "src/p.y" /* yacc.c:1646  */
    {
                        portset.family = Socket_Ip4;
                  }
#line 4565 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 422:
#line 1481 "src/p.y" /* yacc.c:1646  */
    {
                        portset.family = Socket_Ip6;
                  }
#line 4573 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 423:
#line 1486 "src/p.y" /* yacc.c:1646  */
    {
                        portset.type = Socket_Tcp;
                  }
#line 4581 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 424:
#line 1489 "src/p.y" /* yacc.c:1646  */
    { // The typelist is kept for backward compatibility (replaced by ssloptionlist)
                        portset.type = Socket_Tcp;
                        sslset.flags = SSL_Enabled;
                  }
#line 4590 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 425:
#line 1493 "src/p.y" /* yacc.c:1646  */
    {
                        portset.type = Socket_Udp;
                  }
#line 4598 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 430:
#line 1506 "src/p.y" /* yacc.c:1646  */
    {
                        _parseOutgoingAddress((yyvsp[0].string), &(portset.outgoing));
                  }
#line 4606 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 431:
#line 1511 "src/p.y" /* yacc.c:1646  */
    {
                        portset.protocol = Protocol_get(Protocol_APACHESTATUS);
                  }
#line 4614 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 432:
#line 1514 "src/p.y" /* yacc.c:1646  */
    {
                        portset.protocol = Protocol_get(Protocol_DEFAULT);
                  }
#line 4622 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 433:
#line 1517 "src/p.y" /* yacc.c:1646  */
    {
                        portset.protocol = Protocol_get(Protocol_DNS);
                  }
#line 4630 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 434:
#line 1520 "src/p.y" /* yacc.c:1646  */
    {
                        portset.protocol = Protocol_get(Protocol_DWP);
                  }
#line 4638 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 435:
#line 1523 "src/p.y" /* yacc.c:1646  */
    {
                        portset.protocol = Protocol_get(Protocol_FAIL2BAN);
                }
#line 4646 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 436:
#line 1526 "src/p.y" /* yacc.c:1646  */
    {
                        portset.protocol = Protocol_get(Protocol_FTP);
                  }
#line 4654 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 437:
#line 1529 "src/p.y" /* yacc.c:1646  */
    {
                        portset.protocol = Protocol_get(Protocol_HTTP);
                  }
#line 4662 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 438:
#line 1532 "src/p.y" /* yacc.c:1646  */
    {
                        sslset.flags = SSL_Enabled;
                        portset.type = Socket_Tcp;
                        portset.protocol = Protocol_get(Protocol_HTTP);
                 }
#line 4672 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 439:
#line 1537 "src/p.y" /* yacc.c:1646  */
    {
                        portset.protocol = Protocol_get(Protocol_IMAP);
                  }
#line 4680 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 440:
#line 1540 "src/p.y" /* yacc.c:1646  */
    {
                        sslset.flags = SSL_Enabled;
                        portset.type = Socket_Tcp;
                        portset.protocol = Protocol_get(Protocol_IMAP);
                  }
#line 4690 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 441:
#line 1545 "src/p.y" /* yacc.c:1646  */
    {
                        portset.protocol = Protocol_get(Protocol_CLAMAV);
                  }
#line 4698 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 442:
#line 1548 "src/p.y" /* yacc.c:1646  */
    {
                        portset.protocol = Protocol_get(Protocol_LDAP2);
                  }
#line 4706 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 443:
#line 1551 "src/p.y" /* yacc.c:1646  */
    {
                        portset.protocol = Protocol_get(Protocol_LDAP3);
                  }
#line 4714 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 444:
#line 1554 "src/p.y" /* yacc.c:1646  */
    {
                        portset.protocol = Protocol_get(Protocol_MONGODB);
                  }
#line 4722 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 445:
#line 1557 "src/p.y" /* yacc.c:1646  */
    {
                        portset.protocol = Protocol_get(Protocol_MYSQL);
                  }
#line 4730 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 446:
#line 1560 "src/p.y" /* yacc.c:1646  */
    {
                        portset.protocol = Protocol_get(Protocol_SIP);
                  }
#line 4738 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 447:
#line 1563 "src/p.y" /* yacc.c:1646  */
    {
                        portset.protocol = Protocol_get(Protocol_NNTP);
                  }
#line 4746 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 448:
#line 1566 "src/p.y" /* yacc.c:1646  */
    {
                        portset.protocol = Protocol_get(Protocol_NTP3);
                        portset.type = Socket_Udp;
                  }
#line 4755 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 449:
#line 1570 "src/p.y" /* yacc.c:1646  */
    {
                        portset.protocol = Protocol_get(Protocol_POSTFIXPOLICY);
                  }
#line 4763 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 450:
#line 1573 "src/p.y" /* yacc.c:1646  */
    {
                        portset.protocol = Protocol_get(Protocol_POP);
                  }
#line 4771 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 451:
#line 1576 "src/p.y" /* yacc.c:1646  */
    {
                        sslset.flags = SSL_Enabled;
                        portset.type = Socket_Tcp;
                        portset.protocol = Protocol_get(Protocol_POP);
                  }
#line 4781 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 452:
#line 1581 "src/p.y" /* yacc.c:1646  */
    {
                        portset.protocol = Protocol_get(Protocol_SIEVE);
                  }
#line 4789 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 453:
#line 1584 "src/p.y" /* yacc.c:1646  */
    {
                        portset.protocol = Protocol_get(Protocol_SMTP);
                  }
#line 4797 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 454:
#line 1587 "src/p.y" /* yacc.c:1646  */
    {
                        sslset.flags = SSL_Enabled;
                        portset.type = Socket_Tcp;
                        portset.protocol = Protocol_get(Protocol_SMTP);
                 }
#line 4807 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 455:
#line 1592 "src/p.y" /* yacc.c:1646  */
    {
                        portset.protocol = Protocol_get(Protocol_SPAMASSASSIN);
                  }
#line 4815 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 456:
#line 1595 "src/p.y" /* yacc.c:1646  */
    {
                        portset.protocol = Protocol_get(Protocol_SSH);
                  }
#line 4823 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 457:
#line 1598 "src/p.y" /* yacc.c:1646  */
    {
                        portset.protocol = Protocol_get(Protocol_RDATE);
                  }
#line 4831 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 458:
#line 1601 "src/p.y" /* yacc.c:1646  */
    {
                        portset.protocol = Protocol_get(Protocol_REDIS);
                  }
#line 4839 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 459:
#line 1604 "src/p.y" /* yacc.c:1646  */
    {
                        portset.protocol = Protocol_get(Protocol_RSYNC);
                  }
#line 4847 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 460:
#line 1607 "src/p.y" /* yacc.c:1646  */
    {
                        portset.protocol = Protocol_get(Protocol_TNS);
                  }
#line 4855 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 461:
#line 1610 "src/p.y" /* yacc.c:1646  */
    {
                        portset.protocol = Protocol_get(Protocol_PGSQL);
                  }
#line 4863 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 462:
#line 1613 "src/p.y" /* yacc.c:1646  */
    {
                        portset.protocol = Protocol_get(Protocol_LMTP);
                  }
#line 4871 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 463:
#line 1616 "src/p.y" /* yacc.c:1646  */
    {
                        portset.protocol = Protocol_get(Protocol_GPS);
                  }
#line 4879 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 464:
#line 1619 "src/p.y" /* yacc.c:1646  */
    {
                        portset.protocol = Protocol_get(Protocol_RADIUS);
                  }
#line 4887 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 465:
#line 1622 "src/p.y" /* yacc.c:1646  */
    {
                        portset.protocol = Protocol_get(Protocol_MEMCACHE);
                  }
#line 4895 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 466:
#line 1625 "src/p.y" /* yacc.c:1646  */
    {
                        portset.protocol = Protocol_get(Protocol_WEBSOCKET);
                  }
#line 4903 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 467:
#line 1630 "src/p.y" /* yacc.c:1646  */
    {
                        if (portset.protocol->check == check_default || portset.protocol->check == check_generic) {
                                portset.protocol = Protocol_get(Protocol_GENERIC);
                                addgeneric(&portset, (yyvsp[0].string), NULL);
                        } else {
                                yyerror("The SEND statement is not allowed in the %s protocol context", portset.protocol->name);
                        }
                  }
#line 4916 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 468:
#line 1638 "src/p.y" /* yacc.c:1646  */
    {
                        if (portset.protocol->check == check_default || portset.protocol->check == check_generic) {
                                portset.protocol = Protocol_get(Protocol_GENERIC);
                                addgeneric(&portset, NULL, (yyvsp[0].string));
                        } else {
                                yyerror("The EXPECT statement is not allowed in the %s protocol context", portset.protocol->name);
                        }
                  }
#line 4929 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 471:
#line 1652 "src/p.y" /* yacc.c:1646  */
    {
                        portset.parameters.websocket.origin = (yyvsp[0].string);
                  }
#line 4937 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 472:
#line 1655 "src/p.y" /* yacc.c:1646  */
    {
                        portset.parameters.websocket.request = (yyvsp[0].string);
                  }
#line 4945 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 473:
#line 1658 "src/p.y" /* yacc.c:1646  */
    {
                        portset.parameters.websocket.host = (yyvsp[0].string);
                  }
#line 4953 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 474:
#line 1661 "src/p.y" /* yacc.c:1646  */
    {
                        portset.parameters.websocket.version = (yyvsp[0].number);
                  }
#line 4961 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 477:
#line 1670 "src/p.y" /* yacc.c:1646  */
    {
                        portset.parameters.smtp.username = (yyvsp[0].string);
                  }
#line 4969 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 478:
#line 1673 "src/p.y" /* yacc.c:1646  */
    {
                        portset.parameters.smtp.password = (yyvsp[0].string);
                  }
#line 4977 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 481:
#line 1682 "src/p.y" /* yacc.c:1646  */
    {
                        if ((yyvsp[0].string)) {
                                if (strlen((yyvsp[0].string)) > 16)
                                        yyerror2("Username too long -- Maximum MySQL username length is 16 characters");
                                else
                                        portset.parameters.mysql.username = (yyvsp[0].string);
                        }
                  }
#line 4990 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 482:
#line 1690 "src/p.y" /* yacc.c:1646  */
    {
                        portset.parameters.mysql.password = (yyvsp[0].string);
                  }
#line 4998 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 483:
#line 1695 "src/p.y" /* yacc.c:1646  */
    {
                        (yyval.string) = (yyvsp[0].string);
                  }
#line 5006 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 484:
#line 1698 "src/p.y" /* yacc.c:1646  */
    {
                        (yyval.string) = (yyvsp[0].string);
                  }
#line 5014 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 485:
#line 1703 "src/p.y" /* yacc.c:1646  */
    {
                        (yyval.number) = verifyMaxForward((yyvsp[0].number));
                  }
#line 5022 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 488:
#line 1712 "src/p.y" /* yacc.c:1646  */
    {
                        portset.parameters.sip.target = (yyvsp[0].string);
                  }
#line 5030 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 489:
#line 1715 "src/p.y" /* yacc.c:1646  */
    {
                        portset.parameters.sip.maxforward = (yyvsp[0].number);
                  }
#line 5038 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 492:
#line 1724 "src/p.y" /* yacc.c:1646  */
    {
                        portset.parameters.http.username = (yyvsp[0].string);
                  }
#line 5046 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 493:
#line 1727 "src/p.y" /* yacc.c:1646  */
    {
                        portset.parameters.http.password = (yyvsp[0].string);
                  }
#line 5054 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 500:
#line 1738 "src/p.y" /* yacc.c:1646  */
    {
                        if ((yyvsp[0].number) < 0) {
                                yyerror2("The status value must be greater or equal to 0");
                        }
                        portset.parameters.http.operator = (yyvsp[-1].number);
                        portset.parameters.http.status = (yyvsp[0].number);
                        portset.parameters.http.hasStatus = true;
                  }
#line 5067 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 501:
#line 1748 "src/p.y" /* yacc.c:1646  */
    {
                        portset.parameters.http.method = Http_Get;
                  }
#line 5075 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 502:
#line 1751 "src/p.y" /* yacc.c:1646  */
    {
                        portset.parameters.http.method = Http_Head;
                  }
#line 5083 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 503:
#line 1756 "src/p.y" /* yacc.c:1646  */
    {
                        portset.parameters.http.request = Util_urlEncode((yyvsp[0].string), false);
                        FREE((yyvsp[0].string));
                  }
#line 5092 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 504:
#line 1760 "src/p.y" /* yacc.c:1646  */
    {
                        portset.parameters.http.request = Util_urlEncode((yyvsp[0].string), false);
                        FREE((yyvsp[0].string));
                  }
#line 5101 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 505:
#line 1766 "src/p.y" /* yacc.c:1646  */
    {
                        portset.parameters.http.checksum = (yyvsp[0].string);
                  }
#line 5109 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 506:
#line 1771 "src/p.y" /* yacc.c:1646  */
    {
                        addhttpheader(&portset, Str_cat("Host:%s", (yyvsp[0].string)));
                        FREE((yyvsp[0].string));
                  }
#line 5118 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 508:
#line 1778 "src/p.y" /* yacc.c:1646  */
    {
                        addhttpheader(&portset, (yyvsp[0].string));
                 }
#line 5126 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 509:
#line 1783 "src/p.y" /* yacc.c:1646  */
    {
                        (yyval.string) = (yyvsp[0].string);
                  }
#line 5134 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 512:
#line 1792 "src/p.y" /* yacc.c:1646  */
    {
                        portset.parameters.radius.secret = (yyvsp[0].string);
                  }
#line 5142 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 515:
#line 1801 "src/p.y" /* yacc.c:1646  */
    {
                        portset.parameters.apachestatus.username = (yyvsp[0].string);
                  }
#line 5150 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 516:
#line 1804 "src/p.y" /* yacc.c:1646  */
    {
                        portset.parameters.apachestatus.password = (yyvsp[0].string);
                  }
#line 5158 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 517:
#line 1807 "src/p.y" /* yacc.c:1646  */
    {
                        portset.parameters.apachestatus.path = (yyvsp[0].string);
                  }
#line 5166 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 518:
#line 1810 "src/p.y" /* yacc.c:1646  */
    {
                        portset.parameters.apachestatus.loglimitOP = (yyvsp[-2].number);
                        portset.parameters.apachestatus.loglimit = (yyvsp[-1].number);
                  }
#line 5175 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 519:
#line 1814 "src/p.y" /* yacc.c:1646  */
    {
                        portset.parameters.apachestatus.closelimitOP = (yyvsp[-2].number);
                        portset.parameters.apachestatus.closelimit = (yyvsp[-1].number);
                  }
#line 5184 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 520:
#line 1818 "src/p.y" /* yacc.c:1646  */
    {
                        portset.parameters.apachestatus.dnslimitOP = (yyvsp[-2].number);
                        portset.parameters.apachestatus.dnslimit = (yyvsp[-1].number);
                  }
#line 5193 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 521:
#line 1822 "src/p.y" /* yacc.c:1646  */
    {
                        portset.parameters.apachestatus.keepalivelimitOP = (yyvsp[-2].number);
                        portset.parameters.apachestatus.keepalivelimit = (yyvsp[-1].number);
                  }
#line 5202 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 522:
#line 1826 "src/p.y" /* yacc.c:1646  */
    {
                        portset.parameters.apachestatus.replylimitOP = (yyvsp[-2].number);
                        portset.parameters.apachestatus.replylimit = (yyvsp[-1].number);
                  }
#line 5211 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 523:
#line 1830 "src/p.y" /* yacc.c:1646  */
    {
                        portset.parameters.apachestatus.requestlimitOP = (yyvsp[-2].number);
                        portset.parameters.apachestatus.requestlimit = (yyvsp[-1].number);
                  }
#line 5220 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 524:
#line 1834 "src/p.y" /* yacc.c:1646  */
    {
                        portset.parameters.apachestatus.startlimitOP = (yyvsp[-2].number);
                        portset.parameters.apachestatus.startlimit = (yyvsp[-1].number);
                  }
#line 5229 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 525:
#line 1838 "src/p.y" /* yacc.c:1646  */
    {
                        portset.parameters.apachestatus.waitlimitOP = (yyvsp[-2].number);
                        portset.parameters.apachestatus.waitlimit = (yyvsp[-1].number);
                  }
#line 5238 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 526:
#line 1842 "src/p.y" /* yacc.c:1646  */
    {
                        portset.parameters.apachestatus.gracefullimitOP = (yyvsp[-2].number);
                        portset.parameters.apachestatus.gracefullimit = (yyvsp[-1].number);
                  }
#line 5247 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 527:
#line 1846 "src/p.y" /* yacc.c:1646  */
    {
                        portset.parameters.apachestatus.cleanuplimitOP = (yyvsp[-2].number);
                        portset.parameters.apachestatus.cleanuplimit = (yyvsp[-1].number);
                  }
#line 5256 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 528:
#line 1852 "src/p.y" /* yacc.c:1646  */
    {
                        addeventaction(&(nonexistset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addnonexist(&nonexistset);
                  }
#line 5265 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 529:
#line 1856 "src/p.y" /* yacc.c:1646  */
    {
                        addeventaction(&(existset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addexist(&existset);
                  }
#line 5274 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 530:
#line 1863 "src/p.y" /* yacc.c:1646  */
    {
                        addeventaction(&(pidset).action, (yyvsp[0].number), Action_Ignored);
                        addpid(&pidset);
                  }
#line 5283 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 531:
#line 1869 "src/p.y" /* yacc.c:1646  */
    {
                        addeventaction(&(ppidset).action, (yyvsp[0].number), Action_Ignored);
                        addppid(&ppidset);
                  }
#line 5292 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 532:
#line 1875 "src/p.y" /* yacc.c:1646  */
    {
                        uptimeset.operator = (yyvsp[-6].number);
                        uptimeset.uptime = ((unsigned long long)(yyvsp[-5].number) * (yyvsp[-4].number));
                        addeventaction(&(uptimeset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        adduptime(&uptimeset);
                  }
#line 5303 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 533:
#line 1882 "src/p.y" /* yacc.c:1646  */
    {
                        icmpset.count = (yyvsp[0].number);
                 }
#line 5311 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 534:
#line 1887 "src/p.y" /* yacc.c:1646  */
    {
                        icmpset.size = (yyvsp[0].number);
                 }
#line 5319 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 535:
#line 1892 "src/p.y" /* yacc.c:1646  */
    {
                        icmpset.timeout = (yyvsp[-1].number) * 1000; // timeout is in milliseconds internally
                    }
#line 5327 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 536:
#line 1897 "src/p.y" /* yacc.c:1646  */
    {
                        _parseOutgoingAddress((yyvsp[0].string), &(icmpset.outgoing));
                  }
#line 5335 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 537:
#line 1902 "src/p.y" /* yacc.c:1646  */
    {
                        (yyval.number) = Run.limits.stopTimeout;
                  }
#line 5343 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 538:
#line 1905 "src/p.y" /* yacc.c:1646  */
    {
                        (yyval.number) = (yyvsp[-1].number) * 1000; // milliseconds internally
                  }
#line 5351 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 539:
#line 1910 "src/p.y" /* yacc.c:1646  */
    {
                        (yyval.number) = Run.limits.startTimeout;
                  }
#line 5359 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 540:
#line 1913 "src/p.y" /* yacc.c:1646  */
    {
                        (yyval.number) = (yyvsp[-1].number) * 1000; // milliseconds internally
                  }
#line 5367 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 541:
#line 1918 "src/p.y" /* yacc.c:1646  */
    {
                        (yyval.number) = Run.limits.restartTimeout;
                  }
#line 5375 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 542:
#line 1921 "src/p.y" /* yacc.c:1646  */
    {
                        (yyval.number) = (yyvsp[-1].number) * 1000; // milliseconds internally
                  }
#line 5383 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 543:
#line 1926 "src/p.y" /* yacc.c:1646  */
    {
                        (yyval.number) = Run.limits.programTimeout;
                  }
#line 5391 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 544:
#line 1929 "src/p.y" /* yacc.c:1646  */
    {
                        (yyval.number) = (yyvsp[-1].number) * 1000; // milliseconds internally
                  }
#line 5399 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 545:
#line 1934 "src/p.y" /* yacc.c:1646  */
    {
                        (yyval.number) = Run.limits.networkTimeout;
                  }
#line 5407 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 546:
#line 1937 "src/p.y" /* yacc.c:1646  */
    {
                        (yyval.number) = (yyvsp[-1].number) * 1000; // net timeout is in milliseconds internally
                  }
#line 5415 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 547:
#line 1942 "src/p.y" /* yacc.c:1646  */
    {
                        portset.timeout = (yyvsp[-1].number) * 1000; // timeout is in milliseconds internally
                    }
#line 5423 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 548:
#line 1947 "src/p.y" /* yacc.c:1646  */
    {
                        portset.retry = (yyvsp[0].number);
                  }
#line 5431 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 549:
#line 1952 "src/p.y" /* yacc.c:1646  */
    {
                        actionrateset.count = (yyvsp[-5].number);
                        actionrateset.cycle = (yyvsp[-3].number);
                        addeventaction(&(actionrateset).action, (yyvsp[0].number), Action_Alert);
                        addactionrate(&actionrateset);
                  }
#line 5442 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 550:
#line 1958 "src/p.y" /* yacc.c:1646  */
    {
                        actionrateset.count = (yyvsp[-5].number);
                        actionrateset.cycle = (yyvsp[-3].number);
                        addeventaction(&(actionrateset).action, Action_Unmonitor, Action_Alert);
                        addactionrate(&actionrateset);
                  }
#line 5453 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 551:
#line 1966 "src/p.y" /* yacc.c:1646  */
    {
                        seturlrequest((yyvsp[-1].number), (yyvsp[0].string));
                        FREE((yyvsp[0].string));
                  }
#line 5462 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 552:
#line 1972 "src/p.y" /* yacc.c:1646  */
    { (yyval.number) = Operator_Equal; }
#line 5468 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 553:
#line 1973 "src/p.y" /* yacc.c:1646  */
    { (yyval.number) = Operator_NotEqual; }
#line 5474 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 554:
#line 1976 "src/p.y" /* yacc.c:1646  */
    {
                        mailset.events = Event_All;
                        addmail((yyvsp[-2].string), &mailset, &current->maillist);
                  }
#line 5483 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 555:
#line 1980 "src/p.y" /* yacc.c:1646  */
    {
                        addmail((yyvsp[-5].string), &mailset, &current->maillist);
                  }
#line 5491 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 556:
#line 1983 "src/p.y" /* yacc.c:1646  */
    {
                        mailset.events = ~mailset.events;
                        addmail((yyvsp[-6].string), &mailset, &current->maillist);
                  }
#line 5500 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 557:
#line 1987 "src/p.y" /* yacc.c:1646  */
    {
                        addmail((yyvsp[0].string), &mailset, &current->maillist);
                  }
#line 5508 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 558:
#line 1992 "src/p.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 5514 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 559:
#line 1995 "src/p.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 5520 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 562:
#line 2002 "src/p.y" /* yacc.c:1646  */
    { mailset.events |= Event_Action; }
#line 5526 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 563:
#line 2003 "src/p.y" /* yacc.c:1646  */
    { mailset.events |= Event_ByteIn; }
#line 5532 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 564:
#line 2004 "src/p.y" /* yacc.c:1646  */
    { mailset.events |= Event_ByteOut; }
#line 5538 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 565:
#line 2005 "src/p.y" /* yacc.c:1646  */
    { mailset.events |= Event_Checksum; }
#line 5544 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 566:
#line 2006 "src/p.y" /* yacc.c:1646  */
    { mailset.events |= Event_Connection; }
#line 5550 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 567:
#line 2007 "src/p.y" /* yacc.c:1646  */
    { mailset.events |= Event_Content; }
#line 5556 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 568:
#line 2008 "src/p.y" /* yacc.c:1646  */
    { mailset.events |= Event_Data; }
#line 5562 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 569:
#line 2009 "src/p.y" /* yacc.c:1646  */
    { mailset.events |= Event_Exec; }
#line 5568 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 570:
#line 2010 "src/p.y" /* yacc.c:1646  */
    { mailset.events |= Event_Exist; }
#line 5574 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 571:
#line 2011 "src/p.y" /* yacc.c:1646  */
    { mailset.events |= Event_FsFlag; }
#line 5580 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 572:
#line 2012 "src/p.y" /* yacc.c:1646  */
    { mailset.events |= Event_Gid; }
#line 5586 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 573:
#line 2013 "src/p.y" /* yacc.c:1646  */
    { mailset.events |= Event_Icmp; }
#line 5592 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 574:
#line 2014 "src/p.y" /* yacc.c:1646  */
    { mailset.events |= Event_Instance; }
#line 5598 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 575:
#line 2015 "src/p.y" /* yacc.c:1646  */
    { mailset.events |= Event_Invalid; }
#line 5604 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 576:
#line 2016 "src/p.y" /* yacc.c:1646  */
    { mailset.events |= Event_Link; }
#line 5610 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 577:
#line 2017 "src/p.y" /* yacc.c:1646  */
    { mailset.events |= Event_NonExist; }
#line 5616 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 578:
#line 2018 "src/p.y" /* yacc.c:1646  */
    { mailset.events |= Event_PacketIn; }
#line 5622 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 579:
#line 2019 "src/p.y" /* yacc.c:1646  */
    { mailset.events |= Event_PacketOut; }
#line 5628 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 580:
#line 2020 "src/p.y" /* yacc.c:1646  */
    { mailset.events |= Event_Permission; }
#line 5634 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 581:
#line 2021 "src/p.y" /* yacc.c:1646  */
    { mailset.events |= Event_Pid; }
#line 5640 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 582:
#line 2022 "src/p.y" /* yacc.c:1646  */
    { mailset.events |= Event_PPid; }
#line 5646 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 583:
#line 2023 "src/p.y" /* yacc.c:1646  */
    { mailset.events |= Event_Resource; }
#line 5652 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 584:
#line 2024 "src/p.y" /* yacc.c:1646  */
    { mailset.events |= Event_Saturation; }
#line 5658 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 585:
#line 2025 "src/p.y" /* yacc.c:1646  */
    { mailset.events |= Event_Size; }
#line 5664 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 586:
#line 2026 "src/p.y" /* yacc.c:1646  */
    { mailset.events |= Event_Speed; }
#line 5670 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 587:
#line 2027 "src/p.y" /* yacc.c:1646  */
    { mailset.events |= Event_Status; }
#line 5676 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 588:
#line 2028 "src/p.y" /* yacc.c:1646  */
    { mailset.events |= Event_Timeout; }
#line 5682 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 589:
#line 2029 "src/p.y" /* yacc.c:1646  */
    { mailset.events |= Event_Timestamp; }
#line 5688 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 590:
#line 2030 "src/p.y" /* yacc.c:1646  */
    { mailset.events |= Event_Uid; }
#line 5694 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 591:
#line 2031 "src/p.y" /* yacc.c:1646  */
    { mailset.events |= Event_Uptime; }
#line 5700 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 596:
#line 2042 "src/p.y" /* yacc.c:1646  */
    { mailset.from = (yyvsp[-1].address); }
#line 5706 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 597:
#line 2043 "src/p.y" /* yacc.c:1646  */
    { mailset.replyto = (yyvsp[-1].address); }
#line 5712 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 598:
#line 2044 "src/p.y" /* yacc.c:1646  */
    { mailset.subject = (yyvsp[0].string); }
#line 5718 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 599:
#line 2045 "src/p.y" /* yacc.c:1646  */
    { mailset.message = (yyvsp[0].string); }
#line 5724 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 600:
#line 2048 "src/p.y" /* yacc.c:1646  */
    {
                        current->every.type = Every_SkipCycles;
                        current->every.spec.cycle.counter = current->every.spec.cycle.number = (yyvsp[-1].number);
                 }
#line 5733 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 601:
#line 2052 "src/p.y" /* yacc.c:1646  */
    {
                        current->every.type = Every_Cron;
                        current->every.spec.cron = (yyvsp[0].string);
                 }
#line 5742 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 602:
#line 2056 "src/p.y" /* yacc.c:1646  */
    {
                        current->every.type = Every_NotInCron;
                        current->every.spec.cron = (yyvsp[0].string);
                 }
#line 5751 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 603:
#line 2062 "src/p.y" /* yacc.c:1646  */
    {
                        current->mode = Monitor_Active;
                  }
#line 5759 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 604:
#line 2065 "src/p.y" /* yacc.c:1646  */
    {
                        current->mode = Monitor_Passive;
                  }
#line 5767 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 605:
#line 2068 "src/p.y" /* yacc.c:1646  */
    {
                        // Deprecated since monit 5.18
                        current->onreboot = Onreboot_Laststate;
                  }
#line 5776 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 606:
#line 2074 "src/p.y" /* yacc.c:1646  */
    {
                        current->onreboot = Onreboot_Start;
                  }
#line 5784 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 607:
#line 2077 "src/p.y" /* yacc.c:1646  */
    {
                        current->onreboot = Onreboot_Nostart;
                        current->monitor = Monitor_Not;
                  }
#line 5793 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 608:
#line 2081 "src/p.y" /* yacc.c:1646  */
    {
                        current->onreboot = Onreboot_Laststate;
                  }
#line 5801 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 609:
#line 2086 "src/p.y" /* yacc.c:1646  */
    {
                        addservicegroup((yyvsp[0].string));
                        FREE((yyvsp[0].string));
                  }
#line 5810 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 613:
#line 2100 "src/p.y" /* yacc.c:1646  */
    { adddependant((yyvsp[0].string)); }
#line 5816 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 614:
#line 2103 "src/p.y" /* yacc.c:1646  */
    {
                        statusset.initialized = true;
                        statusset.operator = (yyvsp[-5].number);
                        statusset.return_value = (yyvsp[-4].number);
                        addeventaction(&(statusset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addstatus(&statusset);
                   }
#line 5828 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 615:
#line 2110 "src/p.y" /* yacc.c:1646  */
    {
                        statusset.initialized = false;
                        statusset.operator = Operator_Changed;
                        statusset.return_value = 0;
                        addeventaction(&(statusset).action, (yyvsp[0].number), Action_Ignored);
                        addstatus(&statusset);
                   }
#line 5840 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 616:
#line 2119 "src/p.y" /* yacc.c:1646  */
    {
                        addeventaction(&(resourceset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addresource(&resourceset);
                   }
#line 5849 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 626:
#line 2138 "src/p.y" /* yacc.c:1646  */
    {
                        addeventaction(&(resourceset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addresource(&resourceset);
                   }
#line 5858 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 633:
#line 2154 "src/p.y" /* yacc.c:1646  */
    {
                        resourceset.resource_id = Resource_CpuPercent;
                        resourceset.operator = (yyvsp[-2].number);
                        resourceset.limit = (yyvsp[-1].real);
                  }
#line 5868 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 634:
#line 2159 "src/p.y" /* yacc.c:1646  */
    {
                        resourceset.resource_id = Resource_CpuPercentTotal;
                        resourceset.operator = (yyvsp[-2].number);
                        resourceset.limit = (yyvsp[-1].real);
                  }
#line 5878 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 635:
#line 2166 "src/p.y" /* yacc.c:1646  */
    {
                        resourceset.resource_id = (yyvsp[-3].number);
                        resourceset.operator = (yyvsp[-2].number);
                        resourceset.limit = (yyvsp[-1].real);
                  }
#line 5888 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 636:
#line 2173 "src/p.y" /* yacc.c:1646  */
    { (yyval.number) = Resource_CpuUser; }
#line 5894 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 637:
#line 2174 "src/p.y" /* yacc.c:1646  */
    { (yyval.number) = Resource_CpuSystem; }
#line 5900 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 638:
#line 2175 "src/p.y" /* yacc.c:1646  */
    { (yyval.number) = Resource_CpuWait; }
#line 5906 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 639:
#line 2176 "src/p.y" /* yacc.c:1646  */
    { (yyval.number) = Resource_CpuPercent; }
#line 5912 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 640:
#line 2179 "src/p.y" /* yacc.c:1646  */
    {
                        resourceset.resource_id = Resource_MemoryKbyte;
                        resourceset.operator = (yyvsp[-2].number);
                        resourceset.limit = (yyvsp[-1].real) * (yyvsp[0].number);
                  }
#line 5922 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 641:
#line 2184 "src/p.y" /* yacc.c:1646  */
    {
                        resourceset.resource_id = Resource_MemoryPercent;
                        resourceset.operator = (yyvsp[-2].number);
                        resourceset.limit = (yyvsp[-1].real);
                  }
#line 5932 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 642:
#line 2191 "src/p.y" /* yacc.c:1646  */
    {
                        resourceset.resource_id = Resource_MemoryKbyte;
                        resourceset.operator = (yyvsp[-2].number);
                        resourceset.limit = (yyvsp[-1].real) * (yyvsp[0].number);
                  }
#line 5942 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 643:
#line 2196 "src/p.y" /* yacc.c:1646  */
    {
                        resourceset.resource_id = Resource_MemoryPercent;
                        resourceset.operator = (yyvsp[-2].number);
                        resourceset.limit = (yyvsp[-1].real);
                  }
#line 5952 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 644:
#line 2201 "src/p.y" /* yacc.c:1646  */
    {
                        resourceset.resource_id = Resource_MemoryKbyteTotal;
                        resourceset.operator = (yyvsp[-2].number);
                        resourceset.limit = (yyvsp[-1].real) * (yyvsp[0].number);
                  }
#line 5962 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 645:
#line 2206 "src/p.y" /* yacc.c:1646  */
    {
                        resourceset.resource_id = Resource_MemoryPercentTotal;
                        resourceset.operator = (yyvsp[-2].number);
                        resourceset.limit = (yyvsp[-1].real);
                  }
#line 5972 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 646:
#line 2213 "src/p.y" /* yacc.c:1646  */
    {
                        resourceset.resource_id = Resource_SwapKbyte;
                        resourceset.operator = (yyvsp[-2].number);
                        resourceset.limit = (yyvsp[-1].real) * (yyvsp[0].number);
                  }
#line 5982 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 647:
#line 2218 "src/p.y" /* yacc.c:1646  */
    {
                        resourceset.resource_id = Resource_SwapPercent;
                        resourceset.operator = (yyvsp[-2].number);
                        resourceset.limit = (yyvsp[-1].real);
                  }
#line 5992 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 648:
#line 2225 "src/p.y" /* yacc.c:1646  */
    {
                        resourceset.resource_id = Resource_Threads;
                        resourceset.operator = (yyvsp[-1].number);
                        resourceset.limit = (yyvsp[0].number);
                  }
#line 6002 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 649:
#line 2232 "src/p.y" /* yacc.c:1646  */
    {
                        resourceset.resource_id = Resource_Children;
                        resourceset.operator = (yyvsp[-1].number);
                        resourceset.limit = (yyvsp[0].number);
                  }
#line 6012 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 650:
#line 2239 "src/p.y" /* yacc.c:1646  */
    {
                        resourceset.resource_id = (yyvsp[-2].number);
                        resourceset.operator = (yyvsp[-1].number);
                        resourceset.limit = (yyvsp[0].real);
                  }
#line 6022 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 651:
#line 2246 "src/p.y" /* yacc.c:1646  */
    { (yyval.number) = Resource_LoadAverage1m; }
#line 6028 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 652:
#line 2247 "src/p.y" /* yacc.c:1646  */
    { (yyval.number) = Resource_LoadAverage5m; }
#line 6034 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 653:
#line 2248 "src/p.y" /* yacc.c:1646  */
    { (yyval.number) = Resource_LoadAverage15m; }
#line 6040 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 654:
#line 2251 "src/p.y" /* yacc.c:1646  */
    {
                        resourceset.resource_id = Resource_ReadBytes;
                        resourceset.operator = (yyvsp[-3].number);
                        resourceset.limit = (yyvsp[-2].real) * (yyvsp[-1].number);
                  }
#line 6050 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 655:
#line 2256 "src/p.y" /* yacc.c:1646  */
    {
                        resourceset.resource_id = Resource_ReadOperations;
                        resourceset.operator = (yyvsp[-2].number);
                        resourceset.limit = (yyvsp[-1].number);
                  }
#line 6060 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 656:
#line 2263 "src/p.y" /* yacc.c:1646  */
    {
                        resourceset.resource_id = Resource_WriteBytes;
                        resourceset.operator = (yyvsp[-3].number);
                        resourceset.limit = (yyvsp[-2].real) * (yyvsp[-1].number);
                  }
#line 6070 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 657:
#line 2268 "src/p.y" /* yacc.c:1646  */
    {
                        resourceset.resource_id = Resource_WriteOperations;
                        resourceset.operator = (yyvsp[-2].number);
                        resourceset.limit = (yyvsp[-1].number);
                  }
#line 6080 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 658:
#line 2275 "src/p.y" /* yacc.c:1646  */
    { (yyval.real) = (yyvsp[0].real); }
#line 6086 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 659:
#line 2276 "src/p.y" /* yacc.c:1646  */
    { (yyval.real) = (float) (yyvsp[0].number); }
#line 6092 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 660:
#line 2279 "src/p.y" /* yacc.c:1646  */
    { (yyval.number) = Timestamp_Default; }
#line 6098 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 661:
#line 2280 "src/p.y" /* yacc.c:1646  */
    { (yyval.number) = Timestamp_Access; }
#line 6104 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 662:
#line 2281 "src/p.y" /* yacc.c:1646  */
    { (yyval.number) = Timestamp_Change; }
#line 6110 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 663:
#line 2282 "src/p.y" /* yacc.c:1646  */
    { (yyval.number) = Timestamp_Modification; }
#line 6116 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 664:
#line 2285 "src/p.y" /* yacc.c:1646  */
    {
                        timestampset.type = (yyvsp[-7].number);
                        timestampset.operator = (yyvsp[-6].number);
                        timestampset.time = ((yyvsp[-5].number) * (yyvsp[-4].number));
                        addeventaction(&(timestampset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addtimestamp(&timestampset);
                  }
#line 6128 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 665:
#line 2292 "src/p.y" /* yacc.c:1646  */
    {
                        timestampset.type = (yyvsp[-3].number);
                        timestampset.test_changes = true;
                        addeventaction(&(timestampset).action, (yyvsp[0].number), Action_Ignored);
                        addtimestamp(&timestampset);
                  }
#line 6139 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 666:
#line 2300 "src/p.y" /* yacc.c:1646  */
    { (yyval.number) = Operator_Equal; }
#line 6145 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 667:
#line 2301 "src/p.y" /* yacc.c:1646  */
    { (yyval.number) = Operator_Greater; }
#line 6151 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 668:
#line 2302 "src/p.y" /* yacc.c:1646  */
    { (yyval.number) = Operator_GreaterOrEqual; }
#line 6157 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 669:
#line 2303 "src/p.y" /* yacc.c:1646  */
    { (yyval.number) = Operator_Less; }
#line 6163 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 670:
#line 2304 "src/p.y" /* yacc.c:1646  */
    { (yyval.number) = Operator_LessOrEqual; }
#line 6169 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 671:
#line 2305 "src/p.y" /* yacc.c:1646  */
    { (yyval.number) = Operator_Equal; }
#line 6175 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 672:
#line 2306 "src/p.y" /* yacc.c:1646  */
    { (yyval.number) = Operator_NotEqual; }
#line 6181 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 673:
#line 2307 "src/p.y" /* yacc.c:1646  */
    { (yyval.number) = Operator_Changed; }
#line 6187 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 674:
#line 2310 "src/p.y" /* yacc.c:1646  */
    { (yyval.number) = Time_Second; }
#line 6193 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 675:
#line 2311 "src/p.y" /* yacc.c:1646  */
    { (yyval.number) = Time_Second; }
#line 6199 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 676:
#line 2312 "src/p.y" /* yacc.c:1646  */
    { (yyval.number) = Time_Minute; }
#line 6205 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 677:
#line 2313 "src/p.y" /* yacc.c:1646  */
    { (yyval.number) = Time_Hour; }
#line 6211 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 678:
#line 2314 "src/p.y" /* yacc.c:1646  */
    { (yyval.number) = Time_Day; }
#line 6217 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 679:
#line 2315 "src/p.y" /* yacc.c:1646  */
    { (yyval.number) = Time_Month; }
#line 6223 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 680:
#line 2318 "src/p.y" /* yacc.c:1646  */
    { (yyval.number) = Time_Minute; }
#line 6229 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 681:
#line 2319 "src/p.y" /* yacc.c:1646  */
    { (yyval.number) = Time_Hour; }
#line 6235 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 682:
#line 2320 "src/p.y" /* yacc.c:1646  */
    { (yyval.number) = Time_Day; }
#line 6241 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 683:
#line 2322 "src/p.y" /* yacc.c:1646  */
    { (yyval.number) = Time_Second; }
#line 6247 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 684:
#line 2323 "src/p.y" /* yacc.c:1646  */
    { (yyval.number) = Time_Second; }
#line 6253 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 685:
#line 2325 "src/p.y" /* yacc.c:1646  */
    {
                        repeat = 0;
                  }
#line 6261 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 686:
#line 2328 "src/p.y" /* yacc.c:1646  */
    {
                        repeat = 1;
                  }
#line 6269 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 687:
#line 2331 "src/p.y" /* yacc.c:1646  */
    {
                        if ((yyvsp[-1].number) < 0) {
                                yyerror2("The number of repeat cycles must be greater or equal to 0");
                        }
                        repeat = (yyvsp[-1].number);
                  }
#line 6280 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 688:
#line 2339 "src/p.y" /* yacc.c:1646  */
    {
                        (yyval.number) = Action_Alert;
                  }
#line 6288 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 689:
#line 2342 "src/p.y" /* yacc.c:1646  */
    {
                        (yyval.number) = Action_Exec;
                  }
#line 6296 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 690:
#line 2346 "src/p.y" /* yacc.c:1646  */
    {
                        (yyval.number) = Action_Exec;
                  }
#line 6304 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 691:
#line 2349 "src/p.y" /* yacc.c:1646  */
    {
                        (yyval.number) = Action_Restart;
                  }
#line 6312 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 692:
#line 2352 "src/p.y" /* yacc.c:1646  */
    {
                        (yyval.number) = Action_Start;
                  }
#line 6320 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 693:
#line 2355 "src/p.y" /* yacc.c:1646  */
    {
                        (yyval.number) = Action_Stop;
                  }
#line 6328 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 694:
#line 2358 "src/p.y" /* yacc.c:1646  */
    {
                        (yyval.number) = Action_Unmonitor;
                  }
#line 6336 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 695:
#line 2363 "src/p.y" /* yacc.c:1646  */
    {
                        (yyval.number) = (yyvsp[0].number);
                        if ((yyvsp[0].number) == Action_Exec && command) {
                                repeat1 = repeat;
                                repeat = 0;
                                command1 = command;
                                command = NULL;
                        }
                  }
#line 6350 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 696:
#line 2374 "src/p.y" /* yacc.c:1646  */
    {
                        (yyval.number) = (yyvsp[0].number);
                        if ((yyvsp[0].number) == Action_Exec && command) {
                                repeat2 = repeat;
                                repeat = 0;
                                command2 = command;
                                command = NULL;
                        }
                  }
#line 6364 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 697:
#line 2385 "src/p.y" /* yacc.c:1646  */
    {
                        if ((yyvsp[-1].number) < 1 || (yyvsp[-1].number) > BITMAP_MAX) {
                                yyerror2("The number of cycles must be between 1 and %d", BITMAP_MAX);
                        } else {
                                rate.count  = (yyvsp[-1].number);
                                rate.cycles = (yyvsp[-1].number);
                        }
                  }
#line 6377 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 698:
#line 2395 "src/p.y" /* yacc.c:1646  */
    {
                        if ((yyvsp[-1].number) < 1 || (yyvsp[-1].number) > BITMAP_MAX) {
                                yyerror2("The number of cycles must be between 1 and %d", BITMAP_MAX);
                        } else if ((yyvsp[-2].number) < 1 || (yyvsp[-2].number) > (yyvsp[-1].number)) {
                                yyerror2("The number of events must be between 1 and less then poll cycles");
                        } else {
                                rate.count  = (yyvsp[-2].number);
                                rate.cycles = (yyvsp[-1].number);
                        }
                  }
#line 6392 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 700:
#line 2408 "src/p.y" /* yacc.c:1646  */
    {
                        rate1.count = rate.count;
                        rate1.cycles = rate.cycles;
                        reset_rateset(&rate);
                  }
#line 6402 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 701:
#line 2413 "src/p.y" /* yacc.c:1646  */
    {
                        rate1.count = rate.count;
                        rate1.cycles = rate.cycles;
                        reset_rateset(&rate);
                }
#line 6412 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 703:
#line 2421 "src/p.y" /* yacc.c:1646  */
    {
                        rate2.count = rate.count;
                        rate2.cycles = rate.cycles;
                        reset_rateset(&rate);
                  }
#line 6422 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 704:
#line 2426 "src/p.y" /* yacc.c:1646  */
    {
                        rate2.count = rate.count;
                        rate2.cycles = rate.cycles;
                        reset_rateset(&rate);
                }
#line 6432 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 705:
#line 2433 "src/p.y" /* yacc.c:1646  */
    {
                        (yyval.number) = Action_Alert;
                  }
#line 6440 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 706:
#line 2436 "src/p.y" /* yacc.c:1646  */
    {
                        (yyval.number) = (yyvsp[0].number);
                  }
#line 6448 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 707:
#line 2439 "src/p.y" /* yacc.c:1646  */
    {
                        (yyval.number) = (yyvsp[0].number);
                  }
#line 6456 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 708:
#line 2442 "src/p.y" /* yacc.c:1646  */
    {
                        (yyval.number) = (yyvsp[0].number);
                  }
#line 6464 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 709:
#line 2447 "src/p.y" /* yacc.c:1646  */
    {
                        addeventaction(&(checksumset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addchecksum(&checksumset);
                  }
#line 6473 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 710:
#line 2452 "src/p.y" /* yacc.c:1646  */
    {
                        snprintf(checksumset.hash, sizeof(checksumset.hash), "%s", (yyvsp[-4].string));
                        FREE((yyvsp[-4].string));
                        addeventaction(&(checksumset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addchecksum(&checksumset);
                  }
#line 6484 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 711:
#line 2458 "src/p.y" /* yacc.c:1646  */
    {
                        checksumset.test_changes = true;
                        addeventaction(&(checksumset).action, (yyvsp[0].number), Action_Ignored);
                        addchecksum(&checksumset);
                  }
#line 6494 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 712:
#line 2464 "src/p.y" /* yacc.c:1646  */
    { checksumset.type = Hash_Unknown; }
#line 6500 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 713:
#line 2465 "src/p.y" /* yacc.c:1646  */
    { checksumset.type = Hash_Md5; }
#line 6506 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 714:
#line 2466 "src/p.y" /* yacc.c:1646  */
    { checksumset.type = Hash_Sha1; }
#line 6512 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 715:
#line 2469 "src/p.y" /* yacc.c:1646  */
    {
                        filesystemset.resource = Resource_Inode;
                        filesystemset.operator = (yyvsp[-5].number);
                        filesystemset.limit_absolute = (yyvsp[-4].number);
                        addeventaction(&(filesystemset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addfilesystem(&filesystemset);
                  }
#line 6524 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 716:
#line 2476 "src/p.y" /* yacc.c:1646  */
    {
                        filesystemset.resource = Resource_Inode;
                        filesystemset.operator = (yyvsp[-6].number);
                        filesystemset.limit_percent = (yyvsp[-5].real);
                        addeventaction(&(filesystemset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addfilesystem(&filesystemset);
                  }
#line 6536 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 717:
#line 2483 "src/p.y" /* yacc.c:1646  */
    {
                        filesystemset.resource = Resource_InodeFree;
                        filesystemset.operator = (yyvsp[-5].number);
                        filesystemset.limit_absolute = (yyvsp[-4].number);
                        addeventaction(&(filesystemset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addfilesystem(&filesystemset);
                  }
#line 6548 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 718:
#line 2490 "src/p.y" /* yacc.c:1646  */
    {
                        filesystemset.resource = Resource_InodeFree;
                        filesystemset.operator = (yyvsp[-6].number);
                        filesystemset.limit_percent = (yyvsp[-5].real);
                        addeventaction(&(filesystemset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addfilesystem(&filesystemset);
                  }
#line 6560 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 719:
#line 2499 "src/p.y" /* yacc.c:1646  */
    {
                        if (! filesystem_usage(current))
                                yyerror2("Cannot read usage of filesystem %s", current->path);
                        filesystemset.resource = Resource_Space;
                        filesystemset.operator = (yyvsp[-6].number);
                        filesystemset.limit_absolute = (long long)((double)(yyvsp[-5].real) / (double)current->inf.filesystem->f_bsize * (double)(yyvsp[-4].number));
                        addeventaction(&(filesystemset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addfilesystem(&filesystemset);
                  }
#line 6574 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 720:
#line 2508 "src/p.y" /* yacc.c:1646  */
    {
                        filesystemset.resource = Resource_Space;
                        filesystemset.operator = (yyvsp[-6].number);
                        filesystemset.limit_percent = (yyvsp[-5].real);
                        addeventaction(&(filesystemset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addfilesystem(&filesystemset);
                  }
#line 6586 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 721:
#line 2515 "src/p.y" /* yacc.c:1646  */
    {
                        if (! filesystem_usage(current))
                                yyerror2("Cannot read usage of filesystem %s", current->path);
                        filesystemset.resource = Resource_SpaceFree;
                        filesystemset.operator = (yyvsp[-6].number);
                        filesystemset.limit_absolute = (long long)((double)(yyvsp[-5].real) / (double)current->inf.filesystem->f_bsize * (double)(yyvsp[-4].number));
                        addeventaction(&(filesystemset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addfilesystem(&filesystemset);
                  }
#line 6600 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 722:
#line 2524 "src/p.y" /* yacc.c:1646  */
    {
                        filesystemset.resource = Resource_SpaceFree;
                        filesystemset.operator = (yyvsp[-6].number);
                        filesystemset.limit_percent = (yyvsp[-5].real);
                        addeventaction(&(filesystemset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addfilesystem(&filesystemset);
                  }
#line 6612 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 723:
#line 2533 "src/p.y" /* yacc.c:1646  */
    {
                        filesystemset.resource = Resource_ReadBytes;
                        filesystemset.operator = (yyvsp[-7].number);
                        filesystemset.limit_absolute = (yyvsp[-6].real) * (yyvsp[-5].number);
                        addeventaction(&(filesystemset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addfilesystem(&filesystemset);
                  }
#line 6624 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 724:
#line 2540 "src/p.y" /* yacc.c:1646  */
    {
                        filesystemset.resource = Resource_ReadOperations;
                        filesystemset.operator = (yyvsp[-6].number);
                        filesystemset.limit_absolute = (yyvsp[-5].number);
                        addeventaction(&(filesystemset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addfilesystem(&filesystemset);
                  }
#line 6636 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 725:
#line 2549 "src/p.y" /* yacc.c:1646  */
    {
                        filesystemset.resource = Resource_WriteBytes;
                        filesystemset.operator = (yyvsp[-7].number);
                        filesystemset.limit_absolute = (yyvsp[-6].real) * (yyvsp[-5].number);
                        addeventaction(&(filesystemset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addfilesystem(&filesystemset);
                  }
#line 6648 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 726:
#line 2556 "src/p.y" /* yacc.c:1646  */
    {
                        filesystemset.resource = Resource_WriteOperations;
                        filesystemset.operator = (yyvsp[-6].number);
                        filesystemset.limit_absolute = (yyvsp[-5].number);
                        addeventaction(&(filesystemset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addfilesystem(&filesystemset);
                  }
#line 6660 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 727:
#line 2565 "src/p.y" /* yacc.c:1646  */
    {
                        filesystemset.resource = Resource_ServiceTime;
                        filesystemset.operator = (yyvsp[-6].number);
                        filesystemset.limit_absolute = (yyvsp[-5].number);
                        addeventaction(&(filesystemset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addfilesystem(&filesystemset);
                  }
#line 6672 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 728:
#line 2572 "src/p.y" /* yacc.c:1646  */
    {
                        filesystemset.resource = Resource_ServiceTime;
                        filesystemset.operator = (yyvsp[-6].number);
                        filesystemset.limit_absolute = (yyvsp[-5].real) * 1000;
                        addeventaction(&(filesystemset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addfilesystem(&filesystemset);
                  }
#line 6684 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 729:
#line 2581 "src/p.y" /* yacc.c:1646  */
    {
                        addeventaction(&(fsflagset).action, (yyvsp[0].number), Action_Ignored);
                        addfsflag(&fsflagset);
                  }
#line 6693 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 730:
#line 2587 "src/p.y" /* yacc.c:1646  */
    { (yyval.number) = Unit_Byte; }
#line 6699 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 731:
#line 2588 "src/p.y" /* yacc.c:1646  */
    { (yyval.number) = Unit_Byte; }
#line 6705 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 732:
#line 2589 "src/p.y" /* yacc.c:1646  */
    { (yyval.number) = Unit_Kilobyte; }
#line 6711 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 733:
#line 2590 "src/p.y" /* yacc.c:1646  */
    { (yyval.number) = Unit_Megabyte; }
#line 6717 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 734:
#line 2591 "src/p.y" /* yacc.c:1646  */
    { (yyval.number) = Unit_Gigabyte; }
#line 6723 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 735:
#line 2594 "src/p.y" /* yacc.c:1646  */
    {
                        permset.perm = check_perm((yyvsp[-4].number));
                        addeventaction(&(permset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addperm(&permset);
                  }
#line 6733 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 736:
#line 2599 "src/p.y" /* yacc.c:1646  */
    {
                        permset.test_changes = true;
                        addeventaction(&(permset).action, (yyvsp[-1].number), Action_Ignored);
                        addperm(&permset);
                  }
#line 6743 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 737:
#line 2606 "src/p.y" /* yacc.c:1646  */
    {
                        matchset.not = (yyvsp[-4].number) == Operator_Equal ? false : true;
                        matchset.ignore = false;
                        matchset.match_path = (yyvsp[-3].string);
                        matchset.match_string = NULL;
                        addmatchpath(&matchset, (yyvsp[0].number));
                        FREE((yyvsp[-3].string));
                  }
#line 6756 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 738:
#line 2614 "src/p.y" /* yacc.c:1646  */
    {
                        matchset.not = (yyvsp[-4].number) == Operator_Equal ? false : true;
                        matchset.ignore = false;
                        matchset.match_path = NULL;
                        matchset.match_string = (yyvsp[-3].string);
                        addmatch(&matchset, (yyvsp[0].number), 0);
                  }
#line 6768 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 739:
#line 2621 "src/p.y" /* yacc.c:1646  */
    {
                        matchset.not = (yyvsp[-1].number) == Operator_Equal ? false : true;
                        matchset.ignore = true;
                        matchset.match_path = (yyvsp[0].string);
                        matchset.match_string = NULL;
                        addmatchpath(&matchset, Action_Ignored);
                        FREE((yyvsp[0].string));
                  }
#line 6781 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 740:
#line 2629 "src/p.y" /* yacc.c:1646  */
    {
                        matchset.not = (yyvsp[-1].number) == Operator_Equal ? false : true;
                        matchset.ignore = true;
                        matchset.match_path = NULL;
                        matchset.match_string = (yyvsp[0].string);
                        addmatch(&matchset, Action_Ignored, 0);
                  }
#line 6793 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 741:
#line 2637 "src/p.y" /* yacc.c:1646  */
    {
                        matchset.ignore = false;
                        matchset.match_path = (yyvsp[-3].string);
                        matchset.match_string = NULL;
                        addmatchpath(&matchset, (yyvsp[0].number));
                        FREE((yyvsp[-3].string));
                  }
#line 6805 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 742:
#line 2644 "src/p.y" /* yacc.c:1646  */
    {
                        matchset.ignore = false;
                        matchset.match_path = NULL;
                        matchset.match_string = (yyvsp[-3].string);
                        addmatch(&matchset, (yyvsp[0].number), 0);
                  }
#line 6816 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 743:
#line 2650 "src/p.y" /* yacc.c:1646  */
    {
                        matchset.ignore = true;
                        matchset.match_path = (yyvsp[0].string);
                        matchset.match_string = NULL;
                        addmatchpath(&matchset, Action_Ignored);
                        FREE((yyvsp[0].string));
                  }
#line 6828 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 744:
#line 2657 "src/p.y" /* yacc.c:1646  */
    {
                        matchset.ignore = true;
                        matchset.match_path = NULL;
                        matchset.match_string = (yyvsp[0].string);
                        addmatch(&matchset, Action_Ignored, 0);
                  }
#line 6839 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 745:
#line 2665 "src/p.y" /* yacc.c:1646  */
    {
                        matchset.not = false;
                  }
#line 6847 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 746:
#line 2668 "src/p.y" /* yacc.c:1646  */
    {
                        matchset.not = true;
                  }
#line 6855 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 747:
#line 2674 "src/p.y" /* yacc.c:1646  */
    {
                        sizeset.operator = (yyvsp[-6].number);
                        sizeset.size = ((unsigned long long)(yyvsp[-5].number) * (yyvsp[-4].number));
                        addeventaction(&(sizeset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addsize(&sizeset);
                  }
#line 6866 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 748:
#line 2680 "src/p.y" /* yacc.c:1646  */
    {
                        sizeset.test_changes = true;
                        addeventaction(&(sizeset).action, (yyvsp[0].number), Action_Ignored);
                        addsize(&sizeset);
                  }
#line 6876 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 749:
#line 2687 "src/p.y" /* yacc.c:1646  */
    {
                        uidset.uid = get_uid((yyvsp[-4].string), 0);
                        addeventaction(&(uidset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        current->uid = adduid(&uidset);
                        FREE((yyvsp[-4].string));
                  }
#line 6887 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 750:
#line 2693 "src/p.y" /* yacc.c:1646  */
    {
                    uidset.uid = get_uid(NULL, (yyvsp[-4].number));
                    addeventaction(&(uidset).action, (yyvsp[-1].number), (yyvsp[0].number));
                    current->uid = adduid(&uidset);
                  }
#line 6897 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 751:
#line 2700 "src/p.y" /* yacc.c:1646  */
    {
                        uidset.uid = get_uid((yyvsp[-4].string), 0);
                        addeventaction(&(uidset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        current->euid = adduid(&uidset);
                        FREE((yyvsp[-4].string));
                  }
#line 6908 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 752:
#line 2706 "src/p.y" /* yacc.c:1646  */
    {
                        uidset.uid = get_uid(NULL, (yyvsp[-4].number));
                        addeventaction(&(uidset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        current->euid = adduid(&uidset);
                  }
#line 6918 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 753:
#line 2713 "src/p.y" /* yacc.c:1646  */
    {
                        gidset.gid = get_gid((yyvsp[-4].string), 0);
                        addeventaction(&(gidset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        current->gid = addgid(&gidset);
                        FREE((yyvsp[-4].string));
                  }
#line 6929 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 754:
#line 2719 "src/p.y" /* yacc.c:1646  */
    {
                        gidset.gid = get_gid(NULL, (yyvsp[-4].number));
                        addeventaction(&(gidset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        current->gid = addgid(&gidset);
                  }
#line 6939 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 755:
#line 2726 "src/p.y" /* yacc.c:1646  */
    {
                        addeventaction(&(linkstatusset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addlinkstatus(current, &linkstatusset);
                  }
#line 6948 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 756:
#line 2732 "src/p.y" /* yacc.c:1646  */
    {
                        addeventaction(&(linkspeedset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addlinkspeed(current, &linkspeedset);
                  }
#line 6957 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 757:
#line 2737 "src/p.y" /* yacc.c:1646  */
    {
                        linksaturationset.operator = (yyvsp[-6].number);
                        linksaturationset.limit = (unsigned long long)(yyvsp[-5].number);
                        addeventaction(&(linksaturationset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addlinksaturation(current, &linksaturationset);
                  }
#line 6968 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 758:
#line 2745 "src/p.y" /* yacc.c:1646  */
    {
                        bandwidthset.operator = (yyvsp[-7].number);
                        bandwidthset.limit = ((unsigned long long)(yyvsp[-6].number) * (yyvsp[-5].number));
                        bandwidthset.rangecount = 1;
                        bandwidthset.range = (yyvsp[-4].number);
                        addeventaction(&(bandwidthset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addbandwidth(&(current->uploadbyteslist), &bandwidthset);
                  }
#line 6981 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 759:
#line 2753 "src/p.y" /* yacc.c:1646  */
    {
                        bandwidthset.operator = (yyvsp[-7].number);
                        bandwidthset.limit = ((unsigned long long)(yyvsp[-6].number) * (yyvsp[-5].number));
                        bandwidthset.rangecount = 1;
                        bandwidthset.range = (yyvsp[-4].number);
                        addeventaction(&(bandwidthset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addbandwidth(&(current->uploadbyteslist), &bandwidthset);
                  }
#line 6994 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 760:
#line 2761 "src/p.y" /* yacc.c:1646  */
    {
                        bandwidthset.operator = (yyvsp[-8].number);
                        bandwidthset.limit = ((unsigned long long)(yyvsp[-7].number) * (yyvsp[-6].number));
                        bandwidthset.rangecount = (yyvsp[-5].number);
                        bandwidthset.range = (yyvsp[-4].number);
                        addeventaction(&(bandwidthset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addbandwidth(&(current->uploadbyteslist), &bandwidthset);
                  }
#line 7007 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 761:
#line 2769 "src/p.y" /* yacc.c:1646  */
    {
                        bandwidthset.operator = (yyvsp[-7].number);
                        bandwidthset.limit = (unsigned long long)(yyvsp[-6].number);
                        bandwidthset.rangecount = 1;
                        bandwidthset.range = (yyvsp[-4].number);
                        addeventaction(&(bandwidthset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addbandwidth(&(current->uploadpacketslist), &bandwidthset);
                  }
#line 7020 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 762:
#line 2777 "src/p.y" /* yacc.c:1646  */
    {
                        bandwidthset.operator = (yyvsp[-7].number);
                        bandwidthset.limit = (unsigned long long)(yyvsp[-6].number);
                        bandwidthset.rangecount = 1;
                        bandwidthset.range = (yyvsp[-4].number);
                        addeventaction(&(bandwidthset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addbandwidth(&(current->uploadpacketslist), &bandwidthset);
                  }
#line 7033 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 763:
#line 2785 "src/p.y" /* yacc.c:1646  */
    {
                        bandwidthset.operator = (yyvsp[-8].number);
                        bandwidthset.limit = (unsigned long long)(yyvsp[-7].number);
                        bandwidthset.rangecount = (yyvsp[-5].number);
                        bandwidthset.range = (yyvsp[-4].number);
                        addeventaction(&(bandwidthset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addbandwidth(&(current->uploadpacketslist), &bandwidthset);
                  }
#line 7046 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 764:
#line 2795 "src/p.y" /* yacc.c:1646  */
    {
                        bandwidthset.operator = (yyvsp[-7].number);
                        bandwidthset.limit = ((unsigned long long)(yyvsp[-6].number) * (yyvsp[-5].number));
                        bandwidthset.rangecount = 1;
                        bandwidthset.range = (yyvsp[-4].number);
                        addeventaction(&(bandwidthset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addbandwidth(&(current->downloadbyteslist), &bandwidthset);
                  }
#line 7059 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 765:
#line 2803 "src/p.y" /* yacc.c:1646  */
    {
                        bandwidthset.operator = (yyvsp[-7].number);
                        bandwidthset.limit = ((unsigned long long)(yyvsp[-6].number) * (yyvsp[-5].number));
                        bandwidthset.rangecount = 1;
                        bandwidthset.range = (yyvsp[-4].number);
                        addeventaction(&(bandwidthset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addbandwidth(&(current->downloadbyteslist), &bandwidthset);
                  }
#line 7072 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 766:
#line 2811 "src/p.y" /* yacc.c:1646  */
    {
                        bandwidthset.operator = (yyvsp[-8].number);
                        bandwidthset.limit = ((unsigned long long)(yyvsp[-7].number) * (yyvsp[-6].number));
                        bandwidthset.rangecount = (yyvsp[-5].number);
                        bandwidthset.range = (yyvsp[-4].number);
                        addeventaction(&(bandwidthset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addbandwidth(&(current->downloadbyteslist), &bandwidthset);
                  }
#line 7085 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 767:
#line 2819 "src/p.y" /* yacc.c:1646  */
    {
                        bandwidthset.operator = (yyvsp[-7].number);
                        bandwidthset.limit = (unsigned long long)(yyvsp[-6].number);
                        bandwidthset.rangecount = 1;
                        bandwidthset.range = (yyvsp[-4].number);
                        addeventaction(&(bandwidthset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addbandwidth(&(current->downloadpacketslist), &bandwidthset);
                  }
#line 7098 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 768:
#line 2827 "src/p.y" /* yacc.c:1646  */
    {
                        bandwidthset.operator = (yyvsp[-7].number);
                        bandwidthset.limit = (unsigned long long)(yyvsp[-6].number);
                        bandwidthset.rangecount = 1;
                        bandwidthset.range = (yyvsp[-4].number);
                        addeventaction(&(bandwidthset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addbandwidth(&(current->downloadpacketslist), &bandwidthset);
                  }
#line 7111 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 769:
#line 2835 "src/p.y" /* yacc.c:1646  */
    {
                        bandwidthset.operator = (yyvsp[-8].number);
                        bandwidthset.limit = (unsigned long long)(yyvsp[-7].number);
                        bandwidthset.rangecount = (yyvsp[-5].number);
                        bandwidthset.range = (yyvsp[-4].number);
                        addeventaction(&(bandwidthset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addbandwidth(&(current->downloadpacketslist), &bandwidthset);
                  }
#line 7124 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 770:
#line 2845 "src/p.y" /* yacc.c:1646  */
    { (yyval.number) = ICMP_ECHO; }
#line 7130 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 771:
#line 2848 "src/p.y" /* yacc.c:1646  */
    { mailset.reminder = 0; }
#line 7136 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 772:
#line 2849 "src/p.y" /* yacc.c:1646  */
    { mailset.reminder = (yyvsp[0].number); }
#line 7142 "src/y.tab.c" /* yacc.c:1646  */
    break;

  case 773:
#line 2850 "src/p.y" /* yacc.c:1646  */
    { mailset.reminder = (yyvsp[-1].number); }
#line 7148 "src/y.tab.c" /* yacc.c:1646  */
    break;


#line 7152 "src/y.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 2853 "src/p.y" /* yacc.c:1906  */



/* -------------------------------------------------------- Parser interface */


/**
 * Syntactic error routine
 *
 * This routine is automatically called by the lexer!
 */
void yyerror(const char *s, ...) {
        ASSERT(s);
        char *msg = NULL;
        va_list ap;
        va_start(ap, s);
        msg = Str_vcat(s, ap);
        va_end(ap);
        LogError("%s:%i: %s '%s'\n", currentfile, lineno, msg, yytext);
        cfg_errflag++;
        FREE(msg);
}


/**
 * Syntactical warning routine
 */
void yywarning(const char *s, ...) {
        ASSERT(s);
        char *msg = NULL;
        va_list ap;
        va_start(ap, s);
        msg = Str_vcat(s, ap);
        va_end(ap);
        LogWarning("%s:%i: %s '%s'\n", currentfile, lineno, msg, yytext);
        FREE(msg);
}


/**
 * Argument error routine
 */
void yyerror2(const char *s, ...) {
        ASSERT(s);
        char *msg = NULL;
        va_list ap;
        va_start(ap, s);
        msg = Str_vcat(s, ap);
        va_end(ap);
        LogError("%s:%i: %s '%s'\n", argcurrentfile, arglineno, msg, argyytext);
        cfg_errflag++;
        FREE(msg);
}


/**
 * Argument warning routine
 */
void yywarning2(const char *s, ...) {
        ASSERT(s);
        char *msg = NULL;
        va_list ap;
        va_start(ap, s);
        msg = Str_vcat(s, ap);
        va_end(ap);
        LogWarning("%s:%i: %s '%s'\n", argcurrentfile, arglineno, msg, argyytext);
        FREE(msg);
}


/*
 * The Parser hook - start parsing the control file
 * Returns true if parsing succeeded, otherwise false
 */
boolean_t parse(char *controlfile) {
        ASSERT(controlfile);

        servicelist = tail = current = NULL;

        if ((yyin = fopen(controlfile,"r")) == (FILE *)NULL) {
                LogError("Cannot open the control file '%s' -- %s\n", controlfile, STRERROR);
                return false;
        }

        currentfile = Str_dup(controlfile);

        /*
         * Creation of the global service list is synchronized
         */
        LOCK(Run.mutex)
        {
                preparse();
                yyparse();
                fclose(yyin);
                postparse();
        }
        END_LOCK;

        FREE(currentfile);

        if (argyytext != NULL)
                FREE(argyytext);

        /*
         * Secure check the monitrc file. The run control file must have the
         * same uid as the REAL uid of this process, it must have permissions
         * no greater than 700 and it must not be a symbolic link.
         */
        if (! file_checkStat(controlfile, "control file", S_IRUSR|S_IWUSR|S_IXUSR))
                return false;

        return cfg_errflag == 0;
}


/* ----------------------------------------------------------------- Private */


/**
 * Initialize objects used by the parser.
 */
static void preparse() {
        /* Set instance incarnation ID */
        time(&Run.incarnation);
        /* Reset lexer */
        buffer_stack_ptr            = 0;
        lineno                      = 1;
        arglineno                   = 1;
        argcurrentfile              = NULL;
        argyytext                   = NULL;
        /* Reset parser */
        Run.limits.sendExpectBuffer  = LIMIT_SENDEXPECTBUFFER;
        Run.limits.fileContentBuffer = LIMIT_FILECONTENTBUFFER;
        Run.limits.httpContentBuffer = LIMIT_HTTPCONTENTBUFFER;
        Run.limits.programOutput     = LIMIT_PROGRAMOUTPUT;
        Run.limits.networkTimeout    = LIMIT_NETWORKTIMEOUT;
        Run.limits.programTimeout    = LIMIT_PROGRAMTIMEOUT;
        Run.limits.stopTimeout       = LIMIT_STOPTIMEOUT;
        Run.limits.startTimeout      = LIMIT_STARTTIMEOUT;
        Run.limits.restartTimeout    = LIMIT_RESTARTTIMEOUT;
        Run.onreboot                 = Onreboot_Start;
        Run.mmonitcredentials        = NULL;
        Run.httpd.flags              = Httpd_Disabled | Httpd_Signature;
        Run.httpd.credentials        = NULL;
        memset(&(Run.httpd.socket), 0, sizeof(Run.httpd.socket));
        Run.mailserver_timeout       = SMTP_TIMEOUT;
        Run.eventlist_dir            = NULL;
        Run.eventlist_slots          = -1;
        Run.system                   = NULL;
        Run.mmonits                  = NULL;
        Run.maillist                 = NULL;
        Run.mailservers              = NULL;
        Run.MailFormat.from          = NULL;
        Run.MailFormat.replyto       = NULL;
        Run.MailFormat.subject       = NULL;
        Run.MailFormat.message       = NULL;
        depend_list                  = NULL;
        Run.flags |= Run_HandlerInit | Run_MmonitCredentials;
        for (int i = 0; i <= Handler_Max; i++)
                Run.handler_queue[i] = 0;

        /*
         * Initialize objects
         */
        reset_uidset();
        reset_gidset();
        reset_statusset();
        reset_sizeset();
        reset_mailset();
        reset_sslset();
        reset_mailserverset();
        reset_mmonitset();
        reset_portset();
        reset_permset();
        reset_icmpset();
        reset_linkstatusset();
        reset_linkspeedset();
        reset_linksaturationset();
        reset_bandwidthset();
        reset_rateset(&rate);
        reset_rateset(&rate1);
        reset_rateset(&rate2);
        reset_filesystemset();
        reset_resourceset();
        reset_checksumset();
        reset_timestampset();
        reset_actionrateset();
}


/*
 * Check that values are reasonable after parsing
 */
static void postparse() {
        if (cfg_errflag)
                return;

        /* If defined - add the last service to the service list */
        if (current)
                addservice(current);

        /* Check that we do not start monit in daemon mode without having a poll time */
        if (! Run.polltime && ((Run.flags & Run_Daemon) || (Run.flags & Run_Foreground))) {
                LogError("Poll time is invalid or not defined. Please define poll time in the control file\nas a number (> 0)  or use the -d option when starting monit\n");
                cfg_errflag++;
        }

        if (Run.files.log)
                Run.flags |= Run_Log;

        /* Add the default general system service if not specified explicitly: service name default to hostname */
        if (! Run.system) {
                char hostname[STRLEN];
                if (gethostname(hostname, sizeof(hostname))) {
                        LogError("Cannot get system hostname -- please add 'check system <name>'\n");
                        cfg_errflag++;
                }
                if (Util_existService(hostname)) {
                        LogError("'check system' not defined in control file, failed to add automatic configuration (service name %s is used already) -- please add 'check system <name>' manually\n", hostname);
                        cfg_errflag++;
                }
                Run.system = createservice(Service_System, Str_dup(hostname), NULL, check_system);
                addservice(Run.system);
        }
        addeventaction(&(Run.system->action_MONIT_START), Action_Start, Action_Ignored);
        addeventaction(&(Run.system->action_MONIT_STOP), Action_Stop,  Action_Ignored);

        if (Run.mmonits) {
                if (Run.httpd.flags & Httpd_Net) {
                        if (Run.flags & Run_MmonitCredentials) {
                                Auth_T c;
                                for (c = Run.httpd.credentials; c; c = c->next) {
                                        if (c->digesttype == Digest_Cleartext && ! c->is_readonly) {
                                                Run.mmonitcredentials = c;
                                                break;
                                        }
                                }
                                if (! Run.mmonitcredentials)
                                        LogWarning("M/Monit registration with credentials enabled, but no suitable credentials found in monit configuration file -- please add 'allow user:password' option to 'set httpd' statement\n");
                        }
                } else if (Run.httpd.flags & Httpd_Unix) {
                        LogWarning("M/Monit enabled but Monit httpd is using unix socket -- please change 'set httpd' statement to use TCP port in order to be able to manage services on Monit\n");
                } else {
                        LogWarning("M/Monit enabled but no httpd allowed -- please add 'set httpd' statement\n");
                }
        }

        /* Check the sanity of any dependency graph */
        check_depend();

#ifdef HAVE_OPENSSL
        Ssl_setFipsMode(Run.flags & Run_FipsEnabled);
#endif

        Processor_setHttpPostLimit();
}


static boolean_t _parseOutgoingAddress(const char *ip, Outgoing_T *outgoing) {
        struct addrinfo *result, hints = {.ai_flags = AI_NUMERICHOST};
        int status = getaddrinfo(ip, NULL, &hints, &result);
        if (status == 0) {
                outgoing->ip = (char *)ip;
                outgoing->addrlen = result->ai_addrlen;
                memcpy(&(outgoing->addr), result->ai_addr, result->ai_addrlen);
                freeaddrinfo(result);
                return true;
        } else {
                yyerror2("IP address parsing failed -- %s", ip, status == EAI_SYSTEM ? STRERROR : gai_strerror(status));
        }
        return false;
}


/*
 * Create a new service object and add any current objects to the
 * service list.
 */
static Service_T createservice(Service_Type type, char *name, char *value, State_Type (*check)(Service_T s)) {
        ASSERT(name);

        check_name(name);

        if (current)
                addservice(current);

        NEW(current);
        current->type = type;
        switch (type) {
                case Service_Directory:
                        NEW(current->inf.directory);
                        break;
                case Service_Fifo:
                        NEW(current->inf.fifo);
                        break;
                case Service_File:
                        NEW(current->inf.file);
                        break;
                case Service_Filesystem:
                        NEW(current->inf.filesystem);
                        break;
                case Service_Net:
                        NEW(current->inf.net);
                        break;
                case Service_Process:
                        NEW(current->inf.process);
                        break;
                default:
                        break;
        }
        Util_resetInfo(current);

        if (type == Service_Program) {
                NEW(current->program);
                current->program->args = command;
                command = NULL;
                current->program->timeout = Run.limits.programTimeout;
        }

        /* Set default values */
        current->mode     = Monitor_Active;
        current->monitor  = Monitor_Init;
        current->onreboot = Run.onreboot;
        current->name     = name;
        current->check    = check;
        current->path     = value;

        /* Initialize general event handlers */
        addeventaction(&(current)->action_DATA,     Action_Alert,     Action_Alert);
        addeventaction(&(current)->action_EXEC,     Action_Alert,     Action_Alert);
        addeventaction(&(current)->action_INVALID,  Action_Restart,   Action_Alert);

        /* Initialize internal event handlers */
        addeventaction(&(current)->action_ACTION,       Action_Alert, Action_Ignored);

        gettimeofday(&current->collected, NULL);

        return current;
}


/*
 * Add a service object to the servicelist
 */
static void addservice(Service_T s) {
        ASSERT(s);

        // Test sanity check
        switch (s->type) {
                case Service_Host:
                        // Verify that a remote service has a port or an icmp list
                        if (! s->portlist && ! s->icmplist) {
                                LogError("'check host' statement is incomplete: Please specify a port number to test\n or an icmp test at the remote host: '%s'\n", s->name);
                                cfg_errflag++;
                        }
                        break;
                case Service_Program:
                        // Verify that a program test has a status test
                        if (! s->statuslist) {
                                LogError("'check program %s' is incomplete: Please add an 'if status != n' test\n", s->name);
                                cfg_errflag++;
                        }
                        // Create the Command object
                        char program[PATH_MAX];
                        strncpy(program, s->program->args->arg[0], sizeof(program) - 1);
                        s->program->C = Command_new(program, NULL);
                        for (int i = 1; i < s->program->args->length; i++) {
                                Command_appendArgument(s->program->C, s->program->args->arg[i]);
                                snprintf(program + strlen(program), sizeof(program) - strlen(program) - 1, " %s", s->program->args->arg[i]);
                        }
                        s->path = Str_dup(program);
                        if (s->program->args->has_uid)
                                Command_setUid(s->program->C, s->program->args->uid);
                        if (s->program->args->has_gid)
                                Command_setGid(s->program->C, s->program->args->gid);
                        // Set environment
                        Command_setEnv(s->program->C, "MONIT_SERVICE", s->name);
                        break;
                case Service_Net:
                        if (! s->linkstatuslist) {
                                // Add link status test if not defined
                                addeventaction(&(linkstatusset).action, Action_Alert, Action_Alert);
                                addlinkstatus(s, &linkstatusset);
                        }
                        break;
                case Service_Filesystem:
                        if (! s->nonexistlist && ! s->existlist) {
                                // Add non-existence test if not defined
                                addeventaction(&(nonexistset).action, Action_Restart, Action_Alert);
                                addnonexist(&nonexistset);
                        }
                        if (! s->fsflaglist) {
                                // Add filesystem flags change test if not defined
                                addeventaction(&(fsflagset).action, Action_Alert, Action_Ignored);
                                addfsflag(&fsflagset);
                        }
                        break;
                case Service_Directory:
                case Service_Fifo:
                case Service_File:
                case Service_Process:
                        if (! s->nonexistlist && ! s->existlist) {
                                // Add existence test if not defined
                                addeventaction(&(nonexistset).action, Action_Restart, Action_Alert);
                                addnonexist(&nonexistset);
                        }
                        break;
                default:
                        break;
        }

        /* Add the service to the end of the service list */
        if (tail != NULL) {
                tail->next = s;
                tail->next_conf = s;
        } else {
                servicelist = s;
                servicelist_conf = s;
        }
        tail = s;
}


/*
 * Add entry to service group list
 */
static void addservicegroup(char *name) {
        ServiceGroup_T g;

        ASSERT(name);

        /* Check if service group with the same name is defined already */
        for (g = servicegrouplist; g; g = g->next)
                if (IS(g->name, name))
                        break;

        if (! g) {
                NEW(g);
                g->name = Str_dup(name);
                g->members = List_new();
                g->next = servicegrouplist;
                servicegrouplist = g;
        }

        List_append(g->members, current);
}


/*
 * Add a dependant entry to the current service dependant list
 *
 */
static void adddependant(char *dependant) {
        Dependant_T d;

        ASSERT(dependant);

        NEW(d);

        if (current->dependantlist)
                d->next = current->dependantlist;

        d->dependant = dependant;
        current->dependantlist = d;

}


/*
 * Add the given mailaddress with the appropriate alert notification
 * values and mail attributes to the given mailinglist.
 */
static void addmail(char *mailto, Mail_T f, Mail_T *l) {
        Mail_T m;

        ASSERT(mailto);

        NEW(m);
        m->to       = mailto;
        m->from     = f->from;
        m->replyto  = f->replyto;
        m->subject  = f->subject;
        m->message  = f->message;
        m->events   = f->events;
        m->reminder = f->reminder;

        m->next = *l;
        *l = m;

        reset_mailset();
}


/*
 * Add the given portset to the current service's portlist
 */
static void addport(Port_T *list, Port_T port) {
        ASSERT(port);

        if (port->protocol->check == check_radius && port->type != Socket_Udp)
                yyerror("Radius protocol test supports UDP only");

        Port_T p;
        NEW(p);
        p->is_available       = Connection_Init;
        p->type               = port->type;
        p->socket             = port->socket;
        p->family             = port->family;
        p->action             = port->action;
        p->timeout            = port->timeout;
        p->retry              = port->retry;
        p->protocol           = port->protocol;
        p->hostname           = port->hostname;
        p->url_request        = port->url_request;
        p->outgoing           = port->outgoing;
        if (p->family == Socket_Unix) {
                p->target.unix.pathname = port->target.unix.pathname;
        } else {
                p->target.net.port = port->target.net.port;
                if (sslset.flags) {
#ifdef HAVE_OPENSSL
                        p->target.net.ssl.certificate.minimumDays = port->target.net.ssl.certificate.minimumDays;
                        if (sslset.flags && (p->target.net.port == 25 || p->target.net.port == 587))
                                sslset.flags = SSL_StartTLS;
                        _setSSLOptions(&(p->target.net.ssl.options));
#else
                        yyerror("SSL check cannot be activated -- Monit was not built with SSL support");
#endif
                }
        }
        memcpy(&p->parameters, &port->parameters, sizeof(port->parameters));

        if (p->protocol->check == check_http) {
                if (p->parameters.http.checksum) {
                        cleanup_hash_string(p->parameters.http.checksum);
                        if (strlen(p->parameters.http.checksum) == 32)
                                p->parameters.http.hashtype = Hash_Md5;
                        else if (strlen(p->parameters.http.checksum) == 40)
                                p->parameters.http.hashtype = Hash_Sha1;
                        else
                                yyerror2("invalid checksum [%s]", p->parameters.http.checksum);
                } else {
                        p->parameters.http.hashtype = Hash_Unknown;
                }
                if (! p->parameters.http.method) {
                        if ((p->url_request && p->url_request->regex) || p->parameters.http.checksum) {
                                p->parameters.http.method = Http_Get;
                        } else {
                                p->parameters.http.method = Http_Head;
                        }
                } else if (p->parameters.http.method == Http_Head) {
                        // Sanity check: if content or checksum test is used, the method Http_Head is not allowed, as we need the content
                        if ((p->url_request && p->url_request->regex) || p->parameters.http.checksum) {
                                yyerror2("if response content or checksum test is enabled, the HEAD method is not allowed");
                        }
                }
        }

        p->next = *list;
        *list = p;

        reset_sslset();
        reset_portset();

}


static void addhttpheader(Port_T port, const char *header) {
        if (! port->parameters.http.headers) {
                port->parameters.http.headers = List_new();
        }
        if (Str_startsWith(header, "Connection:") && ! Str_sub(header, "close")) {
                yywarning("We don't recommend setting the Connection header. Monit will always close the connection even if 'keep-alive' is set\n");
        }
        List_append(port->parameters.http.headers, (char *)header);
}


/*
 * Add a new resource object to the current service resource list
 */
static void addresource(Resource_T rr) {
        ASSERT(rr);
        if (Run.flags & Run_ProcessEngineEnabled) {
                Resource_T r;
                NEW(r);
                r->resource_id = rr->resource_id;
                r->limit       = rr->limit;
                r->action      = rr->action;
                r->operator    = rr->operator;
                r->next        = current->resourcelist;
                current->resourcelist = r;
        } else {
                yywarning("Cannot activate service check. The process status engine was disabled. On certain systems you must run monit as root to utilize this feature)\n");
        }
        reset_resourceset();
}


/*
 * Add a new file object to the current service timestamp list
 */
static void addtimestamp(Timestamp_T ts) {
        ASSERT(ts);

        Timestamp_T t;
        NEW(t);
        t->type         = ts->type;
        t->operator     = ts->operator;
        t->time         = ts->time;
        t->action       = ts->action;
        t->test_changes = ts->test_changes;

        t->next = current->timestamplist;
        current->timestamplist = t;

        reset_timestampset();
}


/*
 * Add a new object to the current service actionrate list
 */
static void addactionrate(ActionRate_T ar) {
        ActionRate_T a;

        ASSERT(ar);

        if (ar->count > ar->cycle)
                yyerror2("The number of restarts must be less than poll cycles");
        if (ar->count <= 0 || ar->cycle <= 0)
                yyerror2("Zero or negative values not allowed in a action rate statement");

        NEW(a);
        a->count  = ar->count;
        a->cycle  = ar->cycle;
        a->action = ar->action;

        a->next = current->actionratelist;
        current->actionratelist = a;

        reset_actionrateset();
}



/*
 * Add a new Size object to the current service size list
 */
static void addsize(Size_T ss) {
        Size_T s;
        struct stat buf;

        ASSERT(ss);

        NEW(s);
        s->operator     = ss->operator;
        s->size         = ss->size;
        s->action       = ss->action;
        s->test_changes = ss->test_changes;
        /* Get the initial size for future comparision, if the file exists */
        if (s->test_changes) {
                s->initialized = ! stat(current->path, &buf);
                if (s->initialized)
                        s->size = (unsigned long long)buf.st_size;
        }

        s->next = current->sizelist;
        current->sizelist = s;

        reset_sizeset();
}


/*
 * Add a new Uptime object to the current service uptime list
 */
static void adduptime(Uptime_T uu) {
        Uptime_T u;

        ASSERT(uu);

        NEW(u);
        u->operator = uu->operator;
        u->uptime = uu->uptime;
        u->action = uu->action;

        u->next = current->uptimelist;
        current->uptimelist = u;

        reset_uptimeset();
}


/*
 * Add a new Pid object to the current service pid list
 */
static void addpid(Pid_T pp) {
        ASSERT(pp);

        Pid_T p;
        NEW(p);
        p->action = pp->action;

        p->next = current->pidlist;
        current->pidlist = p;

        reset_pidset();
}


/*
 * Add a new PPid object to the current service ppid list
 */
static void addppid(Pid_T pp) {
        ASSERT(pp);

        Pid_T p;
        NEW(p);
        p->action = pp->action;

        p->next = current->ppidlist;
        current->ppidlist = p;

        reset_ppidset();
}


/*
 * Add a new Fsflag object to the current service fsflag list
 */
static void addfsflag(FsFlag_T ff) {
        ASSERT(ff);

        FsFlag_T f;
        NEW(f);
        f->action = ff->action;

        f->next = current->fsflaglist;
        current->fsflaglist = f;

        reset_fsflagset();
}


/*
 * Add a new Nonexist object to the current service list
 */
static void addnonexist(NonExist_T ff) {
        ASSERT(ff);

        NonExist_T f;
        NEW(f);
        f->action = ff->action;

        f->next = current->nonexistlist;
        current->nonexistlist = f;

        reset_nonexistset();
}


static void addexist(Exist_T rule) {
        ASSERT(rule);
        Exist_T r;
        NEW(r);
        r->action = rule->action;
        r->next = current->existlist;
        current->existlist = r;
        reset_existset();
}


/*
 * Set Checksum object in the current service
 */
static void addchecksum(Checksum_T cs) {
        ASSERT(cs);

        cs->initialized = true;

        if (STR_UNDEF(cs->hash)) {
                if (cs->type == Hash_Unknown)
                        cs->type = Hash_Default;
                if (! (Util_getChecksum(current->path, cs->type, cs->hash, sizeof(cs->hash)))) {
                        /* If the file doesn't exist, set dummy value */
                        snprintf(cs->hash, sizeof(cs->hash), cs->type == Hash_Md5 ? "00000000000000000000000000000000" : "0000000000000000000000000000000000000000");
                        cs->initialized = false;
                        yywarning2("Cannot compute a checksum for file %s", current->path);
                }
        }

        int len = cleanup_hash_string(cs->hash);
        if (cs->type == Hash_Unknown) {
                if (len == 32) {
                        cs->type = Hash_Md5;
                } else if (len == 40) {
                        cs->type = Hash_Sha1;
                } else {
                        yyerror2("Unknown checksum type [%s] for file %s", cs->hash, current->path);
                        reset_checksumset();
                        return;
                }
        } else if ((cs->type == Hash_Md5 && len != 32) || (cs->type == Hash_Sha1 && len != 40)) {
                yyerror2("Invalid checksum [%s] for file %s", cs->hash, current->path);
                reset_checksumset();
                return;
        }

        Checksum_T c;
        NEW(c);
        c->type         = cs->type;
        c->test_changes = cs->test_changes;
        c->initialized  = cs->initialized;
        c->action       = cs->action;
        snprintf(c->hash, sizeof(c->hash), "%s", cs->hash);

        current->checksum = c;

        reset_checksumset();

}


/*
 * Set Perm object in the current service
 */
static void addperm(Perm_T ps) {
        ASSERT(ps);

        Perm_T p;
        NEW(p);
        p->action = ps->action;
        p->test_changes = ps->test_changes;
        if (p->test_changes) {
                if (! File_exist(current->path))
                        DEBUG("The path '%s' used in the PERMISSION statement refer to a non-existing object\n", current->path);
                else if ((p->perm = File_mod(current->path)) < 0)
                        yyerror2("Cannot get the timestamp for '%s'", current->path);
                else
                        p->perm &= 07777;
        } else {
                p->perm = ps->perm;
        }
        current->perm = p;
        reset_permset();
}


static void addlinkstatus(Service_T s, LinkStatus_T L) {
        ASSERT(L);
        
        LinkStatus_T l;
        NEW(l);
        l->action = L->action;
        
        l->next = s->linkstatuslist;
        s->linkstatuslist = l;
        
        reset_linkstatusset();
}


static void addlinkspeed(Service_T s, LinkSpeed_T L) {
        ASSERT(L);
        
        LinkSpeed_T l;
        NEW(l);
        l->action = L->action;
        
        l->next = s->linkspeedlist;
        s->linkspeedlist = l;
        
        reset_linkspeedset();
}


static void addlinksaturation(Service_T s, LinkSaturation_T L) {
        ASSERT(L);
        
        LinkSaturation_T l;
        NEW(l);
        l->operator = L->operator;
        l->limit = L->limit;
        l->action = L->action;
        
        l->next = s->linksaturationlist;
        s->linksaturationlist = l;
        
        reset_linksaturationset();
}


/*
 * Return Bandwidth object
 */
static void addbandwidth(Bandwidth_T *list, Bandwidth_T b) {
        ASSERT(list);
        ASSERT(b);

        if (b->rangecount * b->range > 24 * Time_Hour) {
                yyerror2("Maximum range for total test is 24 hours");
        } else if (b->range == Time_Minute && b->rangecount > 60) {
                yyerror2("Maximum value for [minute(s)] unit is 60");
        } else if (b->range == Time_Hour && b->rangecount > 24) {
                yyerror2("Maximum value for [hour(s)] unit is 24");
        } else if (b->range == Time_Day && b->rangecount > 1) {
                yyerror2("Maximum value for [day(s)] unit is 1");
        } else {
                if (b->range == Time_Day) {
                        // translate last day -> last 24 hours
                        b->rangecount = 24;
                        b->range = Time_Hour;
                }
                Bandwidth_T bandwidth;
                NEW(bandwidth);
                bandwidth->operator = b->operator;
                bandwidth->limit = b->limit;
                bandwidth->rangecount = b->rangecount;
                bandwidth->range = b->range;
                bandwidth->action = b->action;
                bandwidth->next = *list;
                *list = bandwidth;
        }
        reset_bandwidthset();
}


static void appendmatch(Match_T *list, Match_T item) {
        if (*list) {
                /* Find the end of the list (keep the same patterns order as in the config file) */
                Match_T last;
                for (last = *list; last->next; last = last->next)
                        ;
                last->next = item;
        } else {
                *list = item;
        }
}


/*
 * Set Match object in the current service
 */
static void addmatch(Match_T ms, int actionnumber, int linenumber) {
        Match_T m;

        ASSERT(ms);

        NEW(m);
        NEW(m->regex_comp);

        m->match_string = ms->match_string;
        m->match_path   = ms->match_path ? Str_dup(ms->match_path) : NULL;
        m->action       = ms->action;
        m->not          = ms->not;
        m->ignore       = ms->ignore;
        m->next         = NULL;

        addeventaction(&(m->action), actionnumber, Action_Ignored);

        int reg_return = regcomp(m->regex_comp, ms->match_string, REG_NOSUB|REG_EXTENDED);

        if (reg_return != 0) {
                char errbuf[STRLEN];
                regerror(reg_return, ms->regex_comp, errbuf, STRLEN);
                if (m->match_path != NULL)
                        yyerror2("Regex parsing error: %s on line %i of", errbuf, linenumber);
                else
                        yyerror2("Regex parsing error: %s", errbuf);
        }
        appendmatch(m->ignore ? &current->matchignorelist : &current->matchlist, m);
}


static void addmatchpath(Match_T ms, Action_Type actionnumber) {

        FILE *handle;
        command_t savecommand = NULL;
        char buf[2048];
        int linenumber = 0;

        ASSERT(ms->match_path);

        handle = fopen(ms->match_path, "r");
        if (handle == NULL) {
                yyerror2("Cannot read regex match file (%s)", ms->match_path);
                return;
        }

        while (! feof(handle)) {
                size_t len;

                linenumber++;

                if (! fgets(buf, 2048, handle))
                        continue;

                len = strlen(buf);

                if (len == 0 || buf[0] == '\n')
                        continue;

                if (buf[len-1] == '\n')
                        buf[len-1] = 0;

                ms->match_string = Str_dup(buf);

                /* The addeventaction() called from addmatch() will reset the
                 * command1 to NULL, but we need to duplicate the command for
                 * each line, thus need to save it here */
                if (actionnumber == Action_Exec) {
                        if (command1 == NULL) {
                                ASSERT(savecommand);
                                command1 = savecommand;
                        }
                        savecommand = copycommand(command1);
                }
                
                addmatch(ms, actionnumber, linenumber);
        }
        
        if (actionnumber == Action_Exec && savecommand)
                gccmd(&savecommand);
        
        fclose(handle);
}


/*
 * Set exit status test object in the current service
 */
static void addstatus(Status_T status) {
        Status_T s;
        ASSERT(status);
        NEW(s);
        s->initialized = status->initialized;
        s->return_value = status->return_value;
        s->operator = status->operator;
        s->action = status->action;
        s->next = current->statuslist;
        current->statuslist = s;

        reset_statusset();
}


/*
 * Set Uid object in the current service
 */
static Uid_T adduid(Uid_T u) {
        ASSERT(u);

        Uid_T uid;
        NEW(uid);
        uid->uid = u->uid;
        uid->action = u->action;
        reset_uidset();
        return uid;
}


/*
 * Set Gid object in the current service
 */
static Gid_T addgid(Gid_T g) {
        ASSERT(g);

        Gid_T gid;
        NEW(gid);
        gid->gid = g->gid;
        gid->action = g->action;
        reset_gidset();
        return gid;
}


/*
 * Add a new filesystem to the current service's filesystem list
 */
static void addfilesystem(FileSystem_T ds) {
        FileSystem_T dev;

        ASSERT(ds);

        NEW(dev);
        dev->resource           = ds->resource;
        dev->operator           = ds->operator;
        dev->limit_absolute     = ds->limit_absolute;
        dev->limit_percent      = ds->limit_percent;
        dev->action             = ds->action;

        dev->next               = current->filesystemlist;
        current->filesystemlist = dev;
        
        reset_filesystemset();

}


/*
 * Add a new icmp object to the current service's icmp list
 */
static void addicmp(Icmp_T is) {
        Icmp_T icmp;

        ASSERT(is);

        NEW(icmp);
        icmp->family       = is->family;
        icmp->type         = is->type;
        icmp->size         = is->size;
        icmp->count        = is->count;
        icmp->timeout      = is->timeout;
        icmp->action       = is->action;
        icmp->outgoing     = is->outgoing;
        icmp->is_available = Connection_Init;
        icmp->response     = -1;

        icmp->next         = current->icmplist;
        current->icmplist  = icmp;

        reset_icmpset();
}


/*
 * Set EventAction object
 */
static void addeventaction(EventAction_T *_ea, Action_Type failed, Action_Type succeeded) {
        EventAction_T ea;

        ASSERT(_ea);

        NEW(ea);
        NEW(ea->failed);
        NEW(ea->succeeded);

        ea->failed->id = failed;
        ea->failed->repeat = repeat1;
        ea->failed->count = rate1.count;
        ea->failed->cycles = rate1.cycles;
        if (failed == Action_Exec) {
                ASSERT(command1);
                ea->failed->exec = command1;
                command1 = NULL;
        }

        ea->succeeded->id = succeeded;
        ea->succeeded->repeat = repeat2;
        ea->succeeded->count = rate2.count;
        ea->succeeded->cycles = rate2.cycles;
        if (succeeded == Action_Exec) {
                ASSERT(command2);
                ea->succeeded->exec = command2;
                command2 = NULL;
        }
        *_ea = ea;
        reset_rateset(&rate);
        reset_rateset(&rate1);
        reset_rateset(&rate2);
        repeat = repeat1 = repeat2 = 0;
}


/*
 * Add a generic protocol handler to
 */
static void addgeneric(Port_T port, char *send, char *expect) {
        Generic_T g = port->parameters.generic.sendexpect;
        if (! g) {
                NEW(g);
                port->parameters.generic.sendexpect = g;
        } else {
                while (g->next)
                        g = g->next;
                NEW(g->next);
                g = g->next;
        }
        if (send) {
                g->send = send;
                g->expect = NULL;
        } else if (expect) {
                int reg_return;
                NEW(g->expect);
                reg_return = regcomp(g->expect, expect, REG_NOSUB|REG_EXTENDED);
                FREE(expect);
                if (reg_return != 0) {
                        char errbuf[STRLEN];
                        regerror(reg_return, g->expect, errbuf, STRLEN);
                        yyerror2("Regex parsing error: %s", errbuf);
                }
                g->send = NULL;
        }
}


/*
 * Add the current command object to the current service object's
 * start or stop program.
 */
static void addcommand(int what, unsigned timeout) {

        switch (what) {
                case START:   current->start = command; break;
                case STOP:    current->stop = command; break;
                case RESTART: current->restart = command; break;
        }

        command->timeout = timeout;
        
        command = NULL;

}


/*
 * Add a new argument to the argument list
 */
static void addargument(char *argument) {

        ASSERT(argument);

        if (! command) {

                NEW(command);
                check_exec(argument);

        }

        command->arg[command->length++] = argument;
        command->arg[command->length] = NULL;

        if (command->length >= ARGMAX)
                yyerror("Exceeded maximum number of program arguments");

}


/*
 * Setup a url request for the current port object
 */
static void prepare_urlrequest(URL_T U) {

        ASSERT(U);

        /* Only the HTTP protocol is supported for URLs currently. See also the lexer if this is to be changed in the future */
        portset.protocol = Protocol_get(Protocol_HTTP);

        if (urlrequest == NULL)
                NEW(urlrequest);
        urlrequest->url = U;
        portset.hostname = Str_dup(U->hostname);
        portset.target.net.port = U->port;
        portset.url_request = urlrequest;
        portset.type = Socket_Tcp;
        portset.parameters.http.request = Str_cat("%s%s%s", U->path, U->query ? "?" : "", U->query ? U->query : "");
        if (IS(U->protocol, "https"))
                sslset.flags = SSL_Enabled;
}


/*
 * Set the url request for a port
 */
static void  seturlrequest(int operator, char *regex) {

        ASSERT(regex);

        if (! urlrequest)
                NEW(urlrequest);
        urlrequest->operator = operator;
        int reg_return;
        NEW(urlrequest->regex);
        reg_return = regcomp(urlrequest->regex, regex, REG_NOSUB|REG_EXTENDED);
        if (reg_return != 0) {
                char errbuf[STRLEN];
                regerror(reg_return, urlrequest->regex, errbuf, STRLEN);
                yyerror2("Regex parsing error: %s", errbuf);
        }
}


/*
 * Add a new data recipient server to the mmonit server list
 */
static void addmmonit(Mmonit_T mmonit) {
        ASSERT(mmonit->url);

        Mmonit_T c;
        NEW(c);
        c->url = mmonit->url;
        c->compress = MmonitCompress_Init;
        _setSSLOptions(&(c->ssl));
        if (IS(c->url->protocol, "https")) {
#ifdef HAVE_OPENSSL
                c->ssl.flags = SSL_Enabled;
#else
                yyerror("SSL check cannot be activated -- SSL disabled");
#endif
        }
        c->timeout = mmonit->timeout;
        c->next = NULL;

        if (Run.mmonits) {
                Mmonit_T C;
                for (C = Run.mmonits; C->next; C = C->next)
                        /* Empty */ ;
                C->next = c;
        } else {
                Run.mmonits = c;
        }
        reset_sslset();
        reset_mmonitset();
}


/*
 * Add a new smtp server to the mail server list
 */
static void addmailserver(MailServer_T mailserver) {

        MailServer_T s;

        ASSERT(mailserver->host);

        NEW(s);
        s->host        = mailserver->host;
        s->port        = mailserver->port;
        s->username    = mailserver->username;
        s->password    = mailserver->password;

        if (sslset.flags && (mailserver->port == 25 || mailserver->port == 587))
                sslset.flags = SSL_StartTLS;
        _setSSLOptions(&(s->ssl));

        s->next = NULL;

        if (Run.mailservers) {
                MailServer_T l;
                for (l = Run.mailservers; l->next; l = l->next)
                        /* empty */;
                l->next = s;
        } else {
                Run.mailservers = s;
        }
        reset_mailserverset();
}


/*
 * Return uid if found on the system. If the parameter user is NULL
 * the uid parameter is used for looking up the user id on the system,
 * otherwise the user parameter is used.
 */
static uid_t get_uid(char *user, uid_t uid) {
        char buf[4096];
        struct passwd pwd, *result = NULL;
        if (user) {
                if (getpwnam_r(user, &pwd, buf, sizeof(buf), &result) != 0 || ! result) {
                        yyerror2("Requested user not found on the system");
                        return(0);
                }
        } else {
                if (getpwuid_r(uid, &pwd, buf, sizeof(buf), &result) != 0 || ! result) {
                        yyerror2("Requested uid not found on the system");
                        return(0);
                }
        }
        return(pwd.pw_uid);
}


/*
 * Return gid if found on the system. If the parameter group is NULL
 * the gid parameter is used for looking up the group id on the system,
 * otherwise the group parameter is used.
 */
static gid_t get_gid(char *group, gid_t gid) {
        struct group *grd;

        if (group) {
                grd = getgrnam(group);

                if (! grd) {
                        yyerror2("Requested group not found on the system");
                        return(0);
                }

        } else {

                if (! (grd = getgrgid(gid))) {
                        yyerror2("Requested gid not found on the system");
                        return(0);
                }

        }

        return(grd->gr_gid);

}


/*
 * Add a new user id to the current command object.
 */
static void addeuid(uid_t uid) {
        if (! getuid()) {
                command->has_uid = true;
                command->uid = uid;
        } else {
                yyerror("UID statement requires root privileges");
        }
}


/*
 * Add a new group id to the current command object.
 */
static void addegid(gid_t gid) {
        if (! getuid()) {
                command->has_gid = true;
                command->gid = gid;
        } else {
                yyerror("GID statement requires root privileges");
        }
}


/*
 * Reset the logfile if changed
 */
static void setlogfile(char *logfile) {
        if (Run.files.log) {
                if (IS(Run.files.log, logfile)) {
                        FREE(logfile);
                        return;
                } else {
                        FREE(Run.files.log);
                }
        }
        Run.files.log = logfile;
}


/*
 * Reset the pidfile if changed
 */
static void setpidfile(char *pidfile) {
        if (Run.files.pid) {
                if (IS(Run.files.pid, pidfile)) {
                        FREE(pidfile);
                        return;
                } else {
                        FREE(Run.files.pid);
                }
        }
        Run.files.pid = pidfile;
}


/*
 * Read a apache htpasswd file and add credentials found for username
 */
static void addhtpasswdentry(char *filename, char *username, Digest_Type dtype) {
        char *ht_username = NULL;
        char *ht_passwd = NULL;
        char buf[STRLEN];
        FILE *handle = NULL;
        int credentials_added = 0;

        ASSERT(filename);

        handle = fopen(filename, "r");

        if ( handle == NULL ) {
                if (username != NULL)
                        yyerror2("Cannot read htpasswd (%s)", filename);
                else
                        yyerror2("Cannot read htpasswd", filename);
                return;
        }

        while (! feof(handle)) {
                char *colonindex = NULL;

                if (! fgets(buf, STRLEN, handle))
                        continue;

                Str_rtrim(buf);
                Str_curtail(buf, "#");

                if ( NULL == (colonindex = strchr(buf, ':')))
                continue;

                ht_passwd = Str_dup(colonindex+1);
                *colonindex = '\0';

                /* In case we have a file in /etc/passwd or /etc/shadow style we
                 *  want to remove ":.*$" and Crypt and MD5 hashed dont have a colon
                 */

                if ( (NULL != (colonindex = strchr(ht_passwd, ':'))) && ( dtype != Digest_Cleartext) )
                *colonindex = '\0';

                ht_username = Str_dup(buf);

                if (username == NULL) {
                        if (addcredentials(ht_username, ht_passwd, dtype, false))
                                credentials_added++;
                } else if (Str_cmp(username, ht_username) == 0)  {
                        if (addcredentials(ht_username, ht_passwd, dtype, false))
                                credentials_added++;
                } else {
                        FREE(ht_passwd);
                        FREE(ht_username);
                }
        }

        if (credentials_added == 0) {
                if ( username == NULL )
                        yywarning2("htpasswd file (%s) has no usable credentials", filename);
                else
                        yywarning2("htpasswd file (%s) has no usable credentials for user %s", filename, username);
        }
        fclose(handle);
}


#ifdef HAVE_LIBPAM
static void addpamauth(char* groupname, int readonly) {
        Auth_T prev = NULL;

        ASSERT(groupname);

        if (! Run.httpd.credentials)
                NEW(Run.httpd.credentials);

        Auth_T c = Run.httpd.credentials;
        do {
                if (c->groupname != NULL && IS(c->groupname, groupname)) {
                        yywarning2("PAM group %s was added already, entry ignored", groupname);
                        FREE(groupname);
                        return;
                }
                prev = c;
                c = c->next;
        } while (c != NULL);

        NEW(prev->next);
        c = prev->next;

        c->next        = NULL;
        c->uname       = NULL;
        c->passwd      = NULL;
        c->groupname   = groupname;
        c->digesttype  = Digest_Pam;
        c->is_readonly = readonly;

        DEBUG("Adding PAM group '%s'\n", groupname);

        return;
}
#endif


/*
 * Add Basic Authentication credentials
 */
static boolean_t addcredentials(char *uname, char *passwd, Digest_Type dtype, boolean_t readonly) {
        Auth_T c;

        ASSERT(uname);
        ASSERT(passwd);

        if (strlen(passwd) > MAX_CONSTANT_TIME_STRING_LENGTH) {
                yyerror2("Password for user %s is too long, maximum %d allowed", uname, MAX_CONSTANT_TIME_STRING_LENGTH);
                FREE(uname);
                FREE(passwd);
                return false;
        }

        if (! Run.httpd.credentials) {
                NEW(Run.httpd.credentials);
                c = Run.httpd.credentials;
        } else {
                if (Util_getUserCredentials(uname) != NULL) {
                        yywarning2("Credentials for user %s were already added, entry ignored", uname);
                        FREE(uname);
                        FREE(passwd);
                        return false;
                }
                c = Run.httpd.credentials;
                while (c->next != NULL)
                        c = c->next;
                NEW(c->next);
                c = c->next;
        }

        c->next        = NULL;
        c->uname       = uname;
        c->passwd      = passwd;
        c->groupname   = NULL;
        c->digesttype  = dtype;
        c->is_readonly = readonly;

        DEBUG("Adding credentials for user '%s'\n", uname);

        return true;

}


/*
 * Set the syslog and the facilities to be used
 */
static void setsyslog(char *facility) {

        if (! Run.files.log || ihp.logfile) {
                ihp.logfile = true;
                setlogfile(Str_dup("syslog"));
                Run.flags |= Run_UseSyslog;
                Run.flags |= Run_Log;
        }

        if (facility) {
                if (IS(facility,"log_local0"))
                        Run.facility = LOG_LOCAL0;
                else if (IS(facility, "log_local1"))
                        Run.facility = LOG_LOCAL1;
                else if (IS(facility, "log_local2"))
                        Run.facility = LOG_LOCAL2;
                else if (IS(facility, "log_local3"))
                        Run.facility = LOG_LOCAL3;
                else if (IS(facility, "log_local4"))
                        Run.facility = LOG_LOCAL4;
                else if (IS(facility, "log_local5"))
                        Run.facility = LOG_LOCAL5;
                else if (IS(facility, "log_local6"))
                        Run.facility = LOG_LOCAL6;
                else if (IS(facility, "log_local7"))
                        Run.facility = LOG_LOCAL7;
                else if (IS(facility, "log_daemon"))
                        Run.facility = LOG_DAEMON;
                else
                        yyerror2("Invalid syslog facility");
        } else {
                Run.facility = LOG_USER;
        }

}


/*
 * Reset the current sslset for reuse
 */
static void reset_sslset() {
        memset(&sslset, 0, sizeof(struct SslOptions_T));
        sslset.version = sslset.verify = sslset.allowSelfSigned = -1;
}


/*
 * Reset the current mailset for reuse
 */
static void reset_mailset() {
        memset(&mailset, 0, sizeof(struct Mail_T));
}


/*
 * Reset the mailserver set to default values
 */
static void reset_mailserverset() {
        memset(&mailserverset, 0, sizeof(struct MailServer_T));
        mailserverset.port = PORT_SMTP;
}


/*
 * Reset the mmonit set to default values
 */
static void reset_mmonitset() {
        memset(&mmonitset, 0, sizeof(struct Mmonit_T));
        mmonitset.timeout = Run.limits.networkTimeout;
}


/*
 * Reset the Port set to default values
 */
static void reset_portset() {
        memset(&portset, 0, sizeof(struct Port_T));
        portset.socket = -1;
        portset.type = Socket_Tcp;
        portset.family = Socket_Ip;
        portset.timeout = Run.limits.networkTimeout;
        portset.retry = 1;
        portset.protocol = Protocol_get(Protocol_DEFAULT);
        urlrequest = NULL;
}


/*
 * Reset the Proc set to default values
 */
static void reset_resourceset() {
        resourceset.resource_id = 0;
        resourceset.limit = 0;
        resourceset.action = NULL;
        resourceset.operator = Operator_Equal;
}


/*
 * Reset the Timestamp set to default values
 */
static void reset_timestampset() {
        timestampset.type = Timestamp_Default;
        timestampset.operator = Operator_Equal;
        timestampset.time = 0;
        timestampset.test_changes = false;
        timestampset.initialized = false;
        timestampset.action = NULL;
}


/*
 * Reset the ActionRate set to default values
 */
static void reset_actionrateset() {
        actionrateset.count = 0;
        actionrateset.cycle = 0;
        actionrateset.action = NULL;
}


/*
 * Reset the Size set to default values
 */
static void reset_sizeset() {
        sizeset.operator = Operator_Equal;
        sizeset.size = 0;
        sizeset.test_changes = false;
        sizeset.action = NULL;
}


/*
 * Reset the Uptime set to default values
 */
static void reset_uptimeset() {
        uptimeset.operator = Operator_Equal;
        uptimeset.uptime = 0;
        uptimeset.action = NULL;
}


static void reset_linkstatusset() {
        linkstatusset.action = NULL;
}


static void reset_linkspeedset() {
        linkspeedset.action = NULL;
}


static void reset_linksaturationset() {
        linksaturationset.limit = 0.;
        linksaturationset.operator = Operator_Equal;
        linksaturationset.action = NULL;
}


/*
 * Reset the Bandwidth set to default values
 */
static void reset_bandwidthset() {
        bandwidthset.operator = Operator_Equal;
        bandwidthset.limit = 0ULL;
        bandwidthset.action = NULL;
}


/*
 * Reset the Pid set to default values
 */
static void reset_pidset() {
        pidset.action = NULL;
}


/*
 * Reset the PPid set to default values
 */
static void reset_ppidset() {
        ppidset.action = NULL;
}


/*
 * Reset the Fsflag set to default values
 */
static void reset_fsflagset() {
        fsflagset.action = NULL;
}


/*
 * Reset the Nonexist set to default values
 */
static void reset_nonexistset() {
        nonexistset.action = NULL;
}


static void reset_existset() {
        existset.action = NULL;
}


/*
 * Reset the Checksum set to default values
 */
static void reset_checksumset() {
        checksumset.type         = Hash_Unknown;
        checksumset.test_changes = false;
        checksumset.action       = NULL;
        *checksumset.hash        = 0;
}


/*
 * Reset the Perm set to default values
 */
static void reset_permset() {
        permset.test_changes = false;
        permset.perm = 0;
        permset.action = NULL;
}


/*
 * Reset the Status set to default values
 */
static void reset_statusset() {
        statusset.initialized = false;
        statusset.return_value = 0;
        statusset.operator = Operator_Equal;
        statusset.action = NULL;
}


/*
 * Reset the Uid set to default values
 */
static void reset_uidset() {
        uidset.uid = 0;
        uidset.action = NULL;
}


/*
 * Reset the Gid set to default values
 */
static void reset_gidset() {
        gidset.gid = 0;
        gidset.action = NULL;
}


/*
 * Reset the Filesystem set to default values
 */
static void reset_filesystemset() {
        filesystemset.resource = 0;
        filesystemset.operator = Operator_Equal;
        filesystemset.limit_absolute = -1;
        filesystemset.limit_percent = -1.;
        filesystemset.action = NULL;
}


/*
 * Reset the ICMP set to default values
 */
static void reset_icmpset() {
        icmpset.type = ICMP_ECHO;
        icmpset.size = ICMP_SIZE;
        icmpset.count = ICMP_ATTEMPT_COUNT;
        icmpset.timeout = Run.limits.networkTimeout;
        icmpset.action = NULL;
}


/*
 * Reset the Rate set to default values
 */
static void reset_rateset(struct rate_t *r) {
        r->count = 1;
        r->cycles = 1;
}


/* ---------------------------------------------------------------- Checkers */


/*
 * Check for unique service name
 */
static void check_name(char *name) {
        ASSERT(name);

        if (Util_existService(name) || (current && IS(name, current->name)))
                yyerror2("Service name conflict, %s already defined", name);
        if (name && *name == '/')
                yyerror2("Service name '%s' must not start with '/' -- ", name);
}


/*
 * Permission statement semantic check
 */
static int check_perm(int perm) {
        int result;
        char *status;
        char buf[STRLEN];

        snprintf(buf, STRLEN, "%d", perm);

        result = (int)strtol(buf, &status, 8);

        if (*status != '\0' || result < 0 || result > 07777)
                yyerror2("Permission statements must have an octal value between 0 and 7777");

        return result;
}


/*
 * Check the dependency graph for errors
 * by doing a topological sort, thereby finding any cycles.
 * Assures that graph is a Directed Acyclic Graph (DAG).
 */
static void check_depend() {
        Service_T s;
        Service_T depends_on = NULL;
        Service_T* dlt = &depend_list; /* the current tail of it                                 */
        boolean_t done;                /* no unvisited nodes left?                               */
        boolean_t found_some;          /* last iteration found anything new ?                    */
        depend_list = NULL;            /* depend_list will be the topological sorted servicelist */

        do {
                done = true;
                found_some = false;
                for (s = servicelist; s; s = s->next) {
                        Dependant_T d;
                        if (s->visited)
                                continue;
                        done = false; // still unvisited nodes
                        depends_on = NULL;
                        for (d = s->dependantlist; d; d = d->next) {
                                Service_T dp = Util_getService(d->dependant);
                                if (! dp) {
                                        LogError("Depend service '%s' is not defined in the control file\n", d->dependant);
                                        exit(1);
                                }
                                if (! dp->visited) {
                                        depends_on = dp;
                                }
                        }

                        if (! depends_on) {
                                s->visited = true;
                                found_some = true;
                                *dlt = s;
                                dlt = &s->next_depend;
                        }
                }
        } while (found_some && ! done);

        if (! done) {
                ASSERT(depends_on);
                LogError("Found a depend loop in the control file involving the service '%s'\n", depends_on->name);
                exit(1);
        }

        ASSERT(depend_list);
        servicelist = depend_list;

        for (s = depend_list; s; s = s->next_depend)
                s->next = s->next_depend;
}


/*
 * Check if the executable exist
 */
static void check_exec(char *exec) {
        if (! File_exist(exec))
                yywarning2("Program does not exist:");
        else if (! File_isExecutable(exec))
                yywarning2("Program is not executable:");
}


/* Return a valid max forward value for SIP header */
static int verifyMaxForward(int mf) {
        if (mf >= 0 && mf <= 255)
                return mf;
        yywarning2("SIP max forward is outside the range [0..255]. Setting max forward to 70");
        return 70;
}


/* -------------------------------------------------------------------- Misc */


/*
 * Cleans up a hash string, tolower and remove byte separators
 */
static int cleanup_hash_string(char *hashstring) {
        int i = 0, j = 0;

        ASSERT(hashstring);

        while (hashstring[i]) {
                if (isxdigit((int)hashstring[i])) {
                        hashstring[j] = tolower((int)hashstring[i]);
                        j++;
                }
                i++;
        }
        hashstring[j] = 0;
        return j;
}


/* Return deep copy of the command */
static command_t copycommand(command_t source) {
        int i;
        command_t copy = NULL;

        NEW(copy);
        copy->length = source->length;
        copy->has_uid = source->has_uid;
        copy->uid = source->uid;
        copy->has_gid = source->has_gid;
        copy->gid = source->gid;
        copy->timeout = source->timeout;
        for (i = 0; i < copy->length; i++)
        copy->arg[i] = Str_dup(source->arg[i]);
        copy->arg[copy->length] = NULL;

        return copy;
}


static void _setPEM(char **store, char *path, const char *description, boolean_t isFile) {
        if (*store) {
                yyerror2("Duplicate %s", description);
        } else if (! File_exist(path)) {
                yyerror2("%s doesn't exist", description);
        } else if (! (isFile ? File_isFile(path) : File_isDirectory(path))) {
                yyerror2("%s is not a %s", description, isFile ? "file" : "directory");
        } else if (! File_isReadable(path)) {
                yyerror2("Cannot read %s", description);
        } else {
                sslset.flags = SSL_Enabled;
                *store = path;
        }
}


static void _setSSLOptions(SslOptions_T options) {
        options->allowSelfSigned = sslset.allowSelfSigned;
        options->CACertificateFile = sslset.CACertificateFile;
        options->CACertificatePath = sslset.CACertificatePath;
        options->checksum = sslset.checksum;
        options->checksumType = sslset.checksumType;
        options->ciphers = sslset.ciphers;
        options->clientpemfile = sslset.clientpemfile;
        options->flags = sslset.flags;
        options->pemfile = sslset.pemfile;
        options->verify = sslset.verify;
        options->version = sslset.version;
        reset_sslset();
}

